#pragma once
#include "titlemenu.h"

class CPreparedRTFText
{
public:
	CPreparedRTFText();
	~CPreparedRTFText();

	const CString& GetText();

	void AppendText(const CString& sText, COLORREF crColor = 0x1000000);

	void CheckTable(CString& sColor, CString& sTable, COLORREF crColor) const;

//protected:
	CString m_sText;
	CString m_sRtfHeader;
	long m_iMaxBufSize;
	long m_iTextEnd;
	CUIntArray m_aiLinkStart;
	CUIntArray m_aiLinkSize;
};

class CHTRichEditCtrl : public CRichEditCtrl
{
	DECLARE_DYNAMIC(CHTRichEditCtrl)

public:
	CHTRichEditCtrl();
	virtual ~CHTRichEditCtrl();

	void Init();
	void SetTitle(LPCTSTR pszTitle);
	void AddEntry(LPCTSTR pszMsg);
	void Reset();

	CString GetLastLogEntry();
	CString GetAllLogEntries();

	void AppendText(const CString& sText, COLORREF crColor = -1);
	void AppendHyperLink(const CString& sText, const CString& sTitle, const CString& sCommand, const CString& sDirectory);

	CString GetText() const;
	CString GetHtml();
	CString GetToolTip();
	CPreparedRTFText* GetHyperText();

	void SetHyperText(CPreparedRTFText*, bool bInvalidate = true);
	void UpdateSize();
	void SetFont(CFont* pFont, BOOL bRedraw = TRUE);
	CFont* GetFont() const;
	void ScrollToLastLine();
	bool m_bAutoScroll;

protected:
	CStringArray m_astrBuff;
	CString m_strTitle;
	bool m_bNoPaint;
	bool m_bInMenu;
	long m_iMaxBufSize;
	long m_iTextEnd;
	HCURSOR	m_hCursor;
	CPreparedRTFText* m_pPreparedText;

	void AddLine(LPCTSTR pszMsg, bool bLink = false, COLORREF crColor = -1);
	void SelectAllItems();
	void CopySelectedItems();
	void SaveLogToDisk();
	void SaveRtfToDisk();
	int GetMaxSize();
	void FlushBuffer();

	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);

	DECLARE_MESSAGE_MAP()
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg BOOL OnEnLink(NMHDR *pNMHDR, LRESULT *pResult);

private:
	static DWORD __stdcall MEditStreamOutCallback(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
	{
		CString sThisWrite;
		sThisWrite.GetBufferSetLength(cb);

		CString *psBuffer = (CString *)dwCookie;

		for (int i=0;i<cb;i++) {
			sThisWrite.SetAt(i,*(pbBuff+i));
		}

		*psBuffer += sThisWrite;

		*pcb = sThisWrite.GetLength();
		sThisWrite.ReleaseBuffer();
		return 0;
	}
};
