/*
the IP to country data is provided by http://ip-to-country.webhosting.info/

"IP2Country uses the IP-to-Country Database
 provided by WebHosting.Info (http://www.webhosting.info),
 available from http://ip-to-country.webhosting.info."

 */

/*

flags are from http://sf.net/projects/flags/

*/

// by Superlexx, based on IPFilter by Bouc7

#include "StdAfx.h"
#include "IP2Country.h"
#include "emule.h"
#include "otherfunctions.h"
#include "flag/resource.h"

//refresh list
#include "ServerList.h"
#include "ClientList.h"

//refresh server list ctrl
#include "emuleDlg.h"
#include "ServerWnd.h"
#include "ServerListCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define COUNTRY_FLAG_DLL_NAME		_T("countryflag.dll")

void FirstCharCap(CString *pstrTarget)
{
	pstrTarget->TrimRight(); //clean out the space at the end, prevent exception for index++
	if (!pstrTarget->IsEmpty())
	{
		pstrTarget->MakeLower();
		for (int iIdx = 0;;)
		{
			pstrTarget->SetAt(iIdx, pstrTarget->Mid(iIdx, 1).MakeUpper().GetAt(0));
			iIdx = pstrTarget->Find(_T(' '), iIdx) + 1;
			if (iIdx == 0)
				break;
		}
	}
}

CIP2Country::CIP2Country() : m_rbmapIpList(144)
{
	m_bEnableIP2Country = false;
	m_bEnableCountryFlag = false;

	if (g_eMuleApp.m_pGlobPrefs->GetShowCountryFlag())
	{
		AddDebugLogLine(false, _T("IP-to-Country Database provided by ") RGB_STEEL_BLUE_TXT _T("WEBH") RGB_DARK_ORANGE_TXT _T("O") RGB_STEEL_BLUE_TXT _T("STING") RGB_DARK_ORANGE_TXT _T(".INFO") RGB_DEFAULT_TXT _T(", available from http://ip-to-country.webhosting.info."));
		Load(false);
	}
}

CIP2Country::~CIP2Country()
{
	Unload(false);
}

void CIP2Country::Load(bool bReset)
{
	static const uint16	s_auResID[] =
	{
		IDI_COUNTRY_FLAG_AD, IDI_COUNTRY_FLAG_AE, IDI_COUNTRY_FLAG_AF, IDI_COUNTRY_FLAG_AG,
		IDI_COUNTRY_FLAG_AI, IDI_COUNTRY_FLAG_AL, IDI_COUNTRY_FLAG_AM, IDI_COUNTRY_FLAG_AN,
		IDI_COUNTRY_FLAG_AO, IDI_COUNTRY_FLAG_AR, IDI_COUNTRY_FLAG_AS, IDI_COUNTRY_FLAG_AT,
		IDI_COUNTRY_FLAG_AU, IDI_COUNTRY_FLAG_AW, IDI_COUNTRY_FLAG_AZ, IDI_COUNTRY_FLAG_BA,
		IDI_COUNTRY_FLAG_BB, IDI_COUNTRY_FLAG_BD, IDI_COUNTRY_FLAG_BE, IDI_COUNTRY_FLAG_BF,
		IDI_COUNTRY_FLAG_BG, IDI_COUNTRY_FLAG_BH, IDI_COUNTRY_FLAG_BI, IDI_COUNTRY_FLAG_BJ,
		IDI_COUNTRY_FLAG_BM, IDI_COUNTRY_FLAG_BN, IDI_COUNTRY_FLAG_BO, IDI_COUNTRY_FLAG_BR,
		IDI_COUNTRY_FLAG_BS, IDI_COUNTRY_FLAG_BT, IDI_COUNTRY_FLAG_BW, IDI_COUNTRY_FLAG_BY,
		IDI_COUNTRY_FLAG_BZ, IDI_COUNTRY_FLAG_CA, IDI_COUNTRY_FLAG_CC, IDI_COUNTRY_FLAG_CD,
		IDI_COUNTRY_FLAG_CF, IDI_COUNTRY_FLAG_CG, IDI_COUNTRY_FLAG_CH, IDI_COUNTRY_FLAG_CI,
		IDI_COUNTRY_FLAG_CK, IDI_COUNTRY_FLAG_CL, IDI_COUNTRY_FLAG_CM, IDI_COUNTRY_FLAG_CN,
		IDI_COUNTRY_FLAG_CO, IDI_COUNTRY_FLAG_CR, IDI_COUNTRY_FLAG_CU, IDI_COUNTRY_FLAG_CV,
		IDI_COUNTRY_FLAG_CX, IDI_COUNTRY_FLAG_CY, IDI_COUNTRY_FLAG_CZ, IDI_COUNTRY_FLAG_DE,
		IDI_COUNTRY_FLAG_DJ, IDI_COUNTRY_FLAG_DK, IDI_COUNTRY_FLAG_DM, IDI_COUNTRY_FLAG_DO,
		IDI_COUNTRY_FLAG_DZ, IDI_COUNTRY_FLAG_EC, IDI_COUNTRY_FLAG_EE, IDI_COUNTRY_FLAG_EG,
		IDI_COUNTRY_FLAG_EH, IDI_COUNTRY_FLAG_ER, IDI_COUNTRY_FLAG_ES, IDI_COUNTRY_FLAG_ET,
		IDI_COUNTRY_FLAG_FI, IDI_COUNTRY_FLAG_FJ, IDI_COUNTRY_FLAG_FK, IDI_COUNTRY_FLAG_FM,
		IDI_COUNTRY_FLAG_FO, IDI_COUNTRY_FLAG_FR, IDI_COUNTRY_FLAG_GA, IDI_COUNTRY_FLAG_GB,
		IDI_COUNTRY_FLAG_GD, IDI_COUNTRY_FLAG_GE, IDI_COUNTRY_FLAG_GG, IDI_COUNTRY_FLAG_GH,
		IDI_COUNTRY_FLAG_GI, IDI_COUNTRY_FLAG_GK, IDI_COUNTRY_FLAG_GL, IDI_COUNTRY_FLAG_GM,
		IDI_COUNTRY_FLAG_GN, IDI_COUNTRY_FLAG_GP, IDI_COUNTRY_FLAG_GQ, IDI_COUNTRY_FLAG_GR,
		IDI_COUNTRY_FLAG_GS, IDI_COUNTRY_FLAG_GT, IDI_COUNTRY_FLAG_GU, IDI_COUNTRY_FLAG_GW,
		IDI_COUNTRY_FLAG_GY, IDI_COUNTRY_FLAG_HK, IDI_COUNTRY_FLAG_HN, IDI_COUNTRY_FLAG_HR,
		IDI_COUNTRY_FLAG_HT, IDI_COUNTRY_FLAG_HU, IDI_COUNTRY_FLAG_ID, IDI_COUNTRY_FLAG_IE,
		IDI_COUNTRY_FLAG_IL, IDI_COUNTRY_FLAG_IM, IDI_COUNTRY_FLAG_IN, IDI_COUNTRY_FLAG_IO,
		IDI_COUNTRY_FLAG_IQ, IDI_COUNTRY_FLAG_IR, IDI_COUNTRY_FLAG_IS, IDI_COUNTRY_FLAG_IT,
		IDI_COUNTRY_FLAG_JE, IDI_COUNTRY_FLAG_JM, IDI_COUNTRY_FLAG_JO, IDI_COUNTRY_FLAG_JP,
		IDI_COUNTRY_FLAG_KE, IDI_COUNTRY_FLAG_KG, IDI_COUNTRY_FLAG_KH, IDI_COUNTRY_FLAG_KI,
		IDI_COUNTRY_FLAG_KM, IDI_COUNTRY_FLAG_KN, IDI_COUNTRY_FLAG_KP, IDI_COUNTRY_FLAG_KR,
		IDI_COUNTRY_FLAG_KW, IDI_COUNTRY_FLAG_KY, IDI_COUNTRY_FLAG_KZ, IDI_COUNTRY_FLAG_LA,
		IDI_COUNTRY_FLAG_LB, IDI_COUNTRY_FLAG_LC, IDI_COUNTRY_FLAG_LI, IDI_COUNTRY_FLAG_LK,
		IDI_COUNTRY_FLAG_LR, IDI_COUNTRY_FLAG_LS, IDI_COUNTRY_FLAG_LT, IDI_COUNTRY_FLAG_LU,
		IDI_COUNTRY_FLAG_LV, IDI_COUNTRY_FLAG_LY, IDI_COUNTRY_FLAG_MA, IDI_COUNTRY_FLAG_MC,
		IDI_COUNTRY_FLAG_MD, IDI_COUNTRY_FLAG_MG, IDI_COUNTRY_FLAG_MH, IDI_COUNTRY_FLAG_MK,
		IDI_COUNTRY_FLAG_ML, IDI_COUNTRY_FLAG_MM, IDI_COUNTRY_FLAG_MN, IDI_COUNTRY_FLAG_MO,
		IDI_COUNTRY_FLAG_MP, IDI_COUNTRY_FLAG_MQ, IDI_COUNTRY_FLAG_MR, IDI_COUNTRY_FLAG_MS,
		IDI_COUNTRY_FLAG_MT, IDI_COUNTRY_FLAG_MU, IDI_COUNTRY_FLAG_MV, IDI_COUNTRY_FLAG_MW,
		IDI_COUNTRY_FLAG_MX, IDI_COUNTRY_FLAG_MY, IDI_COUNTRY_FLAG_MZ, IDI_COUNTRY_FLAG_NA,
		IDI_COUNTRY_FLAG_NC, IDI_COUNTRY_FLAG_NE, IDI_COUNTRY_FLAG_NF, IDI_COUNTRY_FLAG_NG,
		IDI_COUNTRY_FLAG_NI, IDI_COUNTRY_FLAG_NL, IDI_COUNTRY_FLAG_NO, IDI_COUNTRY_FLAG_NP,
		IDI_COUNTRY_FLAG_NR, IDI_COUNTRY_FLAG_NU, IDI_COUNTRY_FLAG_NZ, IDI_COUNTRY_FLAG_OM,
		IDI_COUNTRY_FLAG_PA, IDI_COUNTRY_FLAG_PC, IDI_COUNTRY_FLAG_PE, IDI_COUNTRY_FLAG_PF,
		IDI_COUNTRY_FLAG_PG, IDI_COUNTRY_FLAG_PH, IDI_COUNTRY_FLAG_PK, IDI_COUNTRY_FLAG_PL,
		IDI_COUNTRY_FLAG_PM, IDI_COUNTRY_FLAG_PN, IDI_COUNTRY_FLAG_PR, IDI_COUNTRY_FLAG_PS,
		IDI_COUNTRY_FLAG_PT, IDI_COUNTRY_FLAG_PW, IDI_COUNTRY_FLAG_PY, IDI_COUNTRY_FLAG_QA,
		IDI_COUNTRY_FLAG_FR, IDI_COUNTRY_FLAG_RO, IDI_COUNTRY_FLAG_RU, IDI_COUNTRY_FLAG_RW,
		IDI_COUNTRY_FLAG_SA, IDI_COUNTRY_FLAG_SB, IDI_COUNTRY_FLAG_SC, IDI_COUNTRY_FLAG_SD,
		IDI_COUNTRY_FLAG_SE, IDI_COUNTRY_FLAG_SG, IDI_COUNTRY_FLAG_SH, IDI_COUNTRY_FLAG_SI,
		IDI_COUNTRY_FLAG_SK, IDI_COUNTRY_FLAG_SL, IDI_COUNTRY_FLAG_SM, IDI_COUNTRY_FLAG_SN,
		IDI_COUNTRY_FLAG_SO, IDI_COUNTRY_FLAG_SR, IDI_COUNTRY_FLAG_ST, IDI_COUNTRY_FLAG_SV,
		IDI_COUNTRY_FLAG_SY, IDI_COUNTRY_FLAG_SZ, IDI_COUNTRY_FLAG_TC, IDI_COUNTRY_FLAG_TD,
		IDI_COUNTRY_FLAG_TF, IDI_COUNTRY_FLAG_TG, IDI_COUNTRY_FLAG_TH, IDI_COUNTRY_FLAG_TJ,
		IDI_COUNTRY_FLAG_TK, IDI_COUNTRY_FLAG_TL, IDI_COUNTRY_FLAG_TM, IDI_COUNTRY_FLAG_TN,
		IDI_COUNTRY_FLAG_TO, IDI_COUNTRY_FLAG_TL, IDI_COUNTRY_FLAG_TR, IDI_COUNTRY_FLAG_TT,
		IDI_COUNTRY_FLAG_TV, IDI_COUNTRY_FLAG_TW, IDI_COUNTRY_FLAG_TZ, IDI_COUNTRY_FLAG_UA,
		IDI_COUNTRY_FLAG_UG, IDI_COUNTRY_FLAG_US, IDI_COUNTRY_FLAG_US, IDI_COUNTRY_FLAG_UY,
		IDI_COUNTRY_FLAG_UZ, IDI_COUNTRY_FLAG_VA, IDI_COUNTRY_FLAG_VC, IDI_COUNTRY_FLAG_VE,
		IDI_COUNTRY_FLAG_VG, IDI_COUNTRY_FLAG_VI, IDI_COUNTRY_FLAG_VN, IDI_COUNTRY_FLAG_VU,
		IDI_COUNTRY_FLAG_WF, IDI_COUNTRY_FLAG_WS, IDI_COUNTRY_FLAG_YE, IDI_COUNTRY_FLAG_YU,
		IDI_COUNTRY_FLAG_ZA, IDI_COUNTRY_FLAG_ZM, IDI_COUNTRY_FLAG_ZW, IDI_COUNTRY_FLAG_YU
	};
	static const TCHAR s_apcCountryID[][3] =
	{
		"AD", "AE", "AF", "AG", "AI", "AL", "AM", "AN", "AO", "AR", "AS", "AT", "AU", "AW", "AZ",
		"BA", "BB", "BD", "BE", "BF", "BG", "BH", "BI", "BJ", "BM", "BN", "BO", "BR", "BS", "BT",
		"BW", "BY", "BZ", "CA", "CC", "CD", "CF", "CG", "CH", "CI", "CK", "CL", "CM", "CN", "CO",
		"CR", "CU", "CV", "CX", "CY", "CZ", "DE", "DJ", "DK", "DM", "DO", "DZ", "EC", "EE", "EG",
		"EH", "ER", "ES", "ET", "FI", "FJ", "FK", "FM", "FO", "FR", "GA", "GB", "GD", "GE", "GG",
		"GH", "GI", "GK", "GL", "GM", "GN", "GP", "GQ", "GR", "GS", "GT", "GU", "GW", "GY", "HK",
		"HN", "HR", "HT", "HU", "ID", "IE", "IL", "IM", "IN", "IO", "IQ", "IR", "IS", "IT", "JE",
		"JM", "JO", "JP", "KE", "KG", "KH", "KI", "KM", "KN", "KP", "KR", "KW", "KY", "KZ", "LA",
		"LB", "LC", "LI", "LK", "LR", "LS", "LT", "LU", "LV", "LY", "MA", "MC", "MD", "MG", "MH",
		"MK", "ML", "MM", "MN", "MO", "MP", "MQ", "MR", "MS", "MT", "MU", "MV", "MW", "MX", "MY",
		"MZ", "NA", "NC", "NE", "NF", "NG", "NI", "NL", "NO", "NP", "NR", "NU", "NZ", "OM", "PA",
		"PC", "PE", "PF", "PG", "PH", "PK", "PL", "PM", "PN", "PR", "PS", "PT", "PW", "PY", "QA",
		"RE", "RO", "RU", "RW", "SA", "SB", "SC", "SD", "SE", "SG", "SH", "SI", "SK", "SL", "SM",
		"SN", "SO", "SR", "ST", "SV", "SY", "SZ", "TC", "TD", "TF", "TG", "TH", "TJ", "TK", "TL",
		"TM", "TN", "TO", "TP", "TR", "TT", "TV", "TW", "TZ", "UA", "UG", "UM", "US", "UY", "UZ",
		"VA", "VC", "VE", "VG", "VI", "VN", "VU", "WF", "WS", "YE", "YU", "ZA", "ZM", "ZW", "CS"
	};

//	Protect from consecutive loadings
	if (m_bEnableIP2Country)
		return;

//	Temporary resource just for fast lookup
	CRBMap<CString, uint32>	rbmapCountryIDtoFlagIndex(ELEMENT_COUNT(s_auResID));
	CRBMap<CString, uint32>::CPair	*pPair;

	for (unsigned ui = 0; ui < ELEMENT_COUNT(s_auResID); ui++)
	{
		rbmapCountryIDtoFlagIndex.SetAt(CString(reinterpret_cast<const TCHAR*>(&s_apcCountryID[ui])), s_auResID[ui]);
	}

	FILE	*pReadFile;
	CString	strIP2CountryCSVfile = g_eMuleApp.m_pGlobPrefs->GetConfigDir();

	strIP2CountryCSVfile += _T("ip-to-country.csv");

	if ((pReadFile = fopen(strIP2CountryCSVfile, _T("r"))) != NULL)
	{
		char			acBuffer[512];
		CString			strBuffer, strTemp[5];
		unsigned		uiLineNum = 0;
		HINSTANCE		hCountryFlagDll;
		IPRange_Struct	ipRangeData;
		CStringList		countryNameTempList;
		uint32			dwIdx;
		HICON				hIcon;
		bool			bEnableCountryFlag, bEnableIP2Country;

		bEnableCountryFlag = true;
		if ((hCountryFlagDll = ::LoadLibrary(COUNTRY_FLAG_DLL_NAME)) == NULL)
		{
			bEnableCountryFlag = false;
			AddLogLine(false, RGB_LOG_ERROR_TXT _T("CountryFlag disabled, failed to load ") COUNTRY_FLAG_DLL_NAME);
		}
		else
		{
			m_lstCountryFlagImage.Create(18, 12, ILC_COLOR32 | ILC_MASK, 200, 1);
			m_lstCountryFlagImage.SetBkColor(CLR_NONE);

		//	Load flag for unknown country
			hIcon = reinterpret_cast<HICON>(::LoadImage(hCountryFlagDll, MAKEINTRESOURCE(IDI_COUNTRY_FLAG_NOFLAG), IMAGE_ICON, 0, 0, 0));
			if (hIcon == NULL)
			{
				bEnableCountryFlag = false;
				AddLogLine(false, RGB_LOG_ERROR_TXT _T("Invalid ResID, maybe upgrade is required ") COUNTRY_FLAG_DLL_NAME);
			}
			m_lstCountryFlagImage.Add(hIcon);
			::DestroyIcon(hIcon);
		}
	//	Add unknown country name
		countryNameTempList.AddTail(_T("Not Applicable"));

		bEnableIP2Country = true;
		while (!feof(pReadFile))
		{
			if (fgets(acBuffer, sizeof(acBuffer), pReadFile) == 0)
				break;
			strBuffer = acBuffer;
			uiLineNum++;
			/*
				http://ip-to-country.webhosting.info/node/view/54

				This is a sample of how the CSV file is structured:

				"0033996344","0033996351","GB","GBR","UNITED KINGDOM"
				"0050331648","0083886079","US","USA","UNITED STATES"
				"0094585424","0094585439","SE","SWE","SWEDEN"

				FIELD  			DATA TYPE		  	FIELD DESCRIPTION
				IP_FROM 		NUMERICAL (DOUBLE) 	Beginning of IP address range.
				IP_TO			NUMERICAL (DOUBLE) 	Ending of IP address range.
				COUNTRY_CODE2 	CHAR(2)				Two-character country code based on ISO 3166.
				COUNTRY_CODE3 	CHAR(3)				Three-character country code based on ISO 3166.
				COUNTRY_NAME 	VARCHAR(50) 		Country name based on ISO 3166
			*/
			strBuffer.TrimRight(_T('\n'));
			strBuffer.Remove(_T('"')); // get rid of the " signs

			int iCurPos = 0;

			for (unsigned ui = 0; ui < ELEMENT_COUNT(strTemp); ui++)
			{
				strTemp[ui] = strBuffer.Tokenize(_T(","), iCurPos);
				if (strTemp[ui].IsEmpty())
				{
					bEnableIP2Country = false;
					AddDebugLogLine(false, RGB_LOG_ERROR_TXT _T("%s: %s error (line: %u)"), __FUNCTION__, strIP2CountryCSVfile, uiLineNum);
					break;
				}
			}
			if (!bEnableIP2Country)
				break;
			
			ipRangeData.dwIPend = atoi(strTemp[1]);
			ipRangeData.uIndex = NO_COUNTRY_INFO;

			pPair = rbmapCountryIDtoFlagIndex.Lookup(strTemp[2]);	// short country name
			if (pPair != NULL)
			{
				if ((dwIdx = (pPair->m_value >> 16)) == NO_COUNTRY_INFO)
				{
				//	Country name and flag weren't added yet

					if (bEnableCountryFlag)
					{
						hIcon = reinterpret_cast<HICON>(::LoadImage(hCountryFlagDll, MAKEINTRESOURCE(pPair->m_value & 0xffff), IMAGE_ICON, 0, 0, 0));
						if (hIcon == NULL)
						{
							bEnableCountryFlag = false;
							AddLogLine(false, RGB_LOG_ERROR_TXT _T("Invalid ResID, maybe upgrade is required ") COUNTRY_FLAG_DLL_NAME);
							break;
						}
						m_lstCountryFlagImage.Add(hIcon);
						::DestroyIcon(hIcon);
					}
				//	Capitalize words in country name
					FirstCharCap(&strTemp[4]);

					dwIdx = countryNameTempList.GetCount();
					countryNameTempList.AddTail(strTemp[4]);

				//	Associate flag/country index with short country name
					pPair->m_value |= (dwIdx << 16);
				}
				ipRangeData.uIndex = static_cast<uint16>(dwIdx);
			}
			else
			{
				AddDebugLogLine( false, RGB_LOG_WARNING_TXT _T("Unsupported country name found %s/%s (line: %u)"),
										strTemp[2], strTemp[4], uiLineNum );
			}
		//	Start of IP range is a key
			m_rbmapIpList.SetAt(atoi(strTemp[0]), ipRangeData);
		}	//while
		fclose(pReadFile);

		if (m_rbmapIpList.IsEmpty())
			bEnableIP2Country = false;

		if (!bEnableIP2Country)
		{
			bEnableCountryFlag = false;
			m_rbmapIpList.RemoveAll();
		}
		else
		{
		//	Allocate array memory
			m_astrCountryName.SetSize(countryNameTempList.GetCount());

			POSITION pos;

			for (pos = countryNameTempList.GetHeadPosition(), dwIdx = 0; pos != NULL; dwIdx++)
			{
				m_astrCountryName[dwIdx] = countryNameTempList.GetNext(pos);
			}
			m_bEnableIP2Country = bEnableIP2Country;
			m_bEnableCountryFlag = bEnableCountryFlag;

			if (bReset)
				Reset();
		}
		if (hCountryFlagDll != NULL)
		{
			if (!bEnableCountryFlag)
			{
			//	Destory image list
				m_lstCountryFlagImage.DeleteImageList();
			}
			::FreeLibrary(hCountryFlagDll);
		}
	}
	else
	{
		AddLogLine(false, RGB_LOG_ERROR_TXT _T("Failed to load %s"), strIP2CountryCSVfile);
	}
}

void CIP2Country::Unload(bool bReset)
{
//	Protect from consecutive unloadings
	if (!m_bEnableIP2Country)
		return;

	m_bEnableIP2Country = false;
	m_bEnableCountryFlag = false;

	if (bReset)
		Reset();

//	Release resources	
	m_astrCountryName.RemoveAll();
	m_rbmapIpList.RemoveAll();
//	Destory image list
	m_lstCountryFlagImage.DeleteImageList();
}

void CIP2Country::Reset()
{
	g_eMuleApp.m_pServerList->ResetIP2Country();
	g_eMuleApp.m_pClientList->ResetIP2Country();
}

void CIP2Country::Refresh()
{
	g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.RefreshAllServer();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	GetCountryFromIP() obtains country information based on IP.
//		Params:
//			dwClientIP - IP address.
//		Return:
//			index of Country Name and flag.
uint16 CIP2Country::GetCountryFromIP(uint32 dwClientIP)
{
	if (m_bEnableIP2Country && (dwClientIP != 0))
	{
		dwClientIP = htonl(dwClientIP);

		POSITION pos = m_rbmapIpList.FindFirstKeyAfter(dwClientIP);

		if (pos == NULL)
			pos = m_rbmapIpList.GetTailPosition();
		else
			m_rbmapIpList.GetPrev(pos);

		while(pos)
		{
			const CRBMap<uint32, IPRange_Struct>::CPair *pPair = m_rbmapIpList.GetPrev(pos);

			if (dwClientIP > pPair->m_value.dwIPend)
				break;
			if (dwClientIP >= pPair->m_key)
				return pPair->m_value.uIndex;
		}
	}
	return NO_COUNTRY_INFO;
}

CString CIP2Country::GetCountryNameByIndex(uint16 uCountryIndex)
{
	return (uCountryIndex < m_astrCountryName.GetSize()) ? m_astrCountryName[uCountryIndex] : CString(_T(""));
}
