// PPgFiles.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgFiles.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgFiles dialog

IMPLEMENT_DYNAMIC(CPPgFiles, CPropertyPage)
CPPgFiles::CPPgFiles()
	: CPropertyPage(CPPgFiles::IDD)
	, dapEnable(FALSE)
	, uap(FALSE)
	, startPaused(FALSE)
	, startPausedOnComplete(FALSE)
	, resumeOtherCat(FALSE)
	, seeShare(0)
	, hashPriority(0)
	, fileBufferSize(0)
{
}

CPPgFiles::~CPPgFiles()
{
}

void CPPgFiles::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_DAP_ENABLE, dapEnable);
	DDX_Check(pDX, IDC_UAP, uap);
	DDX_Check(pDX, IDC_START_PAUSED, startPaused);
	DDX_Check(pDX, IDC_START_PAUSED_ON_COMPLETE, startPausedOnComplete);
	DDX_Check(pDX, IDC_RESUME_OTHER_CAT, resumeOtherCat);
	DDX_Control(pDX, IDC_FILEBUFFERSIZE, fileBufferSizeSlider);
	DDX_Control(pDX, IDC_SLOWCOMPLETE_BLOCK, m_fileCopySizeSlider);
	DDX_Control(pDX, IDC_AP_HIGH, apHighEdit);
	DDX_Control(pDX, IDC_AP_LOW, apLowEdit);
	DDX_Control(pDX, IDC_SEESHARE1, seeEverybodyRadio);
	DDX_Control(pDX, IDC_SEESHARE2, seeFriendRadio);
	DDX_Control(pDX, IDC_SEESHARE3, seeNooneRadio);
	DDX_Control(pDX, IDC_HASHPRIO_STANDARD, hashStandardRadio);
	DDX_Control(pDX, IDC_HASHPRIO_LOWER, hashLowerRadio);
	DDX_Control(pDX, IDC_HASHPRIO_IDLE, hashIdleRadio);
	DDX_Control(pDX, IDC_DAP_ENABLE, dapEnableCheck);
	DDX_Control(pDX, IDC_UAP, uapCheck);
	DDX_Control(pDX, IDC_START_PAUSED, startPausedCheck);
	DDX_Control(pDX, IDC_START_PAUSED_ON_COMPLETE, startPausedOnCompleteCheck);
	DDX_Control(pDX, IDC_RESUME_OTHER_CAT, resumeOtherCatCheck);
	DDX_Text(pDX, IDC_FILEBUFFERSIZE_LBL, fileBufferSizeDesc);
	DDX_Text(pDX, IDC_SEEMYSHARE_FRM, seeMyShareDesc);
	DDX_Text(pDX, IDC_AP_GRP, apGrpDesc);
	DDX_Text(pDX, IDC_AP_HIGH_LBL, apHighDesc);
	DDX_Text(pDX, IDC_AP_LOW_LBL, apLowDesc);
	DDX_Text(pDX, IDC_AP_SOURCES1, apSources1Desc);
	DDX_Text(pDX, IDC_AP_SOURCES2, apSources2Desc);
	DDX_Text(pDX, IDC_SLOWCOMPLETE, m_strCopyBufferDesc);
	DDX_Text(pDX, IDC_HASHING_FRM, hashingFrmDesc);
	DDX_Text(pDX, IDC_AP_HIGH, apHigh);
	DDX_Text(pDX, IDC_AP_LOW, apLow);
	DDX_Radio(pDX, IDC_SEESHARE1, seeShare);
	DDX_Radio(pDX, IDC_HASHPRIO_STANDARD, hashPriority);
	DDX_Slider(pDX, IDC_FILEBUFFERSIZE, fileBufferSize);
	DDX_Slider(pDX, IDC_SLOWCOMPLETE_BLOCK, m_iCopyBufferSz);
}

BEGIN_MESSAGE_MAP(CPPgFiles, CPropertyPage)
	ON_BN_CLICKED(IDC_SEESHARE1, OnSettingsChange)
	ON_BN_CLICKED(IDC_SEESHARE2, OnSettingsChange)
	ON_BN_CLICKED(IDC_SEESHARE3, OnSettingsChange)
	ON_BN_CLICKED(IDC_HASHPRIO_STANDARD, OnSettingsChange)
	ON_BN_CLICKED(IDC_HASHPRIO_LOWER, OnSettingsChange)
	ON_BN_CLICKED(IDC_HASHPRIO_IDLE, OnSettingsChange)
	ON_EN_CHANGE(IDC_AP_HIGH, OnSettingsChange)
	ON_EN_CHANGE(IDC_AP_LOW, OnSettingsChange)
	ON_BN_CLICKED(IDC_UAP, OnSettingsChange)
	ON_BN_CLICKED(IDC_DAP_ENABLE, OnBnClickedDAP)
	ON_BN_CLICKED(IDC_START_PAUSED, OnSettingsChange)
	ON_BN_CLICKED(IDC_START_PAUSED_ON_COMPLETE, OnBnClickedStartPaused)
	ON_BN_CLICKED(IDC_RESUME_OTHER_CAT, OnSettingsChange)
	ON_WM_HSCROLL()
END_MESSAGE_MAP()

BOOL CPPgFiles::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgFiles::LoadSettings(void)
{
	switch(m_pPrefs->CanSeeShares())
	{
		case SEE_SHARE_EVERYBODY:
			seeShare = 0;
			break;
		case SEE_SHARE_FRIENDS:
			seeShare = 1;
			break;
		case SEE_SHARE_NOONE:
		default:
			seeShare = 2;
			break;
	}

	switch(m_pPrefs->GetHashingPriority())
	{
		case HASH_PRIORITY_IDLE:
			hashPriority = 2;
			break;
		case HASH_PRIORITY_LOWER:
			hashPriority = 1;
			break;
		case HASH_PRIORITY_STANDARD:
		default:
			hashPriority = 0;
			break;
	}

	uap = m_pPrefs->IsUAPEnabled();

	dapEnable = m_pPrefs->IsDAPEnabled();

	apHigh.Format(_T("%u"), m_pPrefs->PriorityHigh());
	apLow.Format(_T("%u"), m_pPrefs->PriorityLow());

	startPaused = m_pPrefs->StartDownloadPaused();
	startPausedOnComplete = m_pPrefs->DownloadPausedOnComplete();
	resumeOtherCat = m_pPrefs->IsResumeOtherCat();

	fileBufferSizeSlider.SetRange(1, 100, true);
	fileBufferSize = m_pPrefs->GetFileBufferSize();

//	Scale step is 4 KB
	m_fileCopySizeSlider.SetRange(8 / 4, 256 / 4, true);
	m_iCopyBufferSz = static_cast<unsigned>(m_pPrefs->SlowCompleteBlockSize() / 4);

	UpdateData(FALSE);

	OnBnClickedDAP();
	OnBnClickedStartPaused();

	SetModified(FALSE);
}

BOOL CPPgFiles::OnApply()
{
	if(m_bModified)
	{
		UpdateData(TRUE);

		switch(seeShare)
		{
			case 0:
				m_pPrefs->SetCanSeeShares(SEE_SHARE_EVERYBODY);
				break;
			case 1:
				m_pPrefs->SetCanSeeShares(SEE_SHARE_FRIENDS);
				break;
			case 2:
			default:
				m_pPrefs->SetCanSeeShares(SEE_SHARE_NOONE);
				break;
		}

		switch(hashPriority)
		{
			case 2:
				m_pPrefs->SetHashingPriority(HASH_PRIORITY_IDLE);
				g_eMuleApp.m_fileHashControl.SetProcessingPriority(ePIdle);
				break;
			case 1:
				m_pPrefs->SetHashingPriority(HASH_PRIORITY_LOWER);
				g_eMuleApp.m_fileHashControl.SetProcessingPriority(ePLower);
				break;
			case 0:
			default:
				m_pPrefs->SetHashingPriority(HASH_PRIORITY_STANDARD);
				g_eMuleApp.m_fileHashControl.SetProcessingPriority(ePStandard);
				break;
		}

		m_pPrefs->SetUAPEnabled(uap);
		m_pPrefs->SetDAPEnabled(dapEnable);
		m_pPrefs->SetStartDownloadPaused(startPaused);
		m_pPrefs->SetDownloadPausedOnComplete(startPausedOnComplete);
		m_pPrefs->SetResumeOtherCat(resumeOtherCat);
		m_pPrefs->SetPriorityHigh(_tstoi(apHigh));
		m_pPrefs->SetPriorityLow(_tstoi(apLow));

		if(m_pPrefs->PriorityLow() < m_pPrefs->PriorityHigh())
		{
			m_pPrefs->SetPriorityLow(m_pPrefs->PriorityHigh() * 2);
			apLow.Format(_T("%u"), m_pPrefs->PriorityLow());
		}

		m_pPrefs->SetFileBufferSize(fileBufferSize);
		m_pPrefs->SetSlowCompleteBlockSize(static_cast<unsigned>(m_iCopyBufferSz) * 4u);

		UpdateData(FALSE);
		SetModified(FALSE);
	}
	return CPropertyPage::OnApply();
}

void CPPgFiles::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_FILES));
		seeMyShareDesc = GetResString(IDS_PW_SHARE);
		seeEverybodyRadio.SetWindowText(GetResString(IDS_PW_EVER));
		seeFriendRadio.SetWindowText(GetResString(IDS_PW_FRIENDS));
		seeNooneRadio.SetWindowText(GetResString(IDS_PW_NOONE));
		apGrpDesc = GetResString(IDS_AP_GRP);
		apHighDesc = GetResString(IDS_AP_HIGH_LBL);
		apLowDesc = GetResString(IDS_AP_LOW_LBL);
		dapEnableCheck.SetWindowText(GetResString(IDS_ENABLED));
		uapCheck.SetWindowText(GetResString(IDS_UAP));
		startPausedCheck.SetWindowText(GetResString(IDS_START_PAUSED));
		startPausedOnCompleteCheck.SetWindowText(GetResString(IDS_START_PAUSED_ON_COMPLETE));
		resumeOtherCatCheck.SetWindowText(GetResString(IDS_RESUME_OTHER_CAT));
		apSources1Desc = GetResString(IDS_SOURCES_PF_FILES);
		apSources2Desc = GetResString(IDS_SOURCES_PF_FILES);
		hashingFrmDesc = GetResString(IDS_HASHING_FRM);
		hashStandardRadio.SetWindowText(GetResString(IDS_HASHPRIO_STANDARD));
		hashLowerRadio.SetWindowText(GetResString(IDS_HASHPRIO_LOWER));
		hashIdleRadio.SetWindowText(GetResString(IDS_HASHPRIO_IDLE));
		fileBufferSizeDesc.Format(GetResString(IDS_FILEBUFFERSIZE), fileBufferSize*30000);
		m_strCopyBufferDesc.Format(GetResString(IDS_SLOWCOMPLETE), static_cast<unsigned>(m_iCopyBufferSz) * 4u);
		UpdateData(FALSE);
	}
}

void CPPgFiles::OnBnClickedDAP()
{
	UpdateData(TRUE);
	apHighEdit.EnableWindow(dapEnable);
	apLowEdit.EnableWindow(dapEnable);

	SetModified();
}

void CPPgFiles::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	if (pScrollBar == (CScrollBar*) &fileBufferSizeSlider)
	{
		SetModified(TRUE);
		UpdateData(TRUE);
		fileBufferSizeDesc.Format(GetResString(IDS_FILEBUFFERSIZE), fileBufferSize * 30000);
		UpdateData(FALSE);
	}
	else if (pScrollBar == (CScrollBar*)&m_fileCopySizeSlider)
	{
		SetModified(TRUE);
		UpdateData(TRUE);
		m_strCopyBufferDesc.Format(GetResString(IDS_SLOWCOMPLETE), static_cast<unsigned>(m_iCopyBufferSz) * 4u);
		UpdateData(FALSE);
	}
}

void CPPgFiles::OnBnClickedStartPaused()
{
	UpdateData(TRUE);

	resumeOtherCatCheck.EnableWindow(startPausedOnComplete);

	SetModified();
}
