// PPgPartTraffic.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgPartTraffic.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CPPgPartTraffic dialog

IMPLEMENT_DYNAMIC(CPPgPartTraffic, CPropertyPage)

CPPgPartTraffic::CPPgPartTraffic()
	: CPropertyPage(CPPgPartTraffic::IDD)
	, uploadBarStyle(0)
	, uploadBarColor(0)
	, displayPartTraffic(FALSE)
	, upBarStDesc(_T(""))
	, upBarClDesc(_T(""))
{
}

CPPgPartTraffic::~CPPgPartTraffic()
{
}

void CPPgPartTraffic::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Radio(pDX, IDC_UPBARST1, uploadBarStyle);
	DDX_Radio(pDX, IDC_UPBARCL1, uploadBarColor);
	DDX_Check(pDX, IDC_PT_USEIT, displayPartTraffic);
	DDX_Control(pDX, IDC_PT_USEIT, displayPartTrafficCheck);
	DDX_Control(pDX, IDC_UPBARST1, upBarSt1Radio);
	DDX_Control(pDX, IDC_UPBARST2, upBarSt2Radio);
	DDX_Control(pDX, IDC_UPBARST3, upBarSt3Radio);	
	DDX_Control(pDX, IDC_UPBARST4, upBarSt4Radio);
	DDX_Control(pDX, IDC_UPBARCL1, upBarCl1Radio);
	DDX_Control(pDX, IDC_UPBARCL2, upBarCl2Radio);
	DDX_Control(pDX, IDC_UPBARCL3, upBarCl3Radio);
	DDX_Control(pDX, IDC_UPBARCL4, upBarCl4Radio);
	DDX_Text(pDX, IDC_UPBARST, upBarStDesc);
	DDX_Text(pDX, IDC_UPBARCL, upBarClDesc);
}

BEGIN_MESSAGE_MAP(CPPgPartTraffic, CPropertyPage)
	ON_BN_CLICKED(IDC_UPBARST1, OnBnClickedUpbarst1)
	ON_BN_CLICKED(IDC_UPBARST2, OnBnClickedUpbarst2)
	ON_BN_CLICKED(IDC_UPBARST3, OnBnClickedUpbarst3)
	ON_BN_CLICKED(IDC_UPBARST4, OnBnClickedUpbarst4)
	ON_BN_CLICKED(IDC_UPBARCL1, OnBnClickedUpbarcl1)
	ON_BN_CLICKED(IDC_UPBARCL2, OnBnClickedUpbarcl2)
	ON_BN_CLICKED(IDC_UPBARCL3, OnBnClickedUpbarcl3)
	ON_BN_CLICKED(IDC_UPBARCL4, OnBnClickedUpbarcl4)
	ON_BN_CLICKED(IDC_PT_USEIT, OnBnClickedPtUseit)
END_MESSAGE_MAP()

BOOL CPPgPartTraffic::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgPartTraffic::LoadSettings(void)
{
	if(::IsWindow(m_hWnd))
	{
		displayPartTraffic = m_pPrefs->DoUsePT();

		uploadBarStyle = m_pPrefs->GetUpbarStyle();
		uploadBarColor = m_pPrefs->GetUpbarColor();

		UpdateData(FALSE);

		OnBnClickedPtUseit();

		SetModified(FALSE);
	}
}

BOOL CPPgPartTraffic::OnApply()
{
	if(m_bModified)
	{
		UpdateData(TRUE);

		if(!displayPartTraffic==m_pPrefs->DoUsePT())
		{
			m_pPrefs->SetUsePT(displayPartTraffic);
			if(m_pPrefs->DoUsePT())
				g_eMuleApp.m_pdlgEmule->m_wndSharedFiles.m_ctlSharedFilesList.ShowColumn(9);
			else
				g_eMuleApp.m_pdlgEmule->m_wndSharedFiles.m_ctlSharedFilesList.HideColumn(9);
		}

		m_pPrefs->SetUpbarStyle(uploadBarStyle);
		m_pPrefs->SetUpbarColor(uploadBarColor);
		
		OnBnClickedPtUseit();
		
		g_eMuleApp.m_pdlgEmule->m_wndSharedFiles.m_ctlSharedFilesList.SetDisplay(m_pPrefs->GetUpbarStyle(), true);
		g_eMuleApp.m_pdlgEmule->m_wndSharedFiles.m_ctlSharedFilesList.SetColoring(m_pPrefs->GetUpbarColor());

		LoadSettings();
		SetModified(FALSE);
	}
	return CPropertyPage::OnApply();
}

void CPPgPartTraffic::Localize(void)
{	
	if(::IsWindow(m_hWnd))
	{
		displayPartTrafficCheck.SetWindowText(GetResString(IDS_PT_USEIT));
		upBarStDesc = GetResString(IDS_UPBARST);
		upBarSt1Radio.SetWindowText(GetResString(IDS_UPBARST1));
		upBarSt2Radio.SetWindowText(GetResString(IDS_UPBARST2));
		upBarSt3Radio.SetWindowText(GetResString(IDS_UPBARST3));		
		upBarClDesc = GetResString(IDS_UPBARCL);
		upBarCl1Radio.SetWindowText(GetResString(IDS_UPBARCL1));
		upBarCl2Radio.SetWindowText(GetResString(IDS_UPBARCL2));
		upBarCl3Radio.SetWindowText(GetResString(IDS_UPBARCL3));
		upBarCl4Radio.SetWindowText(GetResString(IDS_UPBARCL4));

		UpdateData(FALSE);
	}
}

void CPPgPartTraffic::OnBnClickedPtUseit()
{
	UpdateData(TRUE);

	upBarSt1Radio.EnableWindow(displayPartTraffic);
	upBarSt2Radio.EnableWindow(displayPartTraffic);
	upBarSt3Radio.EnableWindow(displayPartTraffic);
	upBarSt4Radio.EnableWindow(displayPartTraffic);
	upBarCl1Radio.EnableWindow(displayPartTraffic);
	upBarCl2Radio.EnableWindow(displayPartTraffic);
	upBarCl3Radio.EnableWindow(displayPartTraffic);
	upBarCl4Radio.EnableWindow(displayPartTraffic);

	SetModified();
}
