// PPgSecurity.cpp
//

#include "stdafx.h"
#include "eMule.h"
#include "PPgSecurity.h"
#include "AddBuddy.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////////////////////
IMPLEMENT_DYNAMIC(CPPgSecurity, CPropertyPage)

BEGIN_MESSAGE_MAP(CPPgSecurity, CPropertyPage)
	ON_EN_CHANGE(IDC_FILTERLEVEL_EDIT, OnSettingsChange)
	ON_EN_CHANGE(IDC_IPFILTER_URL_EDIT, OnSettingsChange)
	ON_BN_CLICKED(IDC_FILTERCLIENTS_CHECK, OnSettingsChange)
	ON_BN_CLICKED(IDC_FILTERSERVERS_CHECK, OnSettingsChange)
	ON_BN_CLICKED(IDC_FILESCAN_FILTER_CHECK, OnSettingsChange)
	ON_BN_CLICKED(IDC_IPFILTER_UPDATE_BUTTON, OnBnClickedIpfilterUpdateButton)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_IPFILTER_UPDATEONSTART_CHECK, OnBnClickedIpfilterUpdateonstartCheck)
	ON_BN_CLICKED(IDC_AV_SCANCOMPLETED_CHECK, OnSettingsChange)
	ON_BN_CLICKED(IDC_AV_ENABLED_CHECK, OnBnClickedAvEnable)
	ON_BN_CLICKED(IDC_AV_BROWSE, OnBnClickedAvbrowse)
	ON_EN_CHANGE(IDC_AV_PARAMS_EDIT, OnSettingsChange)
	ON_EN_CHANGE(IDC_AV_PATH_EDIT, OnSettingsChange)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////////////////////
CPPgSecurity::CPPgSecurity()
	: CPropertyPage(CPPgSecurity::IDD)
	, m_strIPFilterGroupBox(_T(""))
	, m_strFilterLevelStatic(_T(""))
	, m_strIPFilterURLStatic(_T(""))
	, m_strIPFilterURLEdit(_T(""))
	, m_bFilterClientsCheck(FALSE)
	, m_bFilterServersCheck(FALSE)
	, m_bIPFilterUpdateOnStartCheck(FALSE)
	, m_bFileScanFilterCheck(FALSE)
	, m_strUpdateDaysStatic(_T(""))
	, m_strAVGroupBox(_T(""))
	, m_strAVParamsStatic(_T(""))
	, m_strAVPathStatic(_T(""))
	, m_strAVParams(_T(""))
	, m_strAVPath(_T(""))
	, m_bAVEnabledCheck(FALSE)
	, m_bAVScanCompletedCheck(FALSE)
{
}
/////////////////////////////////////////////////////////////////////////////////////////////
CPPgSecurity::~CPPgSecurity()
{
}
/////////////////////////////////////////////////////////////////////////////////////////////
void CPPgSecurity::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_IPFILTER_GROUPBOX, m_strIPFilterGroupBox);
	DDX_Text(pDX, IDC_FILTERLEVEL_STATIC, m_strFilterLevelStatic);
	DDX_Text(pDX, IDC_IPFILTER_URL_STATIC, m_strIPFilterURLStatic);
	DDX_Text(pDX, IDC_IPFILTER_URL_EDIT, m_strIPFilterURLEdit);
	DDX_Check(pDX, IDC_FILTERCLIENTS_CHECK, m_bFilterClientsCheck);
	DDX_Check(pDX, IDC_FILTERSERVERS_CHECK, m_bFilterServersCheck);
	DDX_Check(pDX, IDC_IPFILTER_UPDATEONSTART_CHECK, m_bIPFilterUpdateOnStartCheck);
	DDX_Control(pDX, IDC_FILTERCLIENTS_CHECK, m_FilterClientsCheck);
	DDX_Control(pDX, IDC_FILTERSERVERS_CHECK, m_FilterServersCheck);
	DDX_Control(pDX, IDC_IPFILTER_UPDATEONSTART_CHECK, m_IPFilterUpdateOnStartCheck);
	DDX_Check(pDX, IDC_FILESCAN_FILTER_CHECK, m_bFileScanFilterCheck);
	DDX_Control(pDX, IDC_FILESCAN_FILTER_CHECK, m_FileScanFilterCheck);
	DDX_Control(pDX, IDC_IPFILTER_UPDATE_BUTTON, m_IPFilterUpdateButton);
	DDX_Control(pDX, IDC_FILTERLEVEL_SPIN, m_FilterLevelSpinCtrl);
	DDX_Control(pDX, IDC_UPDATE_DAYS_SLIDER, m_UpdateDaysSlider);
	DDX_Text(pDX, IDC_UPDATE_DAYS_STATIC, m_strUpdateDaysStatic);
	DDX_Control(pDX, IDC_UPDATE_DAYS_STATIC, m_UpdateDaysStatic);
	DDX_Text(pDX, IDC_AV_GROUPBOX, m_strAVGroupBox);
	DDX_Text(pDX, IDC_AV_PATH_TEXT, m_strAVPathStatic);
	DDX_Text(pDX, IDC_AV_PARAMS_TEXT, m_strAVParamsStatic);
	DDX_Control(pDX, IDC_AV_BROWSE, m_AVBrowseButton);
	DDX_Check(pDX, IDC_AV_ENABLED_CHECK, m_bAVEnabledCheck);
	DDX_Check(pDX, IDC_AV_SCANCOMPLETED_CHECK, m_bAVScanCompletedCheck);
	DDX_Control(pDX, IDC_AV_SCANCOMPLETED_CHECK, m_AVScanCompletedCheck);
	DDX_Control(pDX, IDC_AV_ENABLED_CHECK, m_AVEnabledCheck);
	DDX_Text(pDX, IDC_AV_PATH_EDIT, m_strAVPath);
	DDX_Control(pDX, IDC_AV_PATH_EDIT, m_strAVPathEdit);
	DDX_Text(pDX, IDC_AV_PARAMS_EDIT, m_strAVParams);
	DDX_Control(pDX, IDC_AV_PARAMS_EDIT, m_strAVParamsEdit);
}
/////////////////////////////////////////////////////////////////////////////////////////////
void CPPgSecurity::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		m_strIPFilterGroupBox	= GetResString(IDS_IPFILTER_GROUPBOX);
		m_strFilterLevelStatic	= GetResString(IDS_FILTERLEVEL_STATIC);
		m_strIPFilterURLStatic	= GetResString(IDS_IPFILTER_URL_STATIC);
		m_FilterClientsCheck.SetWindowText(GetResString(IDS_PW_FILTER));
		m_FilterServersCheck.SetWindowText(GetResString(IDS_FILTERSERVERSBYIP));
		m_IPFilterUpdateOnStartCheck.SetWindowText(GetResString(IDS_IPFILTER_UPDATEONSTART_CHECK));
		m_FileScanFilterCheck.SetWindowText(GetResString(IDS_SCANFILTER));
		m_IPFilterUpdateButton.SetWindowText(GetResString(IDS_SV_UPDATE));

		SetDaysCaption(m_UpdateDaysSlider.GetPos());

		m_strAVGroupBox			= GetResString(IDS_AV_GROUPBOX);
		m_strAVPathStatic		= GetResString(IDS_AV_PATH);
		m_strAVParamsStatic		= GetResString(IDS_AV_PARAMS);
		m_AVEnabledCheck.SetWindowText(GetResString(IDS_ENABLED));
		m_AVScanCompletedCheck.SetWindowText(GetResString(IDS_AV_SCAN_COMPLETED));
	
		UpdateData(FALSE);
	}
}
/////////////////////////////////////////////////////////////////////////////////////////////
void CPPgSecurity::LoadSettings(void)
{
	m_FilterLevelSpinCtrl.SetPos(m_pPrefs->GetIPFilterLevel());
	m_UpdateDaysSlider.SetPos(m_pPrefs->GetIPFilterUpdateFrequency());
	m_strIPFilterURLEdit			= m_pPrefs->GetIPFilterURL();
	m_bFilterClientsCheck			= m_pPrefs->IsFilterBadIPs();
	m_bFilterServersCheck			= m_pPrefs->IsFilterServersByIP();
	m_bIPFilterUpdateOnStartCheck	= m_pPrefs->IsIPFilterUpdateOnStart();
	m_bFileScanFilterCheck			= m_pPrefs->IsScanFilterEnabled();

	m_UpdateDaysStatic.EnableWindow(m_bIPFilterUpdateOnStartCheck);
	m_UpdateDaysSlider.EnableWindow(m_bIPFilterUpdateOnStartCheck);

	m_bAVEnabledCheck				= m_pPrefs->IsAVEnabled();
	m_bAVScanCompletedCheck			= m_pPrefs->IsAVScanCompleted();
	m_strAVPath						= m_pPrefs->GetAVPath();
	m_strAVParams					= m_pPrefs->GetAVParams();

	UpdateData(FALSE);

	OnBnClickedAvEnable();

	SetModified(FALSE);
}
/////////////////////////////////////////////////////////////////////////////////////////////
BOOL CPPgSecurity::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_FilterLevelSpinCtrl.SetRange(0,255);
	m_UpdateDaysSlider.SetRange(0, 6);

	m_strAVPathEdit.SetLimitText(MAX_PATH);
	m_strAVParamsEdit.SetLimitText(30);

	AddBuddy(m_strAVPathEdit.m_hWnd, m_AVBrowseButton.m_hWnd, BDS_RIGHT);

	LoadSettings();
	Localize();

	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////////////////////
BOOL CPPgSecurity::OnApply()
{
	if(m_bModified)
	{
		UpdateData();

		if (m_FilterLevelSpinCtrl.GetPos() > 255)
		{
			m_pPrefs->SetIPFilterLevel(255);
		}
		else
		{
			m_pPrefs->SetIPFilterLevel(m_FilterLevelSpinCtrl.GetPos());
		}
		m_pPrefs->SetIPFilterUpdateFrequency(m_UpdateDaysSlider.GetPos());
		m_pPrefs->SetIPFilterURL(m_strIPFilterURLEdit);
		m_pPrefs->SetFilterBadIPs(m_bFilterClientsCheck);
		m_pPrefs->SetFilterServersByIP(m_bFilterServersCheck);
		m_pPrefs->SetIPFilterUpdateOnStart(m_bIPFilterUpdateOnStartCheck);
		m_pPrefs->SetScanFilterEnabled(m_bFileScanFilterCheck);

		m_pPrefs->SetAVEnabled(m_bAVEnabledCheck);
		m_pPrefs->SetAVScanCompleted(m_bAVScanCompletedCheck);
		m_pPrefs->SetAVPath(m_strAVPath);
		m_pPrefs->SetAVParams(m_strAVParams);

		SetModified(FALSE);
		LoadSettings();
	}

	return CPropertyPage::OnApply();
}
/////////////////////////////////////////////////////////////////////////////////////////////
void CPPgSecurity::OnBnClickedIpfilterUpdateButton()
{
	UpdateData(TRUE);

	m_pPrefs->SetIPFilterURL(m_strIPFilterURLEdit);

	if (g_eMuleApp.m_pIPFilter->DownloadIPFilter())
	{
		m_pPrefs->SetLastIPFilterUpdate(static_cast<uint32>(mktime(CTime::GetCurrentTime().GetLocalTm())));
		m_IPFilterUpdateButton.EnableWindow(FALSE);
	}
}
/////////////////////////////////////////////////////////////////////////////////////////////
void CPPgSecurity::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	if (pScrollBar == reinterpret_cast<CScrollBar*>(&m_UpdateDaysSlider))
	{
		int iSliderPos = m_UpdateDaysSlider.GetPos();

		SetDaysCaption(iSliderPos);
		SetModified();
	}

	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}
/////////////////////////////////////////////////////////////////////////////////////////////
void CPPgSecurity::SetDaysCaption(int iSliderPos)
{
	switch(iSliderPos)
	{
		case 0:
		{
			m_strUpdateDaysStatic = GetResString(IDS_IPFILTER_UPDATE_DAILY);
			break;
		}
		case 6:
		{
			m_strUpdateDaysStatic = GetResString(IDS_IPFILTER_UPDATE_WEEKLY);
			break;
		}
		default:
		{
			m_strUpdateDaysStatic.Format(GetResString(IDS_IPFILTER_UPDATE_DAYS), iSliderPos + 1);
			break;
		}
	}

	UpdateData(FALSE);
}
/////////////////////////////////////////////////////////////////////////////////////////////
void CPPgSecurity::OnBnClickedIpfilterUpdateonstartCheck()
{
	UpdateData();
	m_UpdateDaysStatic.EnableWindow(m_bIPFilterUpdateOnStartCheck);
	m_UpdateDaysSlider.EnableWindow(m_bIPFilterUpdateOnStartCheck);
	SetModified();
}
/////////////////////////////////////////////////////////////////////////////////////////////
BOOL CPPgSecurity::OnSetActive()
{
	CTime LastUpdate(static_cast<time_t>(m_pPrefs->GetLastIPFilterUpdate()));
	time_t tLastUpdate = mktime(LastUpdate.GetLocalTm());
	time_t tNow = mktime(CTime::GetCurrentTime().GetLocalTm());

//
//	Disables Update button for 24h
	if (difftime(tNow, tLastUpdate) < (24 * 60 * 60))
	{
		m_IPFilterUpdateButton.EnableWindow(FALSE);
	}
	else
	{
		m_IPFilterUpdateButton.EnableWindow();
	}

	return CPropertyPage::OnSetActive();
}
/////////////////////////////////////////////////////////////////////////////////////////////
void CPPgSecurity::OnBnClickedAvbrowse()
{
	if(DialogBrowseFile(m_strAVPath, (GetResString(IDS_AV_PATH) + _T(" (*.exe)|*.exe||"))))
	{
		UpdateData(FALSE);
		SetModified();
	}
}
/////////////////////////////////////////////////////////////////////////////////////////////
void CPPgSecurity::OnBnClickedAvEnable()
{
	UpdateData(TRUE);

	m_strAVPathEdit.EnableWindow(m_bAVEnabledCheck);
	m_strAVParamsEdit.EnableWindow(m_bAVEnabledCheck);
	m_AVScanCompletedCheck.EnableWindow(m_bAVEnabledCheck);
	m_AVBrowseButton.EnableWindow(m_bAVEnabledCheck);

	SetModified();
}
/////////////////////////////////////////////////////////////////////////////////////////////
