//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// ServerWnd.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "ServerWnd.h"
#include "HttpDownloadDlg.h"
#include "HTRichEditCtrl.h"
#include "NewServerDlg.h"
#include "UpdateServerMetDlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CServerWnd dialog

IMPLEMENT_DYNAMIC(CServerWnd, CDialog)
CServerWnd::CServerWnd(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CServerWnd::IDD, pParent)
{
	m_pctlServerMsgBox = new CHTRichEditCtrl;
	logbox = new CHTRichEditCtrl;
	debugbox = new CHTRichEditCtrl;
	m_dlgNewServer.SetParent(this);
	m_dlgUpdateServerMet.SetParent(this);
}

CServerWnd::~CServerWnd()
{
	delete m_pctlServerMsgBox;
	delete logbox;
	delete debugbox;
}

BOOL CServerWnd::OnInitDialog()
{
	static const uint16 s_auIconResID[] =
	{
		IDI_LOG,
		IDI_SERVERINFO
	};

	CResizableDialog::OnInitDialog();
	m_ctlServerList.Init(g_eMuleApp.m_pServerList);

///////////////////////////////////////////////////

	m_ctrlBoxSwitcher.ModifyStyle(NULL, TCS_OWNERDRAWFIXED);

	m_imageList.Create(16,16,ILC_COLOR32,0,10);
	m_imageList.SetBkColor(RGB(255,0,255));
	FillImgLstWith16x16Icons(&m_imageList, s_auIconResID, ELEMENT_COUNT(s_auIconResID));

	CImageList		imageList;
	CBitmap Bitmap, *pOldBitmap;
	CDC *pCtrlDC = GetDC(), TempDC;

	TempDC.CreateCompatibleDC(pCtrlDC);
	Bitmap.CreateCompatibleBitmap(pCtrlDC, 16 * 2, 16);
	pOldBitmap = TempDC.SelectObject(&Bitmap);
	m_imageList.Draw(&TempDC, 0, CPoint( 0,0), ILD_NORMAL);
	m_imageList.Draw(&TempDC, 1, CPoint(16,0), ILD_NORMAL);
	TempDC.SelectObject(pOldBitmap);
	imageList.Create(16, 16, ILC_COLOR32 | ILC_MASK, 0, 10);
	imageList.Add(&Bitmap, RGB(255,0,255));
	m_ctrlBoxSwitcher.SetImageList(&imageList);
	imageList.Detach();
	//Bitmap.Detach();
	Bitmap.DeleteObject();
	ReleaseDC(pCtrlDC);
///////////////////////////////////////////////////////

	m_ctrlBoxSwitcher.InsertItem(TCIF_IMAGE | TCIF_TEXT, 0, GetResString(IDS_SV_LOG), 0,0,0,0);
	m_ctrlBoxSwitcher.InsertItem(TCIF_IMAGE | TCIF_TEXT, 1, GetResString(IDS_SV_SERVERINFO), 1,0,0,0);

	CRect rBox;
	GetDlgItem(IDC_LOG)->GetWindowRect(rBox);
	::MapWindowPoints(NULL, m_hWnd, (LPPOINT)&rBox, 2);
	m_pctlServerMsgBox->Create(WS_VISIBLE | WS_CHILD | WS_HSCROLL | WS_VSCROLL | ES_MULTILINE | ES_READONLY | ES_NOHIDESEL, rBox, this, 123);
	m_pctlServerMsgBox->ModifyStyleEx(0, WS_EX_STATICEDGE, SWP_FRAMECHANGED);
	m_pctlServerMsgBox->SetEventMask(m_pctlServerMsgBox->GetEventMask() | ENM_LINK);
	logbox->Create(WS_VISIBLE | WS_CHILD | WS_HSCROLL | WS_VSCROLL | ES_MULTILINE | ES_READONLY | ES_NOHIDESEL, rBox, this, 122);
	logbox->ModifyStyleEx(0, WS_EX_STATICEDGE, SWP_FRAMECHANGED);
	logbox->SetEventMask(m_pctlServerMsgBox->GetEventMask() | ENM_LINK);
	debugbox->Create(WS_VISIBLE | WS_CHILD | WS_HSCROLL | WS_VSCROLL | ES_MULTILINE | ES_READONLY | ES_NOHIDESEL, rBox, this, 121);
	debugbox->ModifyStyleEx(0, WS_EX_STATICEDGE, SWP_FRAMECHANGED);
	debugbox->SetEventMask(m_pctlServerMsgBox->GetEventMask() | ENM_LINK);

	InitFont();
	oldServerListIcon = GetServerLstStatic()->SetIcon(GetServerLstIcon());
	m_pctlServerMsgBox->AppendText(CString(CLIENT_NAME_WITH_VER " (http://emuleplus.info)\n"), RGB(153,51,102));
	m_pctlServerMsgBox->AppendText(GetResString(IDS_EMULEW) + _T(' '), RGB(153,51,102));
	m_pctlServerMsgBox->AppendHyperLink(_T(""),_T(""),GetResString(IDS_EMULEW3),_T(""));
	m_pctlServerMsgBox->AppendText(_T(' ') + GetResString(IDS_EMULEW2) + _T("\n\n"), RGB(153,51,102));

	m_ctrlNewServerBtn.SetThemeHelper(&g_eMuleApp.m_pdlgEmule->m_themeHelper);
	m_ctrlNewServerBtn.SetIcon(IDI_NEWSERVER);
	m_ctrlUpdateServerMetBtn.SetThemeHelper(&g_eMuleApp.m_pdlgEmule->m_themeHelper);
	m_ctrlUpdateServerMetBtn.SetIcon(IDI_UPDATESERVERS);
	m_ctrlResetLogBtn.SetThemeHelper(&g_eMuleApp.m_pdlgEmule->m_themeHelper);
	m_ctrlResetLogBtn.SetIcon(IDI_RESETLOG);

	AddAnchor(IDC_SERVLST_ICO, TOP_LEFT);
	AddAnchor(IDC_SERVLIST_TEXT, TOP_LEFT);
	AddAnchor(IDC_SERVLIST, TOP_LEFT, MIDDLE_RIGHT);
	AddAnchor(IDC_TAB1, MIDDLE_LEFT, BOTTOM_RIGHT);
	AddAnchor(*m_pctlServerMsgBox, MIDDLE_LEFT, BOTTOM_RIGHT);
	AddAnchor(*logbox, MIDDLE_LEFT, BOTTOM_RIGHT);
	AddAnchor(*debugbox, MIDDLE_LEFT, BOTTOM_RIGHT);
	AddAnchor(IDC_NEWSERVER, TOP_RIGHT);
	AddAnchor(IDC_UPDATESERVERMET, TOP_RIGHT);
	AddAnchor(IDC_LOGRESET, MIDDLE_RIGHT);
	debug = false;
	ToggleDebugWindow();
	m_pctlServerMsgBox->ShowWindow(SW_HIDE);
	debugbox->ShowWindow(SW_HIDE);
	logbox->ShowWindow(SW_HIDE);
	if (logbox->m_hWnd)
		logbox->ShowWindow(SW_SHOW);

	Localize();

	m_ttip.Create(this);
	m_ttip.SetDelayTime(TTDT_AUTOPOP, 15000);
	m_ttip.SetDelayTime(TTDT_INITIAL, g_eMuleApp.m_pGlobPrefs->GetToolTipDelay()*1000);
	m_ttip.SendMessage(TTM_SETMAXTIPWIDTH, 0, SHRT_MAX);
	m_ttip.SetBehaviour(PPTOOLTIP_MULTIPLE_SHOW);
	m_ttip.SetNotify(m_hWnd);
	m_ttip.AddTool(&m_ctlServerList, _T(""));

	return true;
}
void CServerWnd::InitFont()
{
	logbox->SetFont(&g_eMuleApp.m_pdlgEmule->m_fontDefault);
	m_pctlServerMsgBox->SetFont(&g_eMuleApp.m_pdlgEmule->m_fontDefault);
	debugbox->SetFont(&g_eMuleApp.m_pdlgEmule->m_fontDefault);
}

void CServerWnd::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SERVLIST, m_ctlServerList);
	DDX_Control(pDX, IDC_NEWSERVER, m_ctrlNewServerBtn);
	DDX_Control(pDX, IDC_UPDATESERVERMET, m_ctrlUpdateServerMetBtn);
	DDX_Control(pDX, IDC_TAB1, m_ctrlBoxSwitcher);
	DDX_Control(pDX, IDC_LOGRESET, m_ctrlResetLogBtn);
}

void CServerWnd::Localize()
{
	if(m_hWnd)
	{
		TCHAR buffer[256];
		TCITEM ti;
		ti.mask = TCIF_TEXT;
		ti.pszText = buffer;
		ti.cchTextMax = sizeof(buffer);

		m_ctrlBoxSwitcher.GetItem(0, &ti);
		_stprintf(buffer, _T("%s"), GetResString(IDS_SV_LOG));
		m_ctrlBoxSwitcher.SetItem(0, &ti);
		m_ctrlBoxSwitcher.GetItem(1, &ti);
		_stprintf(buffer, _T("%s"), GetResString(IDS_SV_SERVERINFO));
		m_ctrlBoxSwitcher.SetItem(1, &ti);
		if (g_eMuleApp.m_pGlobPrefs->GetVerbose() && debug == true)
		{
			m_ctrlBoxSwitcher.GetItem(2, &ti);
			_stprintf(buffer, _T("%s"), GetResString(IDS_SV_DEBUGLOG));
			m_ctrlBoxSwitcher.SetItem(2, &ti);
		}
		logbox->SetTitle(GetResString(IDS_SV_LOG));
		m_pctlServerMsgBox->SetTitle(GetResString(IDS_SV_SERVERINFO));
		debugbox->SetTitle(GetResString(IDS_SV_DEBUGLOG));
		m_ctrlBoxSwitcher.Invalidate();
		logbox->Invalidate();
		debugbox->Invalidate();
		m_pctlServerMsgBox->Invalidate();
		m_ctrlBoxSwitcher.SetWindowPos(&CWnd::wndBottom,0,0,0,0, SWP_NOMOVE | SWP_NOSIZE);
		SetDlgItemText(IDC_SERVLIST_TEXT, GetResString(IDS_SV_SERVERLIST));
		m_ctrlNewServerBtn.SetWindowText(GetResString(IDS_SV_NEWSERVER));
		m_ctrlUpdateServerMetBtn.SetWindowText(GetResString(IDS_SV_MET));
		m_ctrlResetLogBtn.SetWindowText(GetResString(IDS_PW_RESET));

		m_ctlServerList.Localize();
	}
}

BEGIN_MESSAGE_MAP(CServerWnd, CResizableDialog)
	ON_NOTIFY_EX_RANGE(UDM_TOOLTIP_DISPLAY,0,0xFFFF,OnToolTipNotify)
	ON_BN_CLICKED(IDC_LOGRESET, OnBnClickedResetLog)
	ON_BN_CLICKED(IDC_UPDATESERVERMET, OnBnClickedUpdateservermet)
	ON_BN_CLICKED(IDC_NEWSERVER, OnBnClickedNewserver)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnTcnSelchangeTab1)
	ON_NOTIFY(EN_LINK, 123, OnEnLinkServerBox)
	ON_WM_DESTROY()
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CServerWnd message handlers
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CServerWnd::PreTranslateMessage(MSG* pMsg)
{
	if (g_eMuleApp.m_pGlobPrefs->GetToolTipDelay() != 0)
		m_ttip.RelayEvent(pMsg);

	return CResizableDialog::PreTranslateMessage(pMsg);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CServerWnd::GetItemUnderMouse(CListCtrl* ctrl)
{
	EMULE_TRY

	CPoint pt;

	::GetCursorPos(&pt);
	ctrl->ScreenToClient(&pt);

	LVHITTESTINFO hit, subhit;

	hit.pt = pt;
	subhit.pt = pt;
	ctrl->SubItemHitTest(&subhit);

	int sel = ctrl->HitTest(&hit);

	if (sel != LB_ERR && (hit.flags & LVHT_ONITEM))
	{
		if (subhit.iSubItem == 0)
			return sel;
	}

	EMULE_CATCH

	return LB_ERR;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CServerWnd::OnToolTipNotify(UINT id, NMHDR *pNMH, LRESULT *pResult)
{
	NM_PPTOOLTIP_DISPLAY * pNotify = (NM_PPTOOLTIP_DISPLAY*)pNMH;
	int			iControlId = CWnd::FromHandle(pNotify->ti->hWnd)->GetDlgCtrlID();
	CString		strInfo;

	if (iControlId == IDC_SERVLIST)
	{
		if (m_ctlServerList.GetItemCount() < 1)
			return FALSE;

		int		iSel = GetItemUnderMouse(&m_ctlServerList);

		if (iSel < 0 || iSel == 65535)
			return FALSE;

		CServer		*pServer = (CServer*)m_ctlServerList.GetItemData(iSel);

		if (pServer == NULL)
			return FALSE;

		pNotify->ti->hIcon = pServer->GetServerInfo4Tooltips(strInfo);
		SetFocus();
	}
	pNotify->ti->sTooltip = strInfo;

	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CServerWnd::OnBnClickedResetLog()
{
	switch(m_ctrlBoxSwitcher.GetCurSel())
	{
		case 0:
			logbox->Reset();
			break;
		case 1:
			m_pctlServerMsgBox->Reset();
			break;
		case 2:
			debugbox->Reset();
			break;
		default:
			break;
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CServerWnd::OnBnClickedNewserver()
{
	CRect rBtn;
	GetDlgItem(IDC_NEWSERVER)->GetWindowRect(&rBtn);
	m_dlgNewServer.SetInitialPos(CPoint(rBtn.right,rBtn.bottom), 1);
	m_dlgNewServer.SetServerEditMode(false); // We are adding a server, not editing
	m_dlgNewServer.DoModal();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CServerWnd::OnBnClickedUpdateservermet()
{
	CRect rBtn;
	GetDlgItem(IDC_UPDATESERVERMET)->GetWindowRect(&rBtn);
	m_dlgUpdateServerMet.SetInitialPos(CPoint(rBtn.right,rBtn.bottom), 1);
	m_dlgUpdateServerMet.DoModal();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CServerWnd::AddServer(CString strAddress, CString strPort, CString strName, CString strAuxPort/* = _T("")*/, bool bChangeServerInfo/* = false*/)
{
	if (strAddress.IsEmpty())
	{
		AddLogLine(true, IDS_SRV_ADDR);
		return;
	}

	if (strPort.IsEmpty())
	{
		AddLogLine(true, IDS_SRV_PORT);
		return;
	}

	CServer	*pNewServer = new CServer(_tstoi(strPort), strAddress.GetBuffer());

	// Default all manually added servers to high priority
	if( g_eMuleApp.m_pGlobPrefs->GetManualHighPrio() )
		pNewServer->SetPreference(CServer::SERVERPRIORITY_HIGH);

	if (!strName.IsEmpty())
		pNewServer->SetListName(strName.GetBuffer());
	else
		pNewServer->SetListName(strAddress.GetBuffer());

	if (!strAuxPort.IsEmpty())
	{
		pNewServer->SetAuxPort(_tstoi(strAuxPort));
	}

	if (!m_ctlServerList.AddServer(pNewServer, true, false, bChangeServerInfo))
		{
		CServer	   *pServerFound = g_eMuleApp.m_pServerList->GetServerByAddress(pNewServer->GetAddress(), pNewServer->GetPort());

		if (pServerFound != NULL)
		{
			pServerFound->SetListName(pNewServer->GetListName());
			m_ctlServerList.RefreshServer(*pServerFound);
		}

		AddLogLine(true, IDS_SRV_NOTADDED);
		delete pNewServer;
	}
	else
		AddLogLine(true, GetResString(IDS_SERVERADDED), pNewServer->GetListName());

//	g_eMuleApp.m_pServerList->SaveServerMetToFile();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CServerWnd::UpdateServerMetFromURL(CString strURL)
{
	m_ctlServerList.SetRedraw(false);

	if(strURL == "")
	{
	//	Update from known addresses
		g_eMuleApp.m_pServerList->AutoUpdate();

	//	Load Metfile (merge existing servers)
		CString strPath = g_eMuleApp.m_pGlobPrefs->GetConfigDir() + CString(_T("server.met"));
		g_eMuleApp.m_pServerList->AddServerMetToList(strPath, true);
	}
	else
	{
	//	Is not a valid URL
		if (strURL != "" && strURL.Find(_T("://")) == -1)
		{
			AddLogLine(true, RGB_LOG_WARNING + GetResString(IDS_INVALIDURL));
			m_ctlServerList.SetRedraw(true);
			return;
		}

		CString strTempFilename;
		strTempFilename.Format(_T("%stemp-%d-server.met"), g_eMuleApp.m_pGlobPrefs->GetConfigDir(), ::GetTickCount());

		CHttpDownloadDlg dlgDownload;
		dlgDownload.m_strInitializingTitle = GetResString(IDS_HTTP_CAPTION);
		dlgDownload.m_nIDPercentage = IDS_HTTPDOWNLOAD_PERCENTAGE;
		dlgDownload.m_sURLToDownload = strURL;
		dlgDownload.m_sFileToDownloadInto = strTempFilename;

		if(dlgDownload.DoModal() != IDOK)
		{
			AddLogLine(true, RGB_LOG_WARNING + GetResString(IDS_ERR_FAILEDDOWNLOADMET), strURL);
			m_ctlServerList.SetRedraw(true);
			return;
		}

	//	Load Metfile (merge existing servers)
		g_eMuleApp.m_pServerList->AddServerMetToList(strTempFilename, true);

		_tremove(strTempFilename);
	}

//	Insert static servers from textfile
	CString strPath = g_eMuleApp.m_pGlobPrefs->GetConfigDir() + CString(_T("staticservers.dat"));
	g_eMuleApp.m_pServerList->AddServersFromTextFile(strPath);

	m_ctlServerList.RemoveDeadServer();
	m_ctlServerList.ShowFilesCount();

	m_ctlServerList.SetRedraw(true);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CServerWnd::OnStnClickedServinfIco()
{
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CServerWnd::OnTcnSelchangeTab1(NMHDR *pNMHDR, LRESULT *pResult)
{
	switch(m_ctrlBoxSwitcher.GetCurSel())
	{
		case 0:
			debugbox->ShowWindow(SW_HIDE);
			m_pctlServerMsgBox->ShowWindow(SW_HIDE);
			logbox->ShowWindow(SW_SHOW);
			if ((logbox->m_bAutoScroll) && (m_ctrlBoxSwitcher.GetItemState(0, TCIS_HIGHLIGHTED) & TCIS_HIGHLIGHTED))
				logbox->ScrollToLastLine();
			m_ctrlBoxSwitcher.SetItemState(0, TCIS_HIGHLIGHTED, NULL);
			break;
		case 1:
			debugbox->ShowWindow(SW_HIDE);
			m_pctlServerMsgBox->ShowWindow(SW_SHOW);
			logbox->ShowWindow(SW_HIDE);
			if ((m_pctlServerMsgBox->m_bAutoScroll) && (m_ctrlBoxSwitcher.GetItemState(1, TCIS_HIGHLIGHTED) & TCIS_HIGHLIGHTED))
				m_pctlServerMsgBox->ScrollToLastLine();
			m_ctrlBoxSwitcher.SetItemState(1, TCIS_HIGHLIGHTED, NULL);
			break;
		case 2:
			debugbox->ShowWindow(SW_SHOW);
			m_pctlServerMsgBox->ShowWindow(SW_HIDE);
			logbox->ShowWindow(SW_HIDE);
			if ((debugbox->m_bAutoScroll) && (m_ctrlBoxSwitcher.GetItemState(2, TCIS_HIGHLIGHTED) & TCIS_HIGHLIGHTED))
				debugbox->ScrollToLastLine();
			m_ctrlBoxSwitcher.SetItemState(2, TCIS_HIGHLIGHTED, NULL);
			break;
		default:
			break;
	}

	*pResult = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CServerWnd::ToggleDebugWindow()
{
	//AddLogLine(true," get verbose = %i  :: debug = %i",g_eMuleApp.m_pGlobPrefs->GetVerbose() , debug == false);
	int cur_sel = m_ctrlBoxSwitcher.GetCurSel();
	if( g_eMuleApp.m_pGlobPrefs->GetVerbose() && debug == false )
	{
		//AddLogLine(true,"should switch");
		m_ctrlBoxSwitcher.InsertItem(TCIF_IMAGE | TCIF_TEXT, 2, GetResString(IDS_SV_DEBUGLOG), 0,0,0,0);
		debug = true;
	}
	else if( !g_eMuleApp.m_pGlobPrefs->GetVerbose() && debug == true )
	{
		if( cur_sel == 2 )
		{
			m_ctrlBoxSwitcher.SetCurSel(0);
			m_ctrlBoxSwitcher.SetFocus();
		}
		debugbox->ShowWindow(SW_HIDE);
		m_pctlServerMsgBox->ShowWindow(SW_HIDE);
		logbox->ShowWindow(SW_SHOW);
		m_ctrlBoxSwitcher.DeleteItem(2);
		debug = false;
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CServerWnd::OnCancel()
{
	//CResizableDialog::OnCancel();	// pressing ESC when the focus is on the logbox	would hide the server-wnd [FoRcHa]
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CServerWnd::OnEnLinkServerBox(NMHDR *pNMHDR, LRESULT *pResult)
{
	*pResult = 0;
	ENLINK* pEnLink = reinterpret_cast<ENLINK *>(pNMHDR);
	if (pEnLink && pEnLink->msg == WM_LBUTTONDOWN)
	{
		CString strUrl;
		m_pctlServerMsgBox->GetTextRange(pEnLink->chrg.cpMin, pEnLink->chrg.cpMax, strUrl);
		CString sLangUrl = strUrl; // GetTextRange returns '?' for non-english chars :(
		sLangUrl.Remove('?'); sLangUrl.Remove(' ');
		if (strUrl == GetResString(IDS_EMULEW3) || sLangUrl.IsEmpty())
			strUrl.Format(_T("http://emuleplus.info/version_check.php?version=%i&language=%i"),CURRENT_PLUS_VERSION,g_eMuleApp.m_pGlobPrefs->GetLanguageID());
		ShellExecute(NULL, NULL, strUrl, NULL, NULL, SW_SHOWDEFAULT);
		*pResult = 1;
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CServerWnd::OnDestroy()
{
	CResizableDialog::OnDestroy();

	DestroyIcon(GetServerLstStatic()->SetIcon(oldServerListIcon));
	m_imageList.DeleteImageList();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CNewTabCtrl::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	EMULE_TRY

	CDC dc;
	dc.Attach(lpDrawItemStruct->hDC);

	char pBuf[255];
	int nCurItem = lpDrawItemStruct->itemID;

	TCITEM tcitem;
	tcitem.mask = TCIF_TEXT | TCIF_IMAGE | TCIF_STATE;
	tcitem.pszText = pBuf;
	tcitem.cchTextMax = sizeof(pBuf);
	tcitem.dwStateMask = TCIS_HIGHLIGHTED;
	GetItem(nCurItem, &tcitem);

	CRect rect = lpDrawItemStruct->rcItem;
		rect.top += ::GetSystemMetrics(SM_CYEDGE);
		rect.left += ::GetSystemMetrics(SM_CXEDGE);
		rect.right -= ::GetSystemMetrics(SM_CXEDGE);
	if (!g_eMuleApp.m_pdlgEmule->m_themeHelper.IsAppThemed())
		dc.FillSolidRect(&rect, GetSysColor(COLOR_BTNFACE));
	dc.SetBkMode(TRANSPARENT);
	int nIconShift = 0;
	if(nCurItem == GetCurSel())
		nIconShift += 2;
	CImageList *pImageList = GetImageList();
	if(pImageList)
		pImageList->Draw(&dc, tcitem.iImage, CPoint(rect.left + 2 + nIconShift, rect.top), ILD_TRANSPARENT);

	if(tcitem.dwState & TCIS_HIGHLIGHTED)
		dc.SetTextColor(RGB(196, 0, 0));
	else
		dc.SetTextColor(GetSysColor(COLOR_BTNTEXT));

	rect.OffsetRect(10, 2);
	dc.DrawText(CString(pBuf), rect, DT_CENTER);
	dc.Detach();

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
