//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// StatisticsDlg.cpp : implementation file
//
#include "stdafx.h"
#include "emule.h"
#include "StatisticsDlg.h"
#include "UploadQueue.h"
#include "otherfunctions.h"
#include "WebServer.h"
#include "IP2Country.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CStatisticsDlg dialog

IMPLEMENT_DYNAMIC(CStatisticsDlg, CDialog)
CStatisticsDlg::CStatisticsDlg(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CStatisticsDlg::IDD, pParent), m_DownloadOMeter(3), m_Statistics(3), m_UploadOMeter(3)
{
	m_oldcx = 0;
	m_oldcy = 0;

	//eklmn: add initial data in the list
	downrateHistory.push_front(0);
	uprateHistory.push_front(0);
	timeHistory.push_front(::GetTickCount());
}

CStatisticsDlg::~CStatisticsDlg()
{
        // v- eklmn: bugfix(06): resource cleanup in statistic
        if (imagelistStatTree) imagelistStatTree.DeleteImageList();
        if (stattree) stattree.DeleteAllItems();
        // ^- eklmn: bugfix(06): resource cleanup in statistic
}

void CStatisticsDlg::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExoSliderDlg)
	DDX_Control(pDX, IDC_STATTREE, stattree);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStatisticsDlg, CResizableDialog)
	//{{AFX_MSG_MAP(CStatisticsDlg)
	ON_WM_SHOWWINDOW()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BNMENU, OnMenuButtonClicked)
	ON_WM_DESTROY()	// eklmn: bugfix(00): resource cleanup due to CResizableDialog
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CStatisticsDlg message handlers
BOOL CStatisticsDlg::OnInitDialog()
{
	EMULE_TRY

	CResizableDialog::OnInitDialog();
	EnableWindow( FALSE );

	Localize();

	// Setup image list For Tree (2-18-03)
	imagelistStatTree.Create(16, 16, ILC_COLOR32 | ILC_MASK, 12, 0);
	imagelistStatTree.Add(g_eMuleApp.LoadIcon(IDI_TVI_GENERIC));		// Dots & Arrow (Default icon for stats)
	imagelistStatTree.Add(g_eMuleApp.LoadIcon(IDI_UP1DOWN1));			// Transfer
	imagelistStatTree.Add(g_eMuleApp.LoadIcon(IDI_CONNECTEDHIGH));		// Connection
	imagelistStatTree.Add(g_eMuleApp.LoadIcon(IDI_USER));				// Clients
	imagelistStatTree.Add(g_eMuleApp.LoadIcon(IDI_PREF_SERVER));		// Server
	imagelistStatTree.Add(g_eMuleApp.LoadIcon(IDI_SHAREDFILES));		// Shared Files
	imagelistStatTree.Add(g_eMuleApp.LoadIcon(IDI_UPLOAD));				// Transfer > Upload
	imagelistStatTree.Add(g_eMuleApp.LoadIcon(IDI_DIRECTDOWNLOAD));		// Transfer > Download
	imagelistStatTree.Add(g_eMuleApp.LoadIcon(IDI_SMALLSTATISTICS));	// Session Sections
	imagelistStatTree.Add(g_eMuleApp.LoadIcon(IDI_TVI_CUMULATIVE));		// Cumulative Sections
	imagelistStatTree.Add(g_eMuleApp.LoadIcon(IDI_PREF_TWEAK));			// Records
	imagelistStatTree.Add(g_eMuleApp.LoadIcon(IDI_PREF_CONNECTION));	// Connection > General
	imagelistStatTree.Add(g_eMuleApp.LoadIcon(IDI_PREF_SCHEDULER));		// Time Section
	imagelistStatTree.Add(g_eMuleApp.LoadIcon(IDI_PREF_STATISTICS));	// Time > Averages and Projections
	imagelistStatTree.Add(g_eMuleApp.LoadIcon(IDI_TVI_DAY));			// Time > Averages and Projections > Daily
	imagelistStatTree.Add(g_eMuleApp.LoadIcon(IDI_TVI_MONTH));			// Time > Averages and Projections > Monthly
	imagelistStatTree.Add(g_eMuleApp.LoadIcon(IDI_TVI_YEAR));			// Time > Averages and Projections > Yearly
	stattree.SetImageList(&imagelistStatTree, TVSIL_NORMAL);

	CreateStatsTree();

	CRect rClient;
	GetClientRect(&rClient);

	m_DownloadOMeter.m_nYDecimals = 0;
	m_UploadOMeter.m_nYDecimals = 0;
	m_Statistics.m_nYDecimals = 0;
	int iMaxDlGraph = int((g_eMuleApp.m_pGlobPrefs->GetMaxGraphDownloadRate()/10.0)+0.99)*10;
	int iMaxUlGraph = int((g_eMuleApp.m_pGlobPrefs->GetMaxGraphUploadRate()/4.0)+0.99)*4;
	m_DownloadOMeter.m_nYGrids=int(iMaxDlGraph/10)-1;
	m_UploadOMeter.m_nYGrids=int(iMaxUlGraph/2)-1;
	int iStatYGrids=int((g_eMuleApp.m_pGlobPrefs->GetStatsMax()/10.0)+0.1)-1;
	if (iStatYGrids>10)
		iStatYGrids=int((g_eMuleApp.m_pGlobPrefs->GetStatsMax()/50.0)+0.1)-1;
	m_Statistics.m_nYGrids=iStatYGrids;

	// Setup download scope
	CRect rect;
	GetDlgItem(IDC_SCOPE_D)->GetWindowRect(rect);
	ScreenToClient(rect);
	m_DownloadOMeter.Create(WS_VISIBLE | WS_CHILD, rect, this);
	m_DownloadOMeter.SetRange(0, iMaxDlGraph, 0);
	m_DownloadOMeter.SetRange(0, iMaxDlGraph, 1);
	m_DownloadOMeter.SetRange(0, iMaxDlGraph, 2);
	m_DownloadOMeter.SetYUnits(GetResString(IDS_KBYTESEC));
	//m_DownloadOMeter.SetXUnits(GetResString(IDS_TIME));
	CSize sDlMeter[2];
	sDlMeter[0].cx = 100 * rect.left / rClient.Width();
	sDlMeter[0].cy = 100 * rect.top / rClient.Height();
	sDlMeter[1].cx = 100 * rect.right / rClient.Width();
	sDlMeter[1].cy = 100 * rect.bottom / rClient.Width();

	// Setup upload scope
	GetDlgItem(IDC_SCOPE_U)->GetWindowRect(rect);
	ScreenToClient(rect);
	m_UploadOMeter.Create(WS_VISIBLE | WS_CHILD, rect, this);
	m_UploadOMeter.SetRange(0, iMaxUlGraph, 0);
	m_UploadOMeter.SetRange(0, iMaxUlGraph, 1);
	m_UploadOMeter.SetRange(0, iMaxUlGraph, 2);
	m_UploadOMeter.SetYUnits(GetResString(IDS_KBYTESEC));
	//m_UploadOMeter.SetXUnits(GetResString(IDS_TIME));
	CSize sUpMeter[2];
	sUpMeter[0].cx = 100 * rect.left / rClient.Width();
	sUpMeter[0].cy = 100 * rect.top / rClient.Height();
	sUpMeter[1].cx = 100 * rect.right / rClient.Width();
	sUpMeter[1].cy = 100 * rect.bottom / rClient.Height();

	// Setup connections scope
	GetDlgItem(IDC_STATSSCOPE)->GetWindowRect(rect) ;
	ScreenToClient(rect) ;
	m_Statistics.Create(WS_VISIBLE | WS_CHILD, rect, this) ;
	m_Statistics.SetRanges(0, g_eMuleApp.m_pGlobPrefs->GetStatsMax());
	m_Statistics.autofitYscale=false; // DonGato
	m_Statistics.SetYUnits(_T("")) ;
	m_Statistics.SetXUnits(GetResString(IDS_TIME));

	CSize sStatistics[2];
	sStatistics[0].cx = 100 * rect.left / rClient.Width();
	sStatistics[0].cy = 100 * rect.top / rClient.Height();
	sStatistics[1].cx = 100 * rect.right / rClient.Width();
	sStatistics[1].cy = 100 * rect.bottom  / rClient.Height();

	oldRatio=g_eMuleApp.m_pGlobPrefs->GetGraphRatio();		//Cax2 - Resize active connections line...

	RepaintMeters();

	m_DownloadOMeter.InvalidateCtrl();
	m_UploadOMeter.InvalidateCtrl();
	m_Statistics.InvalidateCtrl();

	if (g_eMuleApp.m_pGlobPrefs->GetStatsInterval()==0) GetDlgItem(IDC_STATTREE)->EnableWindow(false);

	UpdateData(FALSE);

	m_ilastMaxConnReached = 0;
	peakconnections = 0;
	totalconnectionchecks = 0;
	averageconnections = 0;
	activeconnections = 0;
	maxDown=0;
	maxDownavg=0;
	maxUp =					0;
	maxUpavg =				0;
	rateDown =				0;
	rateUp =				0;
	timeTransfers =			0;
	timeDownloads =			0;
	timeUploads =			0;
	start_timeTransfers =	0;
	start_timeDownloads =	0;
	start_timeUploads =		0;
	time_thisTransfer =		0;
	time_thisDownload =		0;
	time_thisUpload =		0;
	timeServerDuration =	0;
	time_thisServerDuration=0;
	cntDelay =				0;
	cum_DL_maximal =		g_eMuleApp.m_pGlobPrefs->GetConnMaxDownRate();
	cum_DL_average =		g_eMuleApp.m_pGlobPrefs->GetConnAvgDownRate();
	cum_DL_max_average =	g_eMuleApp.m_pGlobPrefs->GetConnMaxAvgDownRate();

	cum_UL_maximal =		g_eMuleApp.m_pGlobPrefs->GetConnMaxUpRate();
	cum_UL_average =		g_eMuleApp.m_pGlobPrefs->GetConnAvgUpRate();
	cum_UL_max_average =	g_eMuleApp.m_pGlobPrefs->GetConnMaxAvgUpRate();

	AddAnchor(IDC_STATTREE,TOP_LEFT, BOTTOM_CENTER );

	AddAnchor(IDC_SCOPE_D, TOP_CENTER, CSize(100,34));
	AddAnchor(m_DownloadOMeter.m_hWnd, TOP_CENTER, CSize(100,34));
	AddAnchor(IDC_SCOPE_U, CSize(50,34), CSize(100,68));
	AddAnchor(m_UploadOMeter.m_hWnd, CSize(50,34), CSize(100,68));
	AddAnchor(IDC_STATSSCOPE, CSize(50,68), BOTTOM_RIGHT);
	AddAnchor(m_Statistics.m_hWnd, CSize(50,68), BOTTOM_RIGHT);

	AddAnchor(IDC_STATIC_D3, TOP_CENTER);
	AddAnchor(IDC_C0, TOP_RIGHT);
	AddAnchor(IDC_STATIC_D, TOP_RIGHT);
	AddAnchor(IDC_C0_3, TOP_RIGHT);
	AddAnchor(IDC_TIMEAVG1, TOP_RIGHT);
	AddAnchor(IDC_C0_2, TOP_RIGHT);
	AddAnchor(IDC_STATIC_D2, TOP_RIGHT);
	AddAnchor(m_Led1[0].m_hWnd, TOP_RIGHT);
	AddAnchor(m_Led1[1].m_hWnd, TOP_RIGHT);
	AddAnchor(m_Led1[2].m_hWnd, TOP_RIGHT);

	AddAnchor(IDC_STATIC_U, CSize(50,34));
	AddAnchor(IDC_C1, CSize(100,34));
	AddAnchor(IDC_STATIC_U2, CSize(100,34));
	AddAnchor(IDC_C1_3, CSize(100,34));
	AddAnchor(IDC_TIMEAVG2, CSize(100,34));
	AddAnchor(IDC_C1_2, CSize(100,34));
	AddAnchor(IDC_STATIC_U3, CSize(100,34));
	AddAnchor(m_Led2[0].m_hWnd, CSize(100,34));
	AddAnchor(m_Led2[1].m_hWnd, CSize(100,34));
	AddAnchor(m_Led2[2].m_hWnd, CSize(100,34));

	AddAnchor(IDC_STATIC_A, CSize(50,68));
	AddAnchor(IDC_S3, CSize(100,68));
	AddAnchor(IDC_STATIC_S2, CSize(100,68));
	AddAnchor(IDC_S0, CSize(100,68));
	AddAnchor(IDC_STATIC_S0, CSize(100,68));
	AddAnchor(IDC_S1, CSize(100,68));
	AddAnchor(IDC_STATIC_S1, CSize(100,68));
	AddAnchor(m_Led3[1].m_hWnd, CSize(100,68));
	AddAnchor(m_Led3[0].m_hWnd, CSize(100,68));
	AddAnchor(m_Led3[2].m_hWnd, CSize(100,68));

#ifdef OLD_SOCKETS_ENABLED
	ShowStatistics(true);
#endif //OLD_SOCKETS_ENABLED

	// <-----khaos-
	m_oldcx=0;
	m_oldcy=0;

	EnableWindow(TRUE);

	return true;

	EMULE_CATCH

	return false;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// -khaos--+++> This function is going to basically calculate and save a bunch of averages.
//				I made a seperate funtion so that it would always run instead of having
//				the averages not be calculated if the graphs are disabled (Which is bad!).
void CStatisticsDlg::UpdateConnectionStats (double uploadrate, double downloadrate)
{
	// Can't do anything before OnInitDialog
	if(!m_hWnd)
		return;

	rateUp = uploadrate;
	rateDown = downloadrate;

	if (maxUp<uploadrate) maxUp=uploadrate;
	if (cum_UL_maximal<maxUp)
	{
		cum_UL_maximal=maxUp;
		g_eMuleApp.m_pGlobPrefs->Add2ConnMaxUpRate(cum_UL_maximal);
	}

	if (maxDown<downloadrate) maxDown=downloadrate; // MOVED from SetCurrentRate!
	if (cum_DL_maximal < maxDown)
	{
		cum_DL_maximal=maxDown;
		g_eMuleApp.m_pGlobPrefs->Add2ConnMaxDownRate(cum_DL_maximal);
	}

	cum_DL_average = GetAvgDownloadRate(AVG_TOTAL);
	if (cum_DL_max_average<cum_DL_average)
	{
		cum_DL_max_average=cum_DL_average;
		g_eMuleApp.m_pGlobPrefs->Add2ConnMaxAvgDownRate(cum_DL_max_average);
	}

	cum_UL_average = GetAvgUploadRate(AVG_TOTAL);
	if (cum_UL_max_average<cum_UL_average)
	{
		cum_UL_max_average=cum_UL_average;
		g_eMuleApp.m_pGlobPrefs->Add2ConnMaxAvgUpRate(cum_UL_max_average);
	}


	// Transfer Times (Increment Session)
	if (uploadrate > 0 || downloadrate > 0)
	{
		if (start_timeTransfers == 0) start_timeTransfers = GetTickCount();
		else time_thisTransfer = (GetTickCount() - start_timeTransfers) / 1000;

		if (uploadrate > 0)
		{
			if (start_timeUploads == 0) start_timeUploads = GetTickCount();
			else time_thisUpload = (GetTickCount() - start_timeUploads) / 1000;
		}

		if (downloadrate > 0)
		{
			if (start_timeDownloads == 0) start_timeDownloads = GetTickCount();
			else time_thisDownload = (GetTickCount() - start_timeDownloads) / 1000;
		}
	}

	if (uploadrate == 0 && downloadrate == 0 && (time_thisTransfer > 0 || start_timeTransfers > 0))
	{
		timeTransfers += time_thisTransfer;
		time_thisTransfer = 0;
		start_timeTransfers = 0;
	}

	if (uploadrate == 0 && (time_thisUpload > 0 || start_timeUploads > 0))
	{
		timeUploads += time_thisUpload;
		time_thisUpload = 0;
		start_timeUploads = 0;
	}

	if (downloadrate == 0 && (time_thisDownload > 0 || start_timeDownloads > 0))
	{
		timeDownloads += time_thisDownload;
		time_thisDownload = 0;
		start_timeDownloads = 0;
	}

	// Server Durations
	if (g_eMuleApp.stat_serverConnectTime==0) time_thisServerDuration = 0;
	else time_thisServerDuration = ( GetTickCount() - g_eMuleApp.stat_serverConnectTime ) / 1000;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// -khaos--+++> Completely rewritten ShowStatistics
void CStatisticsDlg::ShowStatistics(bool forceUpdate)
{
	stattree.SetRedraw(false);

	CString	cbuffer;
	uint64	myBigStats[STATS_DL_DATA_INFO];
	uint16	myStats[STATS_DL_SOURCES_TYPE];
	// Set Tree Values

	// TRANSFER SECTION
	// If a section is not expanded, don't waste CPU cycles updating it.
	if (forceUpdate || stattree.IsExpanded(h_transfer))
	{
		uint32	statGoodSessions =				0;
		uint32	statBadSessions =				0;
		double	percentSessions =				0;
		// Transfer Ratios
		if ( g_eMuleApp.stat_sessionReceivedBytes>0 && g_eMuleApp.stat_sessionSentBytes>0 )
		{
			// Session
			if (g_eMuleApp.stat_sessionReceivedBytes<g_eMuleApp.stat_sessionSentBytes)
			{
				cbuffer.Format("%s %.2f : 1",GetResString(IDS_STATS_SRATIO),static_cast<double>(g_eMuleApp.stat_sessionSentBytes)/g_eMuleApp.stat_sessionReceivedBytes);
				stattree.SetItemText(trans[0], cbuffer);
			}
			else
			{
				cbuffer.Format("%s 1 : %.2f",GetResString(IDS_STATS_SRATIO),static_cast<double>(g_eMuleApp.stat_sessionReceivedBytes)/g_eMuleApp.stat_sessionSentBytes);
				stattree.SetItemText(trans[0], cbuffer);
			}
		}
		else
		{
			cbuffer.Format("%s %s", GetResString(IDS_STATS_SRATIO), GetResString(IDS_FSTAT_WAITING));
			stattree.SetItemText(trans[0], cbuffer);
		}
		if ( (g_eMuleApp.m_pGlobPrefs->GetTotalDownloaded()>0 && g_eMuleApp.m_pGlobPrefs->GetTotalUploaded()>0) || (g_eMuleApp.stat_sessionReceivedBytes>0 && g_eMuleApp.stat_sessionSentBytes>0) )
		{
			// Cumulative
			if ((g_eMuleApp.stat_sessionReceivedBytes+g_eMuleApp.m_pGlobPrefs->GetTotalDownloaded())<(g_eMuleApp.stat_sessionSentBytes+g_eMuleApp.m_pGlobPrefs->GetTotalUploaded()))
			{
				cbuffer.Format("%s %.2f : 1",GetResString(IDS_STATS_CRATIO),static_cast<double>(g_eMuleApp.stat_sessionSentBytes+g_eMuleApp.m_pGlobPrefs->GetTotalUploaded())/(g_eMuleApp.stat_sessionReceivedBytes+g_eMuleApp.m_pGlobPrefs->GetTotalDownloaded()));
				stattree.SetItemText(trans[1], cbuffer);
			}
			else
			{
				cbuffer.Format("%s 1 : %.2f",GetResString(IDS_STATS_CRATIO),static_cast<double>(g_eMuleApp.stat_sessionReceivedBytes+g_eMuleApp.m_pGlobPrefs->GetTotalDownloaded())/(g_eMuleApp.stat_sessionSentBytes+g_eMuleApp.m_pGlobPrefs->GetTotalUploaded()));
				stattree.SetItemText(trans[1], cbuffer);
			}
		}
		else
		{
			cbuffer.Format("%s %s", GetResString(IDS_STATS_CRATIO), GetResString(IDS_FSTAT_WAITING));
			stattree.SetItemText(trans[1], cbuffer);
		}
		// TRANSFER -> DOWNLOADS SECTION
		if (forceUpdate || stattree.IsExpanded(h_download))
		{
			uint64	DownOHTotal = 0;
			uint64	DownOHTotalPackets = 0;
			g_eMuleApp.m_pDownloadQueue->GetDownloadStats(myStats, myBigStats);
			// TRANSFER -> DOWNLOADS -> SESSION SECTION
			if (forceUpdate || stattree.IsExpanded(h_down_session))
			{
				// Downloaded Data
				cbuffer.Format( "%s: %s", GetResString( IDS_STATS_DDATA ) , CastItoXBytes( g_eMuleApp.stat_sessionReceivedBytes ) );
				stattree.SetItemText( down_S[0] , cbuffer );
				if (forceUpdate || stattree.IsExpanded(down_S[0]))
				{
					// Downloaded Data By Client
					if (forceUpdate || stattree.IsExpanded(hdown_scb))
					{
						uint64 DownDataTotal = g_eMuleApp.m_pGlobPrefs->GetDownSessionClientData();
						uint64 DownDataClient = 0;
						double percentClientTransferred = 0;
						int i = 0;
						for (int j = 0;j<SO_LAST;j++)
							if ((EnumClientTypes)j != SO_OLDEMULE)
							{
								if ((EnumClientTypes)j == SO_EMULE)
									DownDataClient = g_eMuleApp.m_pGlobPrefs->GetDownData((EnumClientTypes)j)
													+ g_eMuleApp.m_pGlobPrefs->GetDownData(SO_OLDEMULE);
								else
									DownDataClient = g_eMuleApp.m_pGlobPrefs->GetDownData((EnumClientTypes)j);
								if ( DownDataTotal!=0 && DownDataClient!=0 )
									percentClientTransferred = (double) 100 * DownDataClient / DownDataTotal;
								else
									percentClientTransferred = 0;
								cbuffer.Format( "%s: %s (%1.1f%%)" , GetClientNameString((EnumClientTypes)j), CastItoXBytes(DownDataClient) , percentClientTransferred);
								stattree.SetItemText( down_scb[i] , cbuffer );
								i++;
							}
					}
					// Downloaded Data By Port
					if (forceUpdate || stattree.IsExpanded(hdown_spb))
					{
						int i = 0;
						uint64	PortDataDefault =	g_eMuleApp.m_pGlobPrefs->GetDownDataPort_4662();
						uint64	PortDataOther =		g_eMuleApp.m_pGlobPrefs->GetDownDataPort_OTHER();
						uint64	PortDataTotal =		g_eMuleApp.m_pGlobPrefs->GetDownSessionDataPort();
						double	percentPortTransferred = 0;

						if ( PortDataTotal!=0 && PortDataDefault!=0 )
							percentPortTransferred = (double) 100 * PortDataDefault / PortDataTotal;
						cbuffer.Format( "%s: %s (%1.1f%%)" , GetResString(IDS_STATS_PRTDEF) , CastItoXBytes( PortDataDefault ) , percentPortTransferred);
						stattree.SetItemText( down_spb[i] , cbuffer ); i++;

						if ( PortDataTotal!=0 && PortDataOther!=0 )
							percentPortTransferred = (double) 100 * PortDataOther / PortDataTotal;
						else
							percentPortTransferred = 0;
						cbuffer.Format( "%s: %s (%1.1f%%)" , GetResString(IDS_STATS_PRTOTHER) , CastItoXBytes( PortDataOther ) , percentPortTransferred);
						stattree.SetItemText( down_spb[i] , cbuffer ); i++;
					}
				}
				// Completed Downloads
				cbuffer.Format( "%s: %u" , GetResString( IDS_STATS_COMPDL ) , g_eMuleApp.m_pGlobPrefs->GetDownSessionCompletedFiles() );
				stattree.SetItemText( down_S[1] , cbuffer );
				// Active Downloads (not paused or stopped)
				cbuffer.Format( GetResString( IDS_DWTOT_NUM ) , g_eMuleApp.m_pDownloadQueue->GetActiveFileCount());
				stattree.SetItemText( down_S[2] , cbuffer );
				// Transferring Chunks
				cbuffer.Format( GetResString( IDS_STATS_ACTDL ) , myStats[1] );
				stattree.SetItemText( down_S[3] , cbuffer );
				// Total Size of Active Downloads
				cbuffer.Format( GetResString( IDS_DWTOT_TSD ) , CastItoXBytes(myBigStats[2]) );
				stattree.SetItemText( down_S[4] , cbuffer );
				// Total Size of All Downloads
				cbuffer.Format( GetResString( IDS_DWTOT_TSAD ) , CastItoXBytes(myBigStats[5]) );
				stattree.SetItemText( down_S[5] , cbuffer );
				// Total Size on Disk of All Downloads
				cbuffer.Format( GetResString( IDS_DWTOT_TSODAD ) , CastItoXBytes(myBigStats[9]) );
				stattree.SetItemText( down_S[6] , cbuffer );
				// Total Completed Size
				uint64 ui64BytesTransferred = (myBigStats[2]-myBigStats[3]);
				cbuffer.Format( GetResString( IDS_DWTOT_TCS ) , CastItoXBytes(ui64BytesTransferred), (myBigStats[2] != 0) ? (100*static_cast<double>(ui64BytesTransferred) / myBigStats[2]) : 0 );
				stattree.SetItemText( down_S[7] , cbuffer );
				// Total Size Left to Transfer
				cbuffer.Format( GetResString( IDS_DWTOT_TSL ) , CastItoXBytes(myBigStats[3]), (myBigStats[2] != 0) ? (100*static_cast<double>(myBigStats[3]) / myBigStats[2]) : 0 );
				stattree.SetItemText( down_S[8] , cbuffer );
				// Total Space Needed by Active Downloads
				cbuffer.Format( GetResString( IDS_DWTOT_TSN ) , CastItoXBytes(myBigStats[4]) );
				stattree.SetItemText( down_S[9] , cbuffer );
				// Total Space Needed by All Downloads
				cbuffer.Format( GetResString( IDS_DWTOT_TSNA ) , CastItoXBytes(myBigStats[6]) );
				stattree.SetItemText( down_S[10] , cbuffer );
				// Free Space on Tempdrive
				uint64 t_FreeBytes = GetFreeDiskSpaceX(g_eMuleApp.m_pGlobPrefs->GetTempDir().GetBuffer());
				if(myBigStats[4] > t_FreeBytes)
				{
					CString	cbuffer2;
					cbuffer2.Format( GetResString( IDS_DWTOT_FS ) , CastItoXBytes(t_FreeBytes) );
					cbuffer.Format( GetResString( IDS_NEEDFREEDISKSPACE ) , cbuffer2, CastItoXBytes(myBigStats[4] - t_FreeBytes) );
				}
				else
				{
					CString	cbuffer2;
					cbuffer2.Format( GetResString( IDS_DWTOT_FS ) , CastItoXBytes(t_FreeBytes) );
					cbuffer.Format( GetResString( IDS_FREEDISKSPACEAFTER ) , cbuffer2, CastItoXBytes(t_FreeBytes - myBigStats[4]) );
				}
				stattree.SetItemText( down_S[11] , cbuffer );
				// Found Sources
				cbuffer.Format( GetResString( IDS_STATS_FOUNDSRC ) , myStats[0] );
				stattree.SetItemText( down_S[12] , cbuffer );
				if (forceUpdate || stattree.IsExpanded(down_S[12]))
				{
					int i = 0;
					// Sources By Status
					cbuffer.Format( "%s: %u" , GetResString( IDS_ONQUEUE ) , myStats[2] );
					stattree.SetItemText( down_sources[i] , cbuffer ); i++;
					cbuffer.Format( "%s: %u" , GetResString( IDS_QUEUEFULL ) , myStats[3] );
					stattree.SetItemText( down_sources[i] , cbuffer ); i++;
					cbuffer.Format( "%s: %u" , GetResString( IDS_STATS_HIGHQR ) , myStats[17] );
					stattree.SetItemText( down_sources[i] , cbuffer ); i++;
					cbuffer.Format( "%s: %u" , GetResString( IDS_NONEEDEDPARTS ) , myStats[4] );
					stattree.SetItemText( down_sources[i] , cbuffer ); i++;
					cbuffer.Format( "%s: %u" , GetResString( IDS_ASKING ) , myStats[5] );
					stattree.SetItemText( down_sources[i] , cbuffer ); i++;
					cbuffer.Format( "%s: %u" , GetResString( IDS_RECHASHSET ) , myStats[6] );
					stattree.SetItemText( down_sources[i] , cbuffer ); i++;
					cbuffer.Format( "%s: %u" , GetResString( IDS_CONNECTING ) , myStats[7] );
					stattree.SetItemText( down_sources[i] , cbuffer ); i++;
					cbuffer.Format( "%s: %u" , GetResString(IDS_CONNVIASERVER) , myStats[8] );
					stattree.SetItemText( down_sources[i] , cbuffer ); i++;
					cbuffer.Format( "%s: %u" , GetResString(IDS_TOOMANYCONNS) , myStats[9] );
					stattree.SetItemText( down_sources[i] , cbuffer ); i++;
					cbuffer.Format( "%s: %u" , GetResString(IDS_NOCONNECTLOW2LOW) , myStats[10] );
					stattree.SetItemText( down_sources[i] , cbuffer ); i++;
					cbuffer.Format( "%s: %u" , GetResString(IDS_ASKED4ANOTHERFILE) , g_eMuleApp.m_pClientList->GetA4AFSourcesCount());
					stattree.SetItemText( down_sources[i] , cbuffer ); i++;
					cbuffer.Format( "%s: %u" , GetResString(IDS_STATS_NOUPLOAD) , myStats[18] );
					stattree.SetItemText( down_sources[i] , cbuffer ); i++;
					cbuffer.Format( "%s: %u" , GetResString(IDS_STATS_PROBLEMATIC) , myStats[12] );
					stattree.SetItemText( down_sources[i] , cbuffer ); i++;
					cbuffer.Format( "%s: %u" , GetResString(IDS_STATS_TIMEOUTED) , myStats[16] );
					stattree.SetItemText( down_sources[i] , cbuffer ); i++;
					cbuffer.Format( "%s: %u" , GetResString(IDS_BANNED) , myStats[13] );
					stattree.SetItemText( down_sources[i] , cbuffer ); i++;
					cbuffer.Format( "%s: %u" , GetResString(IDS_UNKNOWN) , myStats[11] );
					stattree.SetItemText( down_sources[i] , cbuffer ); i++;
				}
				// Set Download Sessions
				statGoodSessions =	g_eMuleApp.m_pGlobPrefs->GetDownS_SuccessfulSessions() + myStats[1]; // Add Active Downloads
				statBadSessions =	g_eMuleApp.m_pGlobPrefs->GetDownS_FailedSessions();
				cbuffer.Format( "%s: %u" , GetResString(IDS_STATS_DLSES) , statGoodSessions + statBadSessions );
				stattree.SetItemText( down_S[13] , cbuffer );
				if (forceUpdate || stattree.IsExpanded(down_S[13]))
				{
					// Set Successful Download Sessions and Average Downloaded Per Session
					percentSessions = 0;
					if (statGoodSessions > 0)
					{
						percentSessions = (double) 100 * statGoodSessions / (statGoodSessions + statBadSessions);
						cbuffer.Format( "%s: %s" , GetResString(IDS_STATS_AVGDATADLSES) , CastItoXBytes( (uint64) g_eMuleApp.stat_sessionReceivedBytes / statGoodSessions ) );
					}
					else cbuffer.Format( "%s: %s" , GetResString(IDS_STATS_AVGDATADLSES) , CastItoXBytes(0) );
					stattree.SetItemText( down_ssessions[2] , cbuffer ); // Set Avg DL/Session
					cbuffer.Format( "%s: %u (%1.1f%%)" , GetResString(IDS_STATS_SDLSES) , statGoodSessions , percentSessions );
					stattree.SetItemText( down_ssessions[0] , cbuffer ); // Set Succ Sessions
					// Set Failed Download Sessions (Avoid Division)
					if (percentSessions != 0 && statBadSessions > 0) percentSessions = 100 - percentSessions; // There were some good sessions and bad ones...
					else if (percentSessions == 0 && statBadSessions > 0) percentSessions = 100; // There were bad sessions and no good ones, must be 100%
					else percentSessions = 0; // No sessions at all, or no bad ones.
					cbuffer.Format( "%s: %u (%1.1f%%)" , GetResString(IDS_STATS_FDLSES) , statBadSessions , percentSessions );
					stattree.SetItemText( down_ssessions[1] , cbuffer );
					// Set Average Download Time
					cbuffer.Format("%s: %s", GetResString(IDS_STATS_AVGDLTIME), CastSecondsToLngHM(g_eMuleApp.m_pGlobPrefs->GetDownS_AvgTime()));
					stattree.SetItemText( down_ssessions[3] , cbuffer );
				}
				// Set Gain Due To Compression
				cbuffer.Format( GetResString( IDS_STATS_GAINCOMP ) , CastItoXBytes( myBigStats[1] ) );
				stattree.SetItemText( down_S[14] , cbuffer );
				// Set Lost Due To Corruption
				cbuffer.Format( GetResString( IDS_STATS_LOSTCORRUPT ) , CastItoXBytes( myBigStats[0] ) );
				stattree.SetItemText( down_S[15] , cbuffer );
				// Set Parts Saved Due To ICH
				cbuffer.Format( GetResString( IDS_STATS_ICHSAVED ) , myStats[14] );
				stattree.SetItemText( down_S[16] , cbuffer );

				// Calculate downline OH totals
				DownOHTotal = g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadFileRequest() + g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadSourceExchange() + g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadServer() + g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadOther();
				DownOHTotalPackets = g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadFileRequestPackets() + g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadSourceExchangePackets() + g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadServerPackets() + g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadOtherPackets();

				// Downline Overhead
				cbuffer.Format( GetResString( IDS_TOVERHEAD ) , CastItoXBytes( DownOHTotal ) , CastItoIShort( DownOHTotalPackets ) );
				stattree.SetItemText( hdown_soh , cbuffer );
				if (forceUpdate || stattree.IsExpanded(hdown_soh))
				{
					int i = 0;
					// Set down session file req OH
					cbuffer.Format( GetResString( IDS_FROVERHEAD ) , CastItoXBytes( g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadFileRequest() ) , CastItoIShort( g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadFileRequestPackets() ) );
					stattree.SetItemText( down_soh[i] , cbuffer ); i++;
					// Set down session source exch OH
					cbuffer.Format( GetResString( IDS_SSOVERHEAD ) , CastItoXBytes( g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadSourceExchange() ), CastItoIShort( g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadSourceExchangePackets() ) );
					stattree.SetItemText( down_soh[i] , cbuffer ); i++;
					// Set down session server OH
					cbuffer.Format( GetResString( IDS_SOVERHEAD ) , CastItoXBytes( g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadServer() ), CastItoIShort( g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadServerPackets() ) );
					stattree.SetItemText( down_soh[i] , cbuffer ); i++;
					// Set down session others OH
					cbuffer.Format( GetResString( IDS_OOVERHEAD ) , CastItoXBytes( g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadOther() ), CastItoIShort( g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadOtherPackets() ) );
					stattree.SetItemText( down_soh[i] , cbuffer ); i++;
				}

			}
			// TRANSFER -> DOWNLOADS -> CUMULATIVE SECTION
			if (forceUpdate || stattree.IsExpanded(h_down_total))
			{
				// Downloaded Data
				cbuffer.Format("%s: %s",GetResString(IDS_STATS_DDATA),CastItoXBytes( g_eMuleApp.stat_sessionReceivedBytes+g_eMuleApp.m_pGlobPrefs->GetTotalDownloaded() ));
				stattree.SetItemText(down_T[0], cbuffer);
				if (forceUpdate || stattree.IsExpanded(down_T[0]))
				{
					// Downloaded Data By Client
					if (forceUpdate || stattree.IsExpanded(hdown_tcb))
					{
						uint64 DownDataTotal = g_eMuleApp.m_pGlobPrefs->GetDownTotalClientData();
						uint64 DownDataClient = 0;
						double percentClientTransferred = 0;
						//eklmn: sequence was replaced to loop...
						int i = 0;
						for (int j = 0;j<SO_LAST;j++)
							if ((EnumClientTypes)j != SO_OLDEMULE)
							{
								if ((EnumClientTypes)j == SO_EMULE)
									DownDataClient = g_eMuleApp.m_pGlobPrefs->GetCumDownData((EnumClientTypes)j)
													+ g_eMuleApp.m_pGlobPrefs->GetCumDownData(SO_OLDEMULE);
								else
									DownDataClient = g_eMuleApp.m_pGlobPrefs->GetCumDownData((EnumClientTypes)j);
								if ( DownDataTotal!=0 && DownDataClient!=0 )
									percentClientTransferred = (double) 100 * DownDataClient / DownDataTotal;
								else
									percentClientTransferred = 0;
								cbuffer.Format( "%s: %s (%1.1f%%)" , GetClientNameString((EnumClientTypes)j), CastItoXBytes(DownDataClient) , percentClientTransferred);
								stattree.SetItemText( down_tcb[i] , cbuffer );
								i++;
							}
					}
					// Downloaded Data By Port
					if (forceUpdate || stattree.IsExpanded(hdown_tpb))
					{
						int i = 0;
						uint64	PortDataDefault =	g_eMuleApp.m_pGlobPrefs->GetCumDownDataPort_4662();
						uint64	PortDataOther =		g_eMuleApp.m_pGlobPrefs->GetCumDownDataPort_OTHER();
						uint64	PortDataTotal =		g_eMuleApp.m_pGlobPrefs->GetDownTotalPortData();
						double	percentPortTransferred = 0;

						if ( PortDataTotal!=0 && PortDataDefault!=0 )
							percentPortTransferred = (double) 100 * PortDataDefault / PortDataTotal;
						cbuffer.Format( "%s: %s (%1.1f%%)" , GetResString(IDS_STATS_PRTDEF) , CastItoXBytes( PortDataDefault ) , percentPortTransferred);
						stattree.SetItemText( down_tpb[i] , cbuffer ); i++;

						if ( PortDataTotal!=0 && PortDataOther!=0 )
							percentPortTransferred = (double) 100 * PortDataOther / PortDataTotal;
						else
							percentPortTransferred = 0;
						cbuffer.Format( "%s: %s (%1.1f%%)" , GetResString(IDS_STATS_PRTOTHER), CastItoXBytes( PortDataOther ) , percentPortTransferred);
						stattree.SetItemText( down_tpb[i] , cbuffer ); i++;
					}
				}
				// Set Cum Completed Downloads
				cbuffer.Format("%s: %u", GetResString(IDS_STATS_COMPDL), g_eMuleApp.m_pGlobPrefs->GetDownCompletedFiles() );
				stattree.SetItemText(down_T[1], cbuffer);
				// Set Cum Download Sessions
				statGoodSessions = g_eMuleApp.m_pGlobPrefs->GetDownC_SuccessfulSessions() + myStats[1]; // Need to reset these from the session section.  Declared up there.
				statBadSessions = g_eMuleApp.m_pGlobPrefs->GetDownC_FailedSessions(); // ^^^^^^^^^^^^^^
				cbuffer.Format("%s: %u", GetResString(IDS_STATS_DLSES), statGoodSessions+statBadSessions );
				stattree.SetItemText(down_T[2], cbuffer);
				if (forceUpdate || stattree.IsExpanded(down_T[2]))
				{
					// Set Cum Successful Download Sessions & Cum Average Download Per Sessions (Save an if-else statement)
					if (statGoodSessions > 0)
					{
						percentSessions = (double) 100 * statGoodSessions / (statGoodSessions + statBadSessions);
						cbuffer.Format( "%s: %s" , GetResString(IDS_STATS_AVGDATADLSES) , CastItoXBytes( (uint64) (g_eMuleApp.stat_sessionReceivedBytes + g_eMuleApp.m_pGlobPrefs->GetTotalDownloaded()) / statGoodSessions ) );
					}
					else
					{
						percentSessions = 0;
						cbuffer.Format( "%s: %s" , GetResString(IDS_STATS_AVGDATADLSES) , CastItoXBytes(0) );
					}
					stattree.SetItemText( down_tsessions[2] , cbuffer ); // Set Avg DL/Session
					cbuffer.Format( "%s: %u (%1.1f%%)", GetResString(IDS_STATS_SDLSES) , statGoodSessions , percentSessions );
					stattree.SetItemText( down_tsessions[0] , cbuffer ); // Set Successful Sessions
					// Set Cum Failed Download Sessions
					if (percentSessions != 0 && statBadSessions > 0) percentSessions = 100 - percentSessions; // There were some good sessions and bad ones...
					else if (percentSessions == 0 && statBadSessions > 0) percentSessions = 100; // There were bad sessions and no good ones, must be 100%
					else percentSessions = 0; // No sessions at all, or no bad ones.
					cbuffer.Format( "%s: %u (%1.1f%%)" , GetResString(IDS_STATS_FDLSES) , statBadSessions , percentSessions);
					stattree.SetItemText( down_tsessions[1] , cbuffer );
					// Set Cumulative Average Download Time
					uint32 avgDownTime = g_eMuleApp.m_pGlobPrefs->GetDownS_AvgTime();
					if (g_eMuleApp.m_pGlobPrefs->GetDownC_AvgTime()<=0) g_eMuleApp.m_pGlobPrefs->Add2DownCAvgTime(avgDownTime);
					avgDownTime = (uint32) (avgDownTime+g_eMuleApp.m_pGlobPrefs->GetDownC_AvgTime())/2;
					cbuffer.Format("%s: %s", GetResString(IDS_STATS_AVGDLTIME), CastSecondsToLngHM(avgDownTime));
					stattree.SetItemText(down_tsessions[3], cbuffer);
				}
				// Set Cumulative Gained Due To Compression
				cbuffer.Format( GetResString( IDS_STATS_GAINCOMP ) , CastItoXBytes( myBigStats[8] + g_eMuleApp.m_pGlobPrefs->GetSavedFromCompression() ) );
				stattree.SetItemText( down_T[3] , cbuffer );
				// Set Cumulative Lost Due To Corruption
				cbuffer.Format( GetResString( IDS_STATS_LOSTCORRUPT ) , CastItoXBytes( myBigStats[7] + g_eMuleApp.m_pGlobPrefs->GetLostFromCorruption() ) );
				stattree.SetItemText( down_T[4] , cbuffer );
				// Set Cumulative Saved Due To ICH
				cbuffer.Format( GetResString( IDS_STATS_ICHSAVED ) , myStats[14] + g_eMuleApp.m_pGlobPrefs->GetPartsSavedByICH() );
				stattree.SetItemText( down_T[5] , cbuffer );

				if (DownOHTotal == 0 || DownOHTotalPackets == 0)
				{
					DownOHTotal = g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadFileRequest() + g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadSourceExchange() + g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadServer() + g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadOther();
					DownOHTotalPackets = g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadFileRequestPackets() + g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadSourceExchangePackets() + g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadServerPackets() + g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadOtherPackets();
				}
				// Total Overhead
				cbuffer.Format(GetResString(IDS_TOVERHEAD),CastItoXBytes(DownOHTotal + g_eMuleApp.m_pGlobPrefs->GetDownOverheadTotal()), CastItoIShort(DownOHTotalPackets + g_eMuleApp.m_pGlobPrefs->GetDownOverheadTotalPackets()));
				stattree.SetItemText(hdown_toh, cbuffer);
				if (forceUpdate || stattree.IsExpanded(hdown_toh))
				{
					int i = 0;
					// File Request Overhead
					cbuffer.Format(GetResString(IDS_FROVERHEAD), CastItoXBytes( g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadFileRequest() + g_eMuleApp.m_pGlobPrefs->GetDownOverheadFileReq()), CastItoIShort(g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadFileRequestPackets() + g_eMuleApp.m_pGlobPrefs->GetDownOverheadFileReqPackets()));
					stattree.SetItemText(down_toh[i], cbuffer); i++;
					// Source Exchange Overhead
					cbuffer.Format(GetResString(IDS_SSOVERHEAD), CastItoXBytes( g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadSourceExchange()+g_eMuleApp.m_pGlobPrefs->GetDownOverheadSrcEx()), CastItoIShort(g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadSourceExchangePackets()+g_eMuleApp.m_pGlobPrefs->GetDownOverheadSrcExPackets()));
					stattree.SetItemText(down_toh[i], cbuffer); i++;
					// Server Overhead
					cbuffer.Format(GetResString(IDS_SOVERHEAD), CastItoXBytes( g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadServer()+g_eMuleApp.m_pGlobPrefs->GetDownOverheadServer()), CastItoIShort(g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadServerPackets()+g_eMuleApp.m_pGlobPrefs->GetDownOverheadServerPackets()));
					stattree.SetItemText(down_toh[i], cbuffer); i++;
					// Others Overhead
					cbuffer.Format(GetResString(IDS_OOVERHEAD), CastItoXBytes( g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadOther()+g_eMuleApp.m_pGlobPrefs->GetDownOverheadOther()), CastItoIShort(g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadOtherPackets()+g_eMuleApp.m_pGlobPrefs->GetDownOverheadOtherPackets()));
					stattree.SetItemText(down_toh[i], cbuffer); i++;
				}
			} // - End Transfer -> Downloads -> Cumulative Section
		} // - End Transfer -> Downloads Section
		// TRANSFER-> UPLOADS SECTION
		if (forceUpdate || stattree.IsExpanded(h_upload))
		{
			uint64 UpOHTotal =			0;
			uint64 UpOHTotalPackets =	0;
			// TRANSFER -> UPLOADS -> SESSION SECTION
			if (forceUpdate || stattree.IsExpanded(h_up_session))
			{
				// Uploaded Data
				cbuffer.Format("%s: %s",GetResString(IDS_STATS_UDATA),CastItoXBytes(g_eMuleApp.stat_sessionSentBytes));
				stattree.SetItemText(up_S[0], cbuffer);
				if (forceUpdate || stattree.IsExpanded(up_S[0]))
				{
					// Uploaded Data By Client
					if (forceUpdate || stattree.IsExpanded(hup_scb))
					{
						uint64 UpDataTotal =	g_eMuleApp.m_pGlobPrefs->GetUpSessionClientData();
						uint64 UpDataClient = 0;
						double percentClientTransferred = 0;
						//eklmn: sequence was replaced to loop...
						int i = 0;
						for (int j = 0;j<SO_LAST;j++)
							if ((EnumClientTypes)j != SO_OLDEMULE)
							{
								if ((EnumClientTypes)j == SO_EMULE)
									UpDataClient = g_eMuleApp.m_pGlobPrefs->GetUpData((EnumClientTypes)j)
													+ g_eMuleApp.m_pGlobPrefs->GetUpData(SO_OLDEMULE);
								else
									UpDataClient = g_eMuleApp.m_pGlobPrefs->GetUpData((EnumClientTypes)j);
								if ( UpDataTotal!=0 && UpDataClient!=0 )
									percentClientTransferred = (double) 100 * UpDataClient / UpDataTotal;
								else
									percentClientTransferred = 0;
								cbuffer.Format( "%s: %s (%1.1f%%)" , GetClientNameString((EnumClientTypes)j), CastItoXBytes(UpDataClient) , percentClientTransferred);
								stattree.SetItemText( up_scb[i] , cbuffer );
								i++;
							}
					}
					// Uploaded Data By Port
					if (forceUpdate || stattree.IsExpanded(hup_spb))
					{
						int i = 0;
						uint64	PortDataDefault =	g_eMuleApp.m_pGlobPrefs->GetUpDataPort_4662();
						uint64	PortDataOther =		g_eMuleApp.m_pGlobPrefs->GetUpDataPort_OTHER();
						uint64	PortDataTotal =		g_eMuleApp.m_pGlobPrefs->GetUpSessionPortData();
						double	percentPortTransferred = 0;

						if ( PortDataTotal!=0 && PortDataDefault!=0 )
							percentPortTransferred = (double) 100 * PortDataDefault / PortDataTotal;
						cbuffer.Format( "%s: %s (%1.1f%%)" , GetResString(IDS_STATS_PRTDEF) , CastItoXBytes( PortDataDefault ) , percentPortTransferred);
						stattree.SetItemText( up_spb[i] , cbuffer ); i++;

						if ( PortDataTotal!=0 && PortDataOther!=0 )
							percentPortTransferred = (double) 100 * PortDataOther / PortDataTotal;
						else
							percentPortTransferred = 0;
						cbuffer.Format( "%s: %s (%1.1f%%)" , GetResString(IDS_STATS_PRTOTHER) , CastItoXBytes( PortDataOther ) , percentPortTransferred);
						stattree.SetItemText( up_spb[i] , cbuffer ); i++;
					}
					// Uploaded Data By Source
					if (forceUpdate || stattree.IsExpanded(hup_ssb))
					{
						int i = 0;
						uint64	DataSourceFile =	g_eMuleApp.m_pGlobPrefs->GetUpData_File();
						uint64	DataSourcePF =		g_eMuleApp.m_pGlobPrefs->GetUpData_PartFile();
						uint64	DataSourceTotal =		g_eMuleApp.m_pGlobPrefs->GetUpSessionDataFile();
						double	percentFileTransferred = 0;

						if ( DataSourceTotal!=0 && DataSourceFile!=0 )
							percentFileTransferred = (double) 100 * DataSourceFile / DataSourceTotal;
						cbuffer.Format( "%s: %s (%1.1f%%)" , GetResString(IDS_STATS_DSFILE) , CastItoXBytes( DataSourceFile ) , percentFileTransferred);
						stattree.SetItemText( up_ssb[i] , cbuffer ); i++;

						if ( DataSourceTotal!=0 && DataSourcePF!=0 )
							percentFileTransferred = (double) 100 * DataSourcePF / DataSourceTotal;
						else
							percentFileTransferred = 0;
						cbuffer.Format( "%s: %s (%1.1f%%)" , GetResString(IDS_STATS_DSPF) , CastItoXBytes( DataSourcePF ) , percentFileTransferred);
						stattree.SetItemText( up_ssb[i] , cbuffer ); i++;
					}
				}
				// Set Active Uploads
				cbuffer.Format(GetResString(IDS_STATS_ACTUL),g_eMuleApp.m_pUploadQueue->GetUploadQueueLength());
				stattree.SetItemText(up_S[1], cbuffer);
				// Set Queue Length
				cbuffer.Format(GetResString(IDS_STATS_WAITINGUSERS),g_eMuleApp.m_pUploadQueue->GetWaitingUserCount());
				stattree.SetItemText(up_S[2], cbuffer);

				// Set Upload Sessions
				statGoodSessions = g_eMuleApp.m_pUploadQueue->GetSuccessfulUpCount(); // + g_eMuleApp.m_pUploadQueue->GetUploadQueueLength();
				statBadSessions = g_eMuleApp.m_pUploadQueue->GetFailedUpCount();
				cbuffer.Format("%s: %u", GetResString(IDS_STATS_ULSES), statGoodSessions + statBadSessions);
				stattree.SetItemText(up_S[3], cbuffer);
				if (forceUpdate || stattree.IsExpanded(up_S[3]))
				{
					// Set Successful Upload Sessions & Average Uploaded Per Session
					uint32 statTotalSessions = statGoodSessions+statBadSessions;
					if (statGoodSessions>0)
					{
						percentSessions = (double) 100*(statGoodSessions+g_eMuleApp.m_pUploadQueue->GetUploadQueueLength())/(statGoodSessions+g_eMuleApp.m_pUploadQueue->GetUploadQueueLength()+statBadSessions);
						cbuffer.Format("%s: %s", GetResString(IDS_STATS_AVGDATAULSES), CastItoXBytes((uint64) g_eMuleApp.stat_sessionSentBytes / (statGoodSessions+g_eMuleApp.m_pUploadQueue->GetUploadQueueLength())) );
					}
					else
					{
						percentSessions = 0;
						cbuffer.Format( "%s: %s" , GetResString(IDS_STATS_AVGDATAULSES) , GetResString(IDS_FSTAT_WAITING) );
					}
					stattree.SetItemText(up_ssessions[2], cbuffer);
					// Successful sessions
					cbuffer.Format("%s: %u (%1.1f%%)",GetResString(IDS_STATS_SUCCUPCOUNT),statGoodSessions,GetPercent(statGoodSessions,statTotalSessions));
					stattree.SetItemText(up_ssessions[0], cbuffer);
					// chunks stasts
					cbuffer.Format("%s: %u (%1.1f%%)",GetResString(IDS_STATS_SUCCUP_FC),g_eMuleApp.m_pUploadQueue->GetULFullChunkCount(),GetPercent(g_eMuleApp.m_pUploadQueue->GetULFullChunkCount(),statTotalSessions));
					stattree.SetItemText(up_ssessions_s[0], cbuffer);
					cbuffer.Format("%s: %u (%1.1f%%)",GetResString(IDS_STATS_SUCCUP_PC),g_eMuleApp.m_pUploadQueue->GetULPartChunkCount(),GetPercent(g_eMuleApp.m_pUploadQueue->GetULPartChunkCount(),statTotalSessions));
					stattree.SetItemText(up_ssessions_s[1], cbuffer);
					//subtree for "part of chunk"
					for (int i = 0; i<ETS_TERMINATOR; i++)
					{
						cbuffer.Format("%s: %u (%1.1f%%)",GetUpEndReason((EnumEndTransferSession)i),
							g_eMuleApp.m_pUploadQueue->GetULPartChunkSubCount((EnumEndTransferSession)i),
							GetPercent(g_eMuleApp.m_pUploadQueue->GetULPartChunkSubCount((EnumEndTransferSession)i),statTotalSessions));
						stattree.SetItemText(up_ssessions_spc[i], cbuffer);
					}

					// Set Failed Upload Sessions
					cbuffer.Format("%s: %u (%1.1f%%)",GetResString(IDS_STATS_FAILUPCOUNT),statBadSessions,GetPercent(statBadSessions,statTotalSessions));
					stattree.SetItemText(up_ssessions[1], cbuffer);
					//subtree for "Failed"
					for (int i = 0; i<ETS_TERMINATOR; i++)
					{
						cbuffer.Format("%s: %u (%1.1f%%)",GetUpEndReason((EnumEndTransferSession)i),
							g_eMuleApp.m_pUploadQueue->GetFailedSubCount((EnumEndTransferSession)i),
							GetPercent(g_eMuleApp.m_pUploadQueue->GetFailedSubCount((EnumEndTransferSession)i),statTotalSessions));
						stattree.SetItemText(up_ssessions_f[i], cbuffer);
					}

					// Set Avg Upload time
					//DWORD running=g_eMuleApp.m_pUploadQueue->GetAverageUpTime();
					cbuffer.Format(GetResString(IDS_STATS_AVEUPTIME),CastSecondsToLngHM(g_eMuleApp.m_pUploadQueue->GetAverageUpTime()));
					stattree.SetItemText(up_ssessions[3], cbuffer);
				}
				// Calculate Upline OH Totals
				UpOHTotal = g_eMuleApp.m_pUploadQueue->GetUpDataOverheadFileRequest() + g_eMuleApp.m_pUploadQueue->GetUpDataOverheadSourceExchange() + g_eMuleApp.m_pUploadQueue->GetUpDataOverheadServer() + g_eMuleApp.m_pUploadQueue->GetUpDataOverheadOther();
				UpOHTotalPackets = g_eMuleApp.m_pUploadQueue->GetUpDataOverheadFileRequestPackets() + g_eMuleApp.m_pUploadQueue->GetUpDataOverheadSourceExchangePackets() + g_eMuleApp.m_pUploadQueue->GetUpDataOverheadServerPackets() + g_eMuleApp.m_pUploadQueue->GetUpDataOverheadOtherPackets();
				// Total Upline Overhead
				cbuffer.Format(GetResString(IDS_TOVERHEAD), CastItoXBytes( UpOHTotal), CastItoIShort(UpOHTotalPackets));
				stattree.SetItemText(hup_soh, cbuffer);
				if (forceUpdate || stattree.IsExpanded(hup_soh))
				{
					int i = 0;
					// File Request Overhead
					cbuffer.Format(GetResString(IDS_FROVERHEAD), CastItoXBytes( g_eMuleApp.m_pUploadQueue->GetUpDataOverheadFileRequest()), CastItoIShort(g_eMuleApp.m_pUploadQueue->GetUpDataOverheadFileRequestPackets()));
					stattree.SetItemText(up_soh[i], cbuffer); i++;
					// Source Exchanged Overhead
					cbuffer.Format(GetResString(IDS_SSOVERHEAD), CastItoXBytes( g_eMuleApp.m_pUploadQueue->GetUpDataOverheadSourceExchange()), CastItoIShort(g_eMuleApp.m_pUploadQueue->GetUpDataOverheadSourceExchangePackets()));
					stattree.SetItemText(up_soh[i], cbuffer); i++;
					// Server Overhead
					cbuffer.Format(GetResString(IDS_SOVERHEAD), CastItoXBytes( g_eMuleApp.m_pUploadQueue->GetUpDataOverheadServer()), CastItoIShort(g_eMuleApp.m_pUploadQueue->GetUpDataOverheadServerPackets()));
					stattree.SetItemText(up_soh[i], cbuffer); i++;
					// Others Overhead
					cbuffer.Format(GetResString(IDS_OOVERHEAD), CastItoXBytes( g_eMuleApp.m_pUploadQueue->GetUpDataOverheadOther()), CastItoIShort(g_eMuleApp.m_pUploadQueue->GetUpDataOverheadOtherPackets()));
					stattree.SetItemText(up_soh[i], cbuffer); i++;
				}
			} // - End Transfer -> Uploads -> Session Section
			// TRANSFER -> UPLOADS -> CUMULATIVE SECTION
			if (forceUpdate || stattree.IsExpanded(h_up_total))
			{

				// Uploaded Data
				cbuffer.Format("%s: %s",GetResString(IDS_STATS_UDATA),CastItoXBytes( g_eMuleApp.stat_sessionSentBytes+g_eMuleApp.m_pGlobPrefs->GetTotalUploaded()));
				stattree.SetItemText(up_T[0],cbuffer);
				if (forceUpdate || stattree.IsExpanded(up_T[0]))
				{
					// Uploaded Data By Client
					if (forceUpdate || stattree.IsExpanded(hup_tcb))
					{
						uint64 UpDataTotal =	g_eMuleApp.m_pGlobPrefs->GetUpTotalClientData();
						uint64 UpDataClient =	0;
						double percentClientTransferred = 0;
						int i = 0;
						//eklmn: sequence was replaced to loop...
						for (int j = 0;j<SO_LAST;j++)
							if ((EnumClientTypes)j != SO_OLDEMULE)
							{
								if ((EnumClientTypes)j == SO_EMULE)
									UpDataClient = g_eMuleApp.m_pGlobPrefs->GetCumUpData((EnumClientTypes)j)
													+ g_eMuleApp.m_pGlobPrefs->GetCumUpData(SO_OLDEMULE);
								else
									UpDataClient = g_eMuleApp.m_pGlobPrefs->GetCumUpData((EnumClientTypes)j);

								if ( UpDataTotal!=0 && UpDataClient!=0 )
									percentClientTransferred = (double) 100 * UpDataClient / UpDataTotal;
								else
									percentClientTransferred = 0;
								cbuffer.Format( "%s: %s (%1.1f%%)" , GetClientNameString((EnumClientTypes)j), CastItoXBytes(UpDataClient) , percentClientTransferred);
								stattree.SetItemText( up_tcb[i] , cbuffer );
								i++;
							}
					}
					// Uploaded Data By Port
					if (forceUpdate || stattree.IsExpanded(hup_tpb))
					{
						int i = 0;
						uint64	PortDataDefault =	g_eMuleApp.m_pGlobPrefs->GetCumUpDataPort_4662();
						uint64	PortDataOther =		g_eMuleApp.m_pGlobPrefs->GetCumUpDataPort_OTHER();
						uint64	PortDataTotal =		g_eMuleApp.m_pGlobPrefs->GetUpTotalPortData();
						double	percentPortTransferred = 0;

						if ( PortDataTotal!=0 && PortDataDefault!=0 )
							percentPortTransferred = (double) 100 * PortDataDefault / PortDataTotal;
						cbuffer.Format( "%s: %s (%1.1f%%)" , GetResString(IDS_STATS_PRTDEF) , CastItoXBytes( PortDataDefault ) , percentPortTransferred);
						stattree.SetItemText( up_tpb[i] , cbuffer ); i++;

						if ( PortDataTotal!=0 && PortDataOther!=0 )
							percentPortTransferred = (double) 100 * PortDataOther / PortDataTotal;
						else
							percentPortTransferred = 0;
						cbuffer.Format( "%s: %s (%1.1f%%)" , GetResString(IDS_STATS_PRTOTHER) , CastItoXBytes( PortDataOther ) , percentPortTransferred);
						stattree.SetItemText( up_tpb[i] , cbuffer ); i++;
					}
					// Uploaded Data By Source
					if (forceUpdate || stattree.IsExpanded(hup_tsb))
					{
						int i = 0;
						uint64	DataSourceFile =	g_eMuleApp.m_pGlobPrefs->GetCumUpData_File();
						uint64	DataSourcePF =		g_eMuleApp.m_pGlobPrefs->GetCumUpData_PartFile();
						uint64	DataSourceTotal =	g_eMuleApp.m_pGlobPrefs->GetUpTotalDataFile();
						double	percentFileTransferred = 0;

						if ( DataSourceTotal!=0 && DataSourceFile!=0 )
							percentFileTransferred = (double) 100 * DataSourceFile / DataSourceTotal;
						cbuffer.Format( "%s: %s (%1.1f%%)" , GetResString(IDS_STATS_DSFILE) , CastItoXBytes( DataSourceFile ) , percentFileTransferred);
						stattree.SetItemText( up_tsb[i] , cbuffer ); i++;

						if ( DataSourceTotal!=0 && DataSourcePF!=0 )
							percentFileTransferred = (double) 100 * DataSourcePF / DataSourceTotal;
						else
							percentFileTransferred = 0;
						cbuffer.Format( "%s: %s (%1.1f%%)" , GetResString(IDS_STATS_DSPF) , CastItoXBytes( DataSourcePF ) , percentFileTransferred);
						stattree.SetItemText( up_tsb[i] , cbuffer ); i++;
					}
				}
				// Upload Sessions
				statGoodSessions = g_eMuleApp.m_pUploadQueue->GetSuccessfulUpCount() + g_eMuleApp.m_pGlobPrefs->GetUpSuccessfulSessions() + g_eMuleApp.m_pUploadQueue->GetUploadQueueLength();
				statBadSessions = g_eMuleApp.m_pUploadQueue->GetFailedUpCount() + g_eMuleApp.m_pGlobPrefs->GetUpFailedSessions();
				cbuffer.Format("%s: %u", GetResString(IDS_STATS_ULSES), statGoodSessions + statBadSessions);
				stattree.SetItemText(up_T[1], cbuffer);
				if (forceUpdate || stattree.IsExpanded(up_T[1]))
				{
					// Set Successful Upload Sessions & Average Uploaded Per Session
					if (statGoodSessions>0)
					{ // Blackholes are when God divided by 0
						percentSessions = (double) 100*statGoodSessions/(statGoodSessions+statBadSessions);
						cbuffer.Format("%s: %s", GetResString(IDS_STATS_AVGDATAULSES), CastItoXBytes((uint64) (g_eMuleApp.stat_sessionSentBytes + g_eMuleApp.m_pGlobPrefs->GetTotalUploaded()) / statGoodSessions) );
					}
					else
					{
						percentSessions = 0;
						cbuffer.Format( "%s: %s" , GetResString(IDS_STATS_AVGDATAULSES) , GetResString(IDS_FSTAT_WAITING) );
					}
					stattree.SetItemText(up_tsessions[2], cbuffer);
					//cbuffer.Format(GetResString(IDS_STATS_SUCCUPCOUNT),statGoodSessions,percentSessions);
					cbuffer.Format("%s: %u (%1.1f%%)",GetResString(IDS_STATS_SUCCUPCOUNT),statGoodSessions,percentSessions);
					stattree.SetItemText(up_tsessions[0], cbuffer);
					// Set Failed Upload Sessions
					if (percentSessions != 0 && statBadSessions > 0) percentSessions = 100 - percentSessions; // There were some good sessions and bad ones...
					else if (percentSessions == 0 && statBadSessions > 0) percentSessions = 100; // There were bad sessions and no good ones, must be 100%
					else percentSessions = 0; // No sessions at all, or no bad ones.
					//cbuffer.Format(GetResString(IDS_STATS_FAILUPCOUNT),statBadSessions,percentSessions);
					cbuffer.Format("%s: %u (%1.1f%%)",GetResString(IDS_STATS_FAILUPCOUNT),statBadSessions,percentSessions);
					stattree.SetItemText(up_tsessions[1], cbuffer);
					// Set Avg Upload time
					uint32 avguptime = g_eMuleApp.m_pUploadQueue->GetAverageUpTime();
					if (g_eMuleApp.m_pGlobPrefs->GetUpAvgTime()<=0) g_eMuleApp.m_pGlobPrefs->Add2UpAvgTime(avguptime);
					avguptime = (uint32) (avguptime+g_eMuleApp.m_pGlobPrefs->GetUpAvgTime())/2;
					cbuffer.Format(GetResString(IDS_STATS_AVEUPTIME),CastSecondsToLngHM(avguptime));
					stattree.SetItemText(up_tsessions[3], cbuffer);
				}

				if (UpOHTotal == 0 || UpOHTotalPackets == 0)
				{
					// Calculate Upline OH Totals
					UpOHTotal = g_eMuleApp.m_pUploadQueue->GetUpDataOverheadFileRequest() + g_eMuleApp.m_pUploadQueue->GetUpDataOverheadSourceExchange() + g_eMuleApp.m_pUploadQueue->GetUpDataOverheadServer() + g_eMuleApp.m_pUploadQueue->GetUpDataOverheadOther();
					UpOHTotalPackets = g_eMuleApp.m_pUploadQueue->GetUpDataOverheadFileRequestPackets() + g_eMuleApp.m_pUploadQueue->GetUpDataOverheadSourceExchangePackets() + g_eMuleApp.m_pUploadQueue->GetUpDataOverheadServerPackets() + g_eMuleApp.m_pUploadQueue->GetUpDataOverheadOtherPackets();
				}
				// Set Cumulative Total Overhead
				cbuffer.Format(GetResString(IDS_TOVERHEAD),CastItoXBytes(UpOHTotal + g_eMuleApp.m_pGlobPrefs->GetUpOverheadTotal()), CastItoIShort(UpOHTotalPackets + g_eMuleApp.m_pGlobPrefs->GetUpOverheadTotalPackets()));
				stattree.SetItemText(hup_toh, cbuffer);
				if (forceUpdate || stattree.IsExpanded(hup_toh))
				{
					int i = 0;
					// Set up total file req OH
					cbuffer.Format(GetResString(IDS_FROVERHEAD), CastItoXBytes( g_eMuleApp.m_pUploadQueue->GetUpDataOverheadFileRequest() + g_eMuleApp.m_pGlobPrefs->GetUpOverheadFileReq()), CastItoIShort(g_eMuleApp.m_pUploadQueue->GetUpDataOverheadFileRequestPackets() + g_eMuleApp.m_pGlobPrefs->GetUpOverheadFileReqPackets()));
					stattree.SetItemText(up_toh[i], cbuffer); i++;
					// Set up total source exch OH
					cbuffer.Format(GetResString(IDS_SSOVERHEAD), CastItoXBytes( g_eMuleApp.m_pUploadQueue->GetUpDataOverheadSourceExchange()+g_eMuleApp.m_pGlobPrefs->GetUpOverheadSrcEx()), CastItoIShort(g_eMuleApp.m_pUploadQueue->GetUpDataOverheadSourceExchangePackets()+g_eMuleApp.m_pGlobPrefs->GetUpOverheadSrcExPackets()));
					stattree.SetItemText(up_toh[i], cbuffer); i++;
					// Set up total server OH
					cbuffer.Format(GetResString(IDS_SOVERHEAD), CastItoXBytes( g_eMuleApp.m_pUploadQueue->GetUpDataOverheadServer()+g_eMuleApp.m_pGlobPrefs->GetUpOverheadServer()), CastItoIShort(g_eMuleApp.m_pUploadQueue->GetUpDataOverheadServerPackets()+g_eMuleApp.m_pGlobPrefs->GetUpOverheadServerPackets()));
					stattree.SetItemText(up_toh[i], cbuffer); i++;
					// Set up total others OH
					cbuffer.Format(GetResString(IDS_OOVERHEAD), CastItoXBytes( g_eMuleApp.m_pUploadQueue->GetUpDataOverheadOther()+g_eMuleApp.m_pGlobPrefs->GetUpOverheadOther()), CastItoIShort(g_eMuleApp.m_pUploadQueue->GetUpDataOverheadOtherPackets()+g_eMuleApp.m_pGlobPrefs->GetUpOverheadOtherPackets()));
					stattree.SetItemText(up_toh[i], cbuffer); i++;
				}
			} // - End Transfer -> Uploads -> Cumulative Section
		} // - End Transfer -> Uploads Section
	} // - END TRANSFER SECTION


	// CONNECTION SECTION
	if (forceUpdate || stattree.IsExpanded(h_connection))
	{
		// CONNECTION -> SESSION SECTION
		if (forceUpdate || stattree.IsExpanded(h_conn_session))
		{
			// CONNECTION -> SESSION -> GENERAL SECTION
			if (forceUpdate || stattree.IsExpanded(hconn_sg))
			{
				int i = 0;
				// Server Reconnects
				if (g_eMuleApp.stat_reconnects>0) cbuffer.Format(GetResString(IDS_STATS_RECONNECTS),g_eMuleApp.stat_reconnects-1);
				else cbuffer.Format(GetResString(IDS_STATS_RECONNECTS),0);
				stattree.SetItemText(conn_sg[i], cbuffer); i++;
				// Active Connections
				cbuffer.Format("%s: %i",GetResString(IDS_SF_ACTIVECON),activeconnections);
				stattree.SetItemText(conn_sg[i], cbuffer); i++;
				// Average Connections
				cbuffer.Format("%s: %i",GetResString(IDS_SF_AVGCON),(int)averageconnections);
				stattree.SetItemText(conn_sg[i], cbuffer); i++;
				// Peak Connections
				cbuffer.Format("%s: %i",GetResString(IDS_SF_PEAKCON),peakconnections);
				stattree.SetItemText(conn_sg[i], cbuffer); i++;
				// Connect Limit Reached
#ifdef OLD_SOCKETS_ENABLED
				uint32 m_itemp = g_eMuleApp.m_pListenSocket->GetMaxConnectionsReachedCount();
				if( m_itemp != m_ilastMaxConnReached )
				{
					cbuffer.Format("%s: %i : %s",GetResString(IDS_SF_MAXCONLIMITREACHED),m_itemp,CTime::GetCurrentTime().Format(_T("%c")));
					stattree.SetItemText(conn_sg[i], cbuffer);
					m_ilastMaxConnReached = m_itemp;
				}
				else if( m_itemp == 0 )
				{
					cbuffer.Format("%s: %i",GetResString(IDS_SF_MAXCONLIMITREACHED),m_itemp);
					stattree.SetItemText(conn_sg[i], cbuffer);
				}
#endif //OLD_SOCKETS_ENABLED
				i++;
			} // - End Connection -> Session -> General Section
			// CONNECTION -> SESSION -> UPLOADS SECTION
			if (forceUpdate || stattree.IsExpanded(hconn_su))
			{
				int i = 0;
				// Upload Rate
				cbuffer.Format("%s: %.2f " + GetResString(IDS_KBYTESEC), GetResString(IDS_ST_UPLOAD), rateUp);			stattree.SetItemText(conn_su[i], cbuffer); i++;
				// Average Upload Rate
				cbuffer.Format(GetResString(IDS_STATS_AVGUL),GetAvgUploadRate(AVG_SESSION));	stattree.SetItemText(conn_su[i], cbuffer); i++;
				// Max Upload Rate
				cbuffer.Format("%s: %.2f " + GetResString(IDS_KBYTESEC), GetResString(IDS_STATS_MAXUL), maxUp);			stattree.SetItemText(conn_su[i], cbuffer); i++;
				// Max Average Upload Rate
				double myAverageUpRate = GetAvgUploadRate(AVG_SESSION);
				if (myAverageUpRate>maxUpavg) maxUpavg = myAverageUpRate;
				cbuffer.Format("%s: %.2f " + GetResString(IDS_KBYTESEC), GetResString(IDS_STATS_MAXAVGUL), maxUpavg);	stattree.SetItemText(conn_su[i], cbuffer); i++;
			} // - End Connection -> Session -> Uploads Section
			// CONNECTION -> SESSION -> DOWNLOADS SECTION
			if (forceUpdate || stattree.IsExpanded(hconn_sd))
			{
				int i = 0;
				// Download Rate
				cbuffer.Format("%s: %.2f " + GetResString(IDS_KBYTESEC), GetResString(IDS_ST_DOWNLOAD), rateDown);		stattree.SetItemText(conn_sd[i], cbuffer); i++;
				// Average Download Rate
				cbuffer.Format(GetResString(IDS_STATS_AVGDL),GetAvgDownloadRate(AVG_SESSION));	stattree.SetItemText(conn_sd[i], cbuffer); i++;
				// Max Download Rate
				cbuffer.Format(GetResString(IDS_STATS_MAXDL),maxDown);							stattree.SetItemText(conn_sd[i], cbuffer); i++;
				// Max Average Download Rate
				double myAverageDownRate = GetAvgDownloadRate(AVG_SESSION);
				if (myAverageDownRate>maxDownavg) maxDownavg = myAverageDownRate;
				cbuffer.Format(GetResString(IDS_STATS_MAXAVGDL), maxDownavg);					stattree.SetItemText(conn_sd[i], cbuffer); i++;
			} // - End Connection -> Session -> Downloads Section
		} // - End Connection -> Session Section
		// CONNECTION -> CUMULATIVE SECTION
		if (forceUpdate || stattree.IsExpanded(h_conn_total))
		{
			// CONNECTION -> CUMULATIVE -> GENERAL SECTION
			if (forceUpdate || stattree.IsExpanded(hconn_tg))
			{
				int i = 0;
				// Server Reconnects
				if(g_eMuleApp.stat_reconnects>0)
					cbuffer.Format(GetResString(IDS_STATS_RECONNECTS),g_eMuleApp.stat_reconnects - 1 + g_eMuleApp.m_pGlobPrefs->GetConnNumReconnects());
				else
					cbuffer.Format(GetResString(IDS_STATS_RECONNECTS),g_eMuleApp.m_pGlobPrefs->GetConnNumReconnects());
				stattree.SetItemText(conn_tg[i], cbuffer); i++;
				// Average Connections
				cbuffer.Format("%s: %i", GetResString(IDS_SF_AVGCON), (int) (activeconnections + g_eMuleApp.m_pGlobPrefs->GetConnAvgConnections()) / 2 );
				stattree.SetItemText(conn_tg[i], cbuffer); i++;
				// Peak Connections
				cbuffer.Format("%s: %i", GetResString(IDS_SF_PEAKCON), g_eMuleApp.m_pGlobPrefs->GetConnPeakConnections());
				stattree.SetItemText(conn_tg[i], cbuffer); i++;
				// Connection Limit Reached
#ifdef OLD_SOCKETS_ENABLED
				cbuffer.Format("%s: %i", GetResString(IDS_SF_MAXCONLIMITREACHED), g_eMuleApp.m_pListenSocket->GetMaxConnectionsReachedCount() + g_eMuleApp.m_pGlobPrefs->GetConnMaxConnLimitReached());
				stattree.SetItemText(conn_tg[i], cbuffer); i++;
#endif //OLD_SOCKETS_ENABLED
			} // - End Connection -> Cumulative -> General Section
			// CONNECTION -> CUMULATIVE -> UPLOADS SECTION
			if (forceUpdate || stattree.IsExpanded(hconn_tu))
			{
				int i = 0;
				// Average Upload Rate
				cbuffer.Format(GetResString(IDS_STATS_AVGUL),cum_UL_average);
				stattree.SetItemText(conn_tu[i], cbuffer); i++;
				// Max Upload Rate
				cbuffer.Format("%s: %.2f " + GetResString(IDS_KBYTESEC), GetResString(IDS_STATS_MAXUL), cum_UL_maximal);
				stattree.SetItemText(conn_tu[i], cbuffer); i++;
				// Max Average Upload Rate
				cbuffer.Format("%s: %.2f " + GetResString(IDS_KBYTESEC), GetResString(IDS_STATS_MAXAVGUL), cum_UL_max_average);
				stattree.SetItemText(conn_tu[i], cbuffer); i++;
			} // - End Connection -> Cumulative -> Uploads Section
			// CONNECTION -> CUMULATIVE -> DOWNLOADS SECTION
			if (forceUpdate || stattree.IsExpanded(hconn_td))
			{
				int i = 0;
				// Average Download Rate
				cbuffer.Format(GetResString(IDS_STATS_AVGDL), cum_DL_average);
				stattree.SetItemText(conn_td[i], cbuffer); i++;
				// Max Download Rate
				cbuffer.Format(GetResString(IDS_STATS_MAXDL), cum_DL_maximal);
				stattree.SetItemText(conn_td[i], cbuffer); i++;
				// Max Average Download Rate
				cbuffer.Format(GetResString(IDS_STATS_MAXAVGDL), cum_DL_max_average);
				stattree.SetItemText(conn_td[i], cbuffer); i++;
			} // - End Connection -> Cumulative -> Downloads Section
		} // - End Connection -> Cumulative Section
	} // - END CONNECTION SECTION


	// TIME STATISTICS SECTION
	if (forceUpdate || stattree.IsExpanded(h_time))
	{
		// Statistics Last Reset
		cbuffer.Format(GetResString(IDS_STATS_LASTRESETSTATIC), g_eMuleApp.m_pGlobPrefs->GetStatsLastResetStr());
		stattree.SetItemText(tvitime[0], cbuffer);
		// Time Since Last Reset
		__int64 timeDiff;
		if (g_eMuleApp.m_pGlobPrefs->GetStatsLastResetLng())
		{
			time_t	timeNow;

			time ( &timeNow );
			timeDiff = timeNow - g_eMuleApp.m_pGlobPrefs->GetStatsLastResetLng(); // In seconds
			cbuffer.Format(GetResString(IDS_STATS_TIMESINCERESET), CastSecondsToLngHM(timeDiff));
		}
		else
		{
			timeDiff = 0;
			cbuffer.Format(GetResString(IDS_STATS_TIMESINCERESET), GetResString(IDS_UNKNOWN));
		}
		stattree.SetItemText(tvitime[1], cbuffer);
		// TIME STATISTICS -> SESSION SECTION
		if (forceUpdate || stattree.IsExpanded(htime_s))
		{
			int i = 0;
			// Run Time
			uint64 sessionRunTime = (uint64)((::GetTickCount()-g_eMuleApp.stat_starttime)/1000);
			cbuffer.Format("%s: %s", GetResString(IDS_STATS_RUNTIME), CastSecondsToLngHM(sessionRunTime));
			stattree.SetItemText(tvitime_s[i], cbuffer); i++;
			if (!sessionRunTime) sessionRunTime = 1;
			// Transfer Time
			cbuffer.Format("%s: %s (%1.1f%%)", GetResString(IDS_STATS_TRANSTIME), CastSecondsToLngHM(GetTransferTime()), (double) (100 * GetTransferTime()) / sessionRunTime);
			stattree.SetItemText(tvitime_s[i], cbuffer);
			if (forceUpdate || stattree.IsExpanded(tvitime_s[i]))
			{
				int x = 0;
				// Upload Time
				cbuffer.Format("%s: %s (%1.1f%%)", GetResString(IDS_STATS_UPTIME), CastSecondsToLngHM(GetUploadTime()), (double) (100 * GetUploadTime()) / sessionRunTime);
				stattree.SetItemText(tvitime_st[x], cbuffer); x++;
				// Download Time
				cbuffer.Format("%s: %s (%1.1f%%)", GetResString(IDS_STATS_DOWNTIME), CastSecondsToLngHM(GetDownloadTime()), (double) (100 * GetDownloadTime()) / sessionRunTime);
				stattree.SetItemText(tvitime_st[x], cbuffer); x++;
			}
			i++;
			// Current Server Duration
			cbuffer.Format("%s: %s (%1.1f%%)", GetResString(IDS_STATS_CURRSRVDUR), CastSecondsToLngHM(time_thisServerDuration), (double) (100 * time_thisServerDuration) / sessionRunTime);
			stattree.SetItemText(tvitime_s[i], cbuffer); i++;
			// Total Server Duration
			cbuffer.Format("%s: %s (%1.1f%%)", GetResString(IDS_STATS_TOTALSRVDUR), CastSecondsToLngHM(GetServerDuration()), (double) (100 * GetServerDuration()) / sessionRunTime);
			stattree.SetItemText(tvitime_s[i], cbuffer); i++;
		}
		// TIME STATISTICS -> CUMULATIVE SECTION
		if (forceUpdate || stattree.IsExpanded(htime_t))
		{
			int i = 0;
			// Run Time
			uint64 totalRunTime = (uint64)((::GetTickCount()-g_eMuleApp.stat_starttime)/1000)+g_eMuleApp.m_pGlobPrefs->GetConnRunTime();
			cbuffer.Format("%s: %s", GetResString(IDS_STATS_RUNTIME), CastSecondsToLngHM(totalRunTime));
			stattree.SetItemText(tvitime_t[i], cbuffer); i++;
			if (!totalRunTime) totalRunTime = 1;
			// Transfer Time
			cbuffer.Format("%s: %s (%1.1f%%)", GetResString(IDS_STATS_TRANSTIME), CastSecondsToLngHM(GetTransferTime() + g_eMuleApp.m_pGlobPrefs->GetConnTransferTime()), (double) (100 * (GetTransferTime() + g_eMuleApp.m_pGlobPrefs->GetConnTransferTime())) / totalRunTime);
			stattree.SetItemText(tvitime_t[i], cbuffer);
			if (forceUpdate || stattree.IsExpanded(tvitime_t[i]))
			{
				int x = 0;
				// Upload Time
				cbuffer.Format("%s: %s (%1.1f%%)", GetResString(IDS_STATS_UPTIME), CastSecondsToLngHM(GetUploadTime() + g_eMuleApp.m_pGlobPrefs->GetConnUploadTime()), (double) (100 * (GetUploadTime() + g_eMuleApp.m_pGlobPrefs->GetConnUploadTime())) / totalRunTime);
				stattree.SetItemText(tvitime_tt[x], cbuffer); x++;
				// Download Time
				cbuffer.Format("%s: %s (%1.1f%%)", GetResString(IDS_STATS_DOWNTIME), CastSecondsToLngHM(GetDownloadTime() + g_eMuleApp.m_pGlobPrefs->GetConnDownloadTime()), (double) (100 * (GetDownloadTime() + g_eMuleApp.m_pGlobPrefs->GetConnDownloadTime())) / totalRunTime);
				stattree.SetItemText(tvitime_tt[x], cbuffer); x++;
			}
			i++;
			// Total Server Duration
			cbuffer.Format("%s: %s (%1.1f%%)", GetResString(IDS_STATS_TOTALSRVDUR), CastSecondsToLngHM(GetServerDuration() + g_eMuleApp.m_pGlobPrefs->GetConnServerDuration()), (double) (100 * (GetServerDuration() + g_eMuleApp.m_pGlobPrefs->GetConnServerDuration())) / totalRunTime);
			stattree.SetItemText(tvitime_t[i], cbuffer); i++;
		}
		// TIME STATISTICS -> PROJECTED AVERAGES SECTION
		if ( (forceUpdate || stattree.IsExpanded(htime_aap)) && timeDiff > 0 )
		{
			double avgModifier[3];
			avgModifier[0] = (double) 86400 / timeDiff; // Days
			avgModifier[1] = (double) 2628000 / timeDiff; // Months
			avgModifier[2] = (double) 31536000 / timeDiff; // Years
			// TIME STATISTICS -> PROJECTED AVERAGES -> TIME PERIODS
			// This section is completely scalable.  Might add "Week" to it in the future.
			// For each time period that we are calculating a projected average for...
			for (int mx = 0; mx<3; mx++)
			{
				if (forceUpdate || stattree.IsExpanded(time_aaph[mx]))
				{
					// TIME STATISTICS -> PROJECTED AVERAGES -> TIME PERIOD -> UPLOADS SECTION
					if (forceUpdate || stattree.IsExpanded(time_aap_hup[mx]))
					{
						// Uploaded Data
						cbuffer.Format("%s: %s",GetResString(IDS_STATS_UDATA),CastItoXBytes( (uint64)(g_eMuleApp.stat_sessionSentBytes+g_eMuleApp.m_pGlobPrefs->GetTotalUploaded())*avgModifier[mx]));
						stattree.SetItemText(time_aap_up[mx][0],cbuffer);
						if (forceUpdate || stattree.IsExpanded(time_aap_up[mx][0]))
						{
							// Uploaded Data By Client
							if (forceUpdate || stattree.IsExpanded(time_aap_up_hd[mx][0]))
							{
								uint64 UpDataTotal =	(uint64) g_eMuleApp.m_pGlobPrefs->GetUpTotalClientData() * avgModifier[mx];
								uint64 UpDataClient =	0;
								double percentClientTransferred = 0;
								//eklmn: sequence was replaced to loop...
								int i = 0;
								for (int j = 0;j<SO_LAST;j++)
									if ((EnumClientTypes)j != SO_OLDEMULE)
									{
										if ((EnumClientTypes)j == SO_EMULE)
											UpDataClient = (g_eMuleApp.m_pGlobPrefs->GetCumUpData((EnumClientTypes)j)
															+ g_eMuleApp.m_pGlobPrefs->GetCumUpData(SO_OLDEMULE))*avgModifier[mx];
										else
											UpDataClient = g_eMuleApp.m_pGlobPrefs->GetCumUpData((EnumClientTypes)j)*avgModifier[mx];

										if ( UpDataTotal!=0 && UpDataClient!=0 )
											percentClientTransferred = (double) 100 * UpDataClient / UpDataTotal;
										else
											percentClientTransferred = 0;
										cbuffer.Format( "%s: %s (%1.1f%%)" , GetClientNameString((EnumClientTypes)j), CastItoXBytes(UpDataClient) , percentClientTransferred);
										stattree.SetItemText( time_aap_up_dc[mx][i] , cbuffer );
										i++;
									}
							}
							// Uploaded Data By Port
							if (forceUpdate || stattree.IsExpanded(time_aap_up_hd[mx][1]))
							{
								int i = 0;
								uint64	PortDataDefault =	(uint64) g_eMuleApp.m_pGlobPrefs->GetCumUpDataPort_4662() * avgModifier[mx];
								uint64	PortDataOther =		(uint64) g_eMuleApp.m_pGlobPrefs->GetCumUpDataPort_OTHER() * avgModifier[mx];
								uint64	PortDataTotal =		(uint64) g_eMuleApp.m_pGlobPrefs->GetUpTotalPortData() * avgModifier[mx];
								double	percentPortTransferred = 0;

								if ( PortDataTotal!=0 && PortDataDefault!=0 )
									percentPortTransferred = (double) 100 * PortDataDefault / PortDataTotal;
								cbuffer.Format( "%s: %s (%1.1f%%)" , GetResString(IDS_STATS_PRTDEF) , CastItoXBytes( PortDataDefault ) , percentPortTransferred);
								stattree.SetItemText( time_aap_up_dp[mx][i] , cbuffer ); i++;

								if ( PortDataTotal!=0 && PortDataOther!=0 )
									percentPortTransferred = (double) 100 * PortDataOther / PortDataTotal;
								else
									percentPortTransferred = 0;
								cbuffer.Format( "%s: %s (%1.1f%%)" , GetResString(IDS_STATS_PRTOTHER) , CastItoXBytes( PortDataOther ) , percentPortTransferred);
								stattree.SetItemText( time_aap_up_dp[mx][i] , cbuffer ); i++;
							}
							// Uploaded Data By Source
							if (forceUpdate || stattree.IsExpanded(time_aap_up_hd[mx][2]))
							{
								int i = 0;
								uint64	DataSourceFile =	(uint64) g_eMuleApp.m_pGlobPrefs->GetCumUpData_File() * avgModifier[mx];
								uint64	DataSourcePF =		(uint64) g_eMuleApp.m_pGlobPrefs->GetCumUpData_PartFile() * avgModifier[mx];
								uint64	DataSourceTotal =	(uint64) g_eMuleApp.m_pGlobPrefs->GetUpTotalDataFile() * avgModifier[mx];
								double	percentFileTransferred = 0;

								if ( DataSourceTotal!=0 && DataSourceFile!=0 )
									percentFileTransferred = (double) 100 * DataSourceFile / DataSourceTotal;
								cbuffer.Format( "%s: %s (%1.1f%%)" , GetResString(IDS_STATS_DSFILE) , CastItoXBytes( DataSourceFile ) , percentFileTransferred);
								stattree.SetItemText( time_aap_up_ds[mx][i] , cbuffer ); i++;

								if ( DataSourceTotal!=0 && DataSourcePF!=0 )
									percentFileTransferred = (double) 100 * DataSourcePF / DataSourceTotal;
								else
									percentFileTransferred = 0;
								cbuffer.Format( "%s: %s (%1.1f%%)" , GetResString(IDS_STATS_DSPF) , CastItoXBytes( DataSourcePF ) , percentFileTransferred);
								stattree.SetItemText( time_aap_up_ds[mx][i] , cbuffer ); i++;
							}
						}
						// Upload Sessions
						uint32 statGoodSessions = (uint32) (g_eMuleApp.m_pUploadQueue->GetSuccessfulUpCount() + g_eMuleApp.m_pGlobPrefs->GetUpSuccessfulSessions() + g_eMuleApp.m_pUploadQueue->GetUploadQueueLength()) * avgModifier[mx];
						uint32 statBadSessions = (uint32) (g_eMuleApp.m_pUploadQueue->GetFailedUpCount() + g_eMuleApp.m_pGlobPrefs->GetUpFailedSessions()) * avgModifier[mx];
						double percentSessions;
						cbuffer.Format("%s: %u", GetResString(IDS_STATS_ULSES), statGoodSessions + statBadSessions);
						stattree.SetItemText(time_aap_up[mx][1], cbuffer);
						if (forceUpdate || stattree.IsExpanded(time_aap_up[mx][1]))
						{
							// Set Successful Upload Sessions
							if (statGoodSessions>0) percentSessions = (double) 100*statGoodSessions/(statGoodSessions+statBadSessions);
							else percentSessions = 0;
							//cbuffer.Format(GetResString(IDS_STATS_SUCCUPCOUNT),statGoodSessions,percentSessions);
							cbuffer.Format("%s: %u (%1.1f%%)",GetResString(IDS_STATS_SUCCUPCOUNT),statGoodSessions,percentSessions);
							stattree.SetItemText(time_aap_up_s[mx][0], cbuffer);
							// Set Failed Upload Sessions
							if (percentSessions != 0 && statBadSessions > 0) percentSessions = 100 - percentSessions; // There were some good sessions and bad ones...
							else if (percentSessions == 0 && statBadSessions > 0) percentSessions = 100; // There were bad sessions and no good ones, must be 100%
							else percentSessions = 0; // No sessions at all, or no bad ones.
							//cbuffer.Format(GetResString(IDS_STATS_FAILUPCOUNT),statBadSessions,percentSessions);
							cbuffer.Format("%s: %u (%1.1f%%)",GetResString(IDS_STATS_FAILUPCOUNT),statBadSessions,percentSessions);
							stattree.SetItemText(time_aap_up_s[mx][1], cbuffer);
						}

						// Calculate Upline OH Totals
						uint64 UpOHTotal = (uint64) (g_eMuleApp.m_pUploadQueue->GetUpDataOverheadFileRequest() + g_eMuleApp.m_pUploadQueue->GetUpDataOverheadSourceExchange() + g_eMuleApp.m_pUploadQueue->GetUpDataOverheadServer() + g_eMuleApp.m_pUploadQueue->GetUpDataOverheadOther()) * avgModifier[mx];
						uint64 UpOHTotalPackets = (uint64) (g_eMuleApp.m_pUploadQueue->GetUpDataOverheadFileRequestPackets() + g_eMuleApp.m_pUploadQueue->GetUpDataOverheadSourceExchangePackets() + g_eMuleApp.m_pUploadQueue->GetUpDataOverheadServerPackets() + g_eMuleApp.m_pUploadQueue->GetUpDataOverheadOtherPackets()) * avgModifier[mx];

						// Set Cumulative Total Overhead
						cbuffer.Format(GetResString(IDS_TOVERHEAD),CastItoXBytes(UpOHTotal + ((uint64)g_eMuleApp.m_pGlobPrefs->GetUpOverheadTotal() * avgModifier[mx])), CastItoIShort(UpOHTotalPackets + ((uint64)g_eMuleApp.m_pGlobPrefs->GetUpOverheadTotalPackets() * avgModifier[mx])));
						stattree.SetItemText(time_aap_up[mx][2], cbuffer);
						if (forceUpdate || stattree.IsExpanded(time_aap_up[mx][2]))
						{
							int i = 0;
							// Set up total file req OH
							cbuffer.Format(GetResString(IDS_FROVERHEAD), CastItoXBytes( (uint64) (g_eMuleApp.m_pUploadQueue->GetUpDataOverheadFileRequest() + g_eMuleApp.m_pGlobPrefs->GetUpOverheadFileReq()) * avgModifier[mx]), CastItoIShort( (uint64) (g_eMuleApp.m_pUploadQueue->GetUpDataOverheadFileRequestPackets() + g_eMuleApp.m_pGlobPrefs->GetUpOverheadFileReqPackets()) * avgModifier[mx]));
							stattree.SetItemText(time_aap_up_oh[mx][i], cbuffer); i++;
							// Set up total source exch OH
							cbuffer.Format(GetResString(IDS_SSOVERHEAD), CastItoXBytes( (uint64) (g_eMuleApp.m_pUploadQueue->GetUpDataOverheadSourceExchange()+g_eMuleApp.m_pGlobPrefs->GetUpOverheadSrcEx()) * avgModifier[mx]), CastItoIShort( (uint64) (g_eMuleApp.m_pUploadQueue->GetUpDataOverheadSourceExchangePackets()+g_eMuleApp.m_pGlobPrefs->GetUpOverheadSrcExPackets()) * avgModifier[mx]));
							stattree.SetItemText(time_aap_up_oh[mx][i], cbuffer); i++;
							// Set up total server OH
							cbuffer.Format(GetResString(IDS_SOVERHEAD), CastItoXBytes( (uint64) (g_eMuleApp.m_pUploadQueue->GetUpDataOverheadServer()+g_eMuleApp.m_pGlobPrefs->GetUpOverheadServer()) * avgModifier[mx]), CastItoIShort( (uint64) (g_eMuleApp.m_pUploadQueue->GetUpDataOverheadServerPackets()+g_eMuleApp.m_pGlobPrefs->GetUpOverheadServerPackets()) * avgModifier[mx]));
							stattree.SetItemText(time_aap_up_oh[mx][i], cbuffer); i++;
							// Set up total others OH
							cbuffer.Format(GetResString(IDS_OOVERHEAD), CastItoXBytes( (uint64) (g_eMuleApp.m_pUploadQueue->GetUpDataOverheadOther()+g_eMuleApp.m_pGlobPrefs->GetUpOverheadOther()) * avgModifier[mx]), CastItoIShort( (uint64) (g_eMuleApp.m_pUploadQueue->GetUpDataOverheadOtherPackets()+g_eMuleApp.m_pGlobPrefs->GetUpOverheadOtherPackets()) * avgModifier[mx]));
							stattree.SetItemText(time_aap_up_oh[mx][i], cbuffer); i++;
						}
					} // - End Time Statistics -> Projected Averages -> Time Period -> Uploads Section
					// TIME STATISTICS -> PROJECTED AVERAGES -> TIME PERIOD -> DOWNLOADS SECTION
					if (forceUpdate || stattree.IsExpanded(time_aap_hdown[mx]))
					{
						g_eMuleApp.m_pDownloadQueue->GetDownloadStats(myStats, myBigStats);
						// Downloaded Data
						cbuffer.Format("%s: %s",GetResString(IDS_STATS_DDATA),CastItoXBytes( (uint64) (g_eMuleApp.stat_sessionReceivedBytes+g_eMuleApp.m_pGlobPrefs->GetTotalDownloaded()) * avgModifier[mx] ));
						stattree.SetItemText(time_aap_down[mx][0], cbuffer);
						if (forceUpdate || stattree.IsExpanded(time_aap_down[mx][0]))
						{
							// Downloaded Data By Client
							if (forceUpdate || stattree.IsExpanded(time_aap_down_hd[mx][0]))
							{
								uint64 DownDataTotal = (uint64) g_eMuleApp.m_pGlobPrefs->GetDownTotalClientData() * avgModifier[mx];
								uint64 DownDataClient = 0;
								double percentClientTransferred = 0;
								//eklmn: sequence was replaced to loop...
								int i = 0;
								for (int j = 0;j<SO_LAST;j++)
									if ((EnumClientTypes)j != SO_OLDEMULE)
									{
										if ((EnumClientTypes)j == SO_EMULE)
											DownDataClient = (g_eMuleApp.m_pGlobPrefs->GetCumDownData((EnumClientTypes)j)
															+ g_eMuleApp.m_pGlobPrefs->GetCumDownData(SO_OLDEMULE))* avgModifier[mx];
										else
											DownDataClient = g_eMuleApp.m_pGlobPrefs->GetCumDownData((EnumClientTypes)j)* avgModifier[mx];

										if ( DownDataTotal!=0 && DownDataClient!=0 )
											percentClientTransferred = (double) 100 * DownDataClient / DownDataTotal;
										else
											percentClientTransferred = 0;
										cbuffer.Format( "%s: %s (%1.1f%%)" , GetClientNameString((EnumClientTypes)j), CastItoXBytes(DownDataClient) , percentClientTransferred);
										stattree.SetItemText( time_aap_down_dc[mx][i] , cbuffer );
										i++;
									}
							}
							// Downloaded Data By Port
							if (forceUpdate || stattree.IsExpanded(time_aap_down_hd[mx][1]))
							{
								int i = 0;
								uint64	PortDataDefault =	(uint64) g_eMuleApp.m_pGlobPrefs->GetCumDownDataPort_4662() * avgModifier[mx];
								uint64	PortDataOther =		(uint64) g_eMuleApp.m_pGlobPrefs->GetCumDownDataPort_OTHER() * avgModifier[mx];
								uint64	PortDataTotal =		(uint64) g_eMuleApp.m_pGlobPrefs->GetDownTotalPortData() * avgModifier[mx];
								double	percentPortTransferred = 0;

								if ( PortDataTotal!=0 && PortDataDefault!=0 )
									percentPortTransferred = (double) 100 * PortDataDefault / PortDataTotal;
								cbuffer.Format( "%s: %s (%1.1f%%)" , GetResString(IDS_STATS_PRTDEF) , CastItoXBytes( PortDataDefault ) , percentPortTransferred);
								stattree.SetItemText( time_aap_down_dp[mx][i] , cbuffer ); i++;

								if ( PortDataTotal!=0 && PortDataOther!=0 )
									percentPortTransferred = (double) 100 * PortDataOther / PortDataTotal;
								else
									percentPortTransferred = 0;
								cbuffer.Format( "%s: %s (%1.1f%%)" , GetResString(IDS_STATS_PRTOTHER), CastItoXBytes( PortDataOther ) , percentPortTransferred);
								stattree.SetItemText( time_aap_down_dp[mx][i] , cbuffer ); i++;
							}
						}
						// Set Cum Completed Downloads
						cbuffer.Format("%s: %I64u", GetResString(IDS_STATS_COMPDL), (uint64) (g_eMuleApp.m_pGlobPrefs->GetDownCompletedFiles() * avgModifier[mx]) );
						stattree.SetItemText(time_aap_down[mx][1], cbuffer);
						// Set Cum Download Sessions
						uint32	statGoodSessions = (uint32) (g_eMuleApp.m_pGlobPrefs->GetDownC_SuccessfulSessions() + myStats[1]) * avgModifier[mx];
						uint32	statBadSessions = (uint32) g_eMuleApp.m_pGlobPrefs->GetDownC_FailedSessions() * avgModifier[mx];
						double	percentSessions;
						cbuffer.Format("%s: %u", GetResString(IDS_STATS_DLSES), statGoodSessions+statBadSessions );
						stattree.SetItemText(time_aap_down[mx][2], cbuffer);
						if (forceUpdate || stattree.IsExpanded(time_aap_down[mx][2]))
						{
							// Set Cum Successful Download Sessions
							if (statGoodSessions > 0) percentSessions = (double) 100 * statGoodSessions / (statGoodSessions + statBadSessions);
							else percentSessions = 0;
							cbuffer.Format( "%s: %u (%1.1f%%)", GetResString(IDS_STATS_SDLSES) , statGoodSessions , percentSessions );
							stattree.SetItemText( time_aap_down_s[mx][0] , cbuffer ); // Set Successful Sessions
							// Set Cum Failed Download Sessions
							if (percentSessions != 0 && statBadSessions > 0) percentSessions = 100 - percentSessions; // There were some good sessions and bad ones...
							else if (percentSessions == 0 && statBadSessions > 0) percentSessions = 100; // There were bad sessions and no good ones, must be 100%
							else percentSessions = 0; // No sessions at all, or no bad ones.
							cbuffer.Format( "%s: %u (%1.1f%%)" , GetResString(IDS_STATS_FDLSES) , statBadSessions , percentSessions);
							stattree.SetItemText( time_aap_down_s[mx][1] , cbuffer );
						}
						// Set Cumulative Gained Due To Compression
						cbuffer.Format( GetResString( IDS_STATS_GAINCOMP ) , CastItoXBytes( (uint64) (myBigStats[1] + g_eMuleApp.m_pGlobPrefs->GetSavedFromCompression()) * avgModifier[mx] ) );
						stattree.SetItemText( time_aap_down[mx][3] , cbuffer );
						// Set Cumulative Lost Due To Corruption
						cbuffer.Format( GetResString( IDS_STATS_LOSTCORRUPT ) , CastItoXBytes( (uint64) (myBigStats[0] + g_eMuleApp.m_pGlobPrefs->GetLostFromCorruption()) * avgModifier[mx] ) );
						stattree.SetItemText( time_aap_down[mx][4] , cbuffer );
						// Set Cumulative Saved Due To ICH
						cbuffer.Format( GetResString( IDS_STATS_ICHSAVED ) , (uint32) ((myStats[14] + g_eMuleApp.m_pGlobPrefs->GetPartsSavedByICH()) * avgModifier[mx]) );
						stattree.SetItemText( time_aap_down[mx][5] , cbuffer );

						uint64 DownOHTotal = g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadFileRequest() + g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadSourceExchange() + g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadServer() + g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadOther();
						uint64 DownOHTotalPackets = g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadFileRequestPackets() + g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadSourceExchangePackets() + g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadServerPackets() + g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadOtherPackets();
						// Total Overhead
						cbuffer.Format(GetResString(IDS_TOVERHEAD),CastItoXBytes( (uint64) (DownOHTotal + g_eMuleApp.m_pGlobPrefs->GetDownOverheadTotal()) * avgModifier[mx]), CastItoIShort((uint64)(DownOHTotalPackets + g_eMuleApp.m_pGlobPrefs->GetDownOverheadTotalPackets()) * avgModifier[mx]));
						stattree.SetItemText(time_aap_down[mx][6], cbuffer);
						if (forceUpdate || stattree.IsExpanded(time_aap_down[mx][6]))
						{
							int i = 0;
							// File Request Overhead
							cbuffer.Format(GetResString(IDS_FROVERHEAD), CastItoXBytes( (uint64)(g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadFileRequest() + g_eMuleApp.m_pGlobPrefs->GetDownOverheadFileReq()) * avgModifier[mx]), CastItoIShort((uint64)(g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadFileRequestPackets() + g_eMuleApp.m_pGlobPrefs->GetDownOverheadFileReqPackets()) * avgModifier[mx]));
							stattree.SetItemText(time_aap_down_oh[mx][i], cbuffer); i++;
							// Source Exchange Overhead
							cbuffer.Format(GetResString(IDS_SSOVERHEAD), CastItoXBytes( (uint64)(g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadSourceExchange()+g_eMuleApp.m_pGlobPrefs->GetDownOverheadSrcEx()) * avgModifier[mx]), CastItoIShort((uint64)(g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadSourceExchangePackets()+g_eMuleApp.m_pGlobPrefs->GetDownOverheadSrcExPackets()) * avgModifier[mx]));
							stattree.SetItemText(time_aap_down_oh[mx][i], cbuffer); i++;
							// Server Overhead
							cbuffer.Format(GetResString(IDS_SOVERHEAD), CastItoXBytes( (uint64)(g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadServer()+g_eMuleApp.m_pGlobPrefs->GetDownOverheadServer()) * avgModifier[mx]), CastItoIShort((uint64)(g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadServerPackets()+g_eMuleApp.m_pGlobPrefs->GetDownOverheadServerPackets()) * avgModifier[mx]));
							stattree.SetItemText(time_aap_down_oh[mx][i], cbuffer); i++;
							// Others Overhead
							cbuffer.Format(GetResString(IDS_OOVERHEAD), CastItoXBytes( (uint64)(g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadOther()+g_eMuleApp.m_pGlobPrefs->GetDownOverheadOther()) * avgModifier[mx]), CastItoIShort((uint64)(g_eMuleApp.m_pDownloadQueue->GetDownDataOverheadOtherPackets()+g_eMuleApp.m_pGlobPrefs->GetDownOverheadOtherPackets()) * avgModifier[mx]));
							stattree.SetItemText(time_aap_down_oh[mx][i], cbuffer); i++;
						}
					} // - End Time Statistics -> Projected Averages -> Time Period -> Downloads Section
				} // - End Time Statistics -> Projected Averages -> Time Period Sections
			} // - End Time Statistics -> Projected Averages Section
		} // - End Time Statistics -> Projected Averages Section Loop
	} // - END TIME STATISTICS SECTION


	// CLIENTS SECTION		[Original idea and code by xrmb]
	//						Note:	This section now has dynamic tree items.  This technique
	//								may appear in other areas, however, there is usually an
	//								advantage to displaying 0 datems.  Here, with the ver-
	//								sions being displayed the way they are, it makes sense.
	//								Who wants to stare at totally blank tree items?  ;)
	if (forceUpdate || stattree.IsExpanded(h_clients))
	{
		CMap<POSITION, POSITION,uint32, uint32> clientMODs;
		CMap<POSITION, POSITION,uint32, uint32> clientCountries;

		uint32	totalclient,totalMODs,myStats[18],clientsPorts[2];
		ClientsData 	AllClients;	// xrmb : statsclientstatus
		// get clientversion-counts
		g_eMuleApp.m_pClientList->GetStatistics(totalclient,myStats, clientsPorts, &AllClients, totalMODs, &clientMODs, &clientCountries);
		//eklmn: check NULL exception
		if (!totalclient)
		{
			totalclient = 1;

			cbuffer.Format("%s: %u", GetResString(IDS_STATS_ONLISTCLIENTS), 0);
			stattree.SetItemText(hcliconnected, cbuffer);

			cbuffer.Format("%s: %u (0%%)", GetResString(IDS_STATS_SUI), myStats[14]);
			stattree.SetItemText(cligen[0], cbuffer);

			cbuffer.Format("%s: %u (0%%)", GetResString(IDS_STATS_NONSUI), myStats[15]);
			stattree.SetItemText(cligen[1], cbuffer);

			cbuffer.Format("%s: %u (0%%)", GetResString(IDS_LOWID), myStats[16]);
			stattree.SetItemText(cligen[2], cbuffer);
		}
		else
		{
			cbuffer.Format("%s: %u", GetResString(IDS_STATS_ONLISTCLIENTS), totalclient);
			stattree.SetItemText(hcliconnected, cbuffer);

			cbuffer.Format("%s: %u (%1.1f%%)", GetResString(IDS_STATS_SUI), myStats[14], static_cast<double>(100*myStats[14])/totalclient);
			stattree.SetItemText(cligen[0], cbuffer);

			cbuffer.Format("%s: %u (%1.1f%%)", GetResString(IDS_STATS_NONSUI), myStats[15], static_cast<double>(100*myStats[15])/totalclient);
			stattree.SetItemText(cligen[1], cbuffer);

			cbuffer.Format("%s: %u (%1.1f%%)", GetResString(IDS_LOWID), myStats[16], static_cast<double>(100*myStats[16])/totalclient);
			stattree.SetItemText(cligen[2], cbuffer);
		}

		// CLIENTS -> CLIENT SOFTWARE SECTION
		if (forceUpdate || stattree.IsExpanded(hcliconnected))
		{
			uint32 totalMules = myStats[SO_EMULE]+myStats[SO_OLDEMULE];
			if (totalMules)
				cbuffer.Format("%s: %u (%1.1f%%)", GetResString(IDS_STATS_CLIENT_MODS), totalMODs,100.0*totalMODs/totalMules);
			else
				cbuffer.Format("%s: %u (0.0%%)", GetResString(IDS_STATS_CLIENT_MODS), totalMODs);
			stattree.SetItemText(hclisoftMODs, cbuffer);
			//eklmn: delete old stuff
			for (int im = 0; im<8; im++)
			{
				if (clisoftMODs[im] != NULL) stattree.DeleteChildItems(clisoftMODs[im]);
				m_nMODs[im] = 0;
			}
			//eklmn: now build a new MOD's subtree
			uint32 MOD_count;
			CString MOD_TypeName;
			POSITION MOD_pos;
			if (totalMODs)
			{
				uint32	currtop = 0;
				uint32	lasttop = 0xFFFFFFFF;
				while (!clientMODs.IsEmpty())
				{
					POSITION pos = clientMODs.GetStartPosition();
					POSITION top_pos = 0;
					uint32 top_count=0;
					while(pos)
					{
						clientMODs.GetNextAssoc(pos, MOD_pos, MOD_count);
						if(currtop<MOD_count && MOD_count<=lasttop)
						{
							top_pos = MOD_pos;
							top_count = MOD_count;
							currtop = MOD_count;
						}
					}
					lasttop=currtop;
					currtop=0;

					if (top_pos)
					{
						// eklmn: now sort client by known types
						MOD_TypeName = g_eMuleApp.m_pClientList->GetMODType(top_pos);
						for (uint16 im = 0; im<8; im++)
						{
							if (im == 7 || MOD_TypeName.Find(GetMODType(im)) != -1)
							{
								m_nMODs[im] += top_count;
								// check item
								if (clisoftMODs[im] == NULL)
								{
									// delete an "Others"
									if (im != 7 && clisoftMODs[7] != NULL)
									{
										stattree.DeleteItem(clisoftMODs[7]); clisoftMODs[7] = NULL;
									}
									clisoftMODs[im] = stattree.InsertItem(cbuffer, hclisoftMODs);
								}
								// now insert a string
								cbuffer.Format("%s: %u", g_eMuleApp.m_pClientList->GetMODType(top_pos), top_count);
								stattree.InsertItem(cbuffer, clisoftMODs[im]);
								break;
							}
						}
						clientMODs.RemoveKey(top_pos);
					}
				}
				for (uint16 im = 0; im<8; im++)
					if (clisoftMODs[im] != NULL)
					{
						cbuffer.Format("%s: %u (%1.1f%%)", GetMODType(im), m_nMODs[im], 100.0*m_nMODs[im]/totalMules);
						stattree.SetItemText(clisoftMODs[im], cbuffer);
					}
			}
			//eklmn: sequence was replaced to loop...
			uint32	clients;
			double	percentClients = 0;
			int it = 0;
			for (int j = 0;j<SO_LAST;j++)
				if ((EnumClientTypes)j != SO_OLDEMULE)
				{
					if ((EnumClientTypes)j == SO_EMULE)
						clients = myStats[SO_EMULE]+myStats[SO_OLDEMULE];
					else
						clients = myStats[j];
					percentClients = static_cast<double>(100*clients)/totalclient;
					cbuffer.Format("%s: %i (%1.1f%%)",GetClientNameString((EnumClientTypes)j), clients, percentClients);
					stattree.SetItemText(clisoft[it], cbuffer);
					//eklmn: here we are building subtrees
					switch ((EnumClientTypes)j)
					{
						case SO_EMULE:
						case SO_EDONKEY:	// CLIENTS ->CONNECTED_> CLIENT SOFTWARE -> EDONKEY SECTION
						case SO_EDONKEYHYBRID:
						case SO_LMULE:
							if (forceUpdate || stattree.IsExpanded(clisoft[it]) || clients != 0)
							{
								//eklmn: since "other versions" must be always on the bottom of the list, let's delete it,
								//           if last of the 4 top values is empty
								if (cli_versions_other[j])
								{
									stattree.DeleteItem(cli_versions_other[j]);
									cli_versions_other[j] = NULL;
								}
								//uint32 totcnt = 0;
								//uint32 verCount = 0;
								//--- find top 4 eDonkey client versions ---
								uint64	currtop = 0;
								uint64	lasttop = 0xFFFFFFFFFFFFFFFF;
								uint32	SubTotal = 0;
								for(uint32 i=0; i<4; i++)
								{
									POSITION pos = AllClients.m_pClients[j].GetStartPosition();
									uint32 topver=0;
									uint32 topcnt=0;
									uint64 cntver=0;
									uint32 ver;
									uint32 cnt;
									while(pos)
									{
										AllClients.m_pClients[j].GetNextAssoc(pos, ver, cnt);
										cntver = cnt; cntver <<= 32; cntver += ver;	//SyruS sort by popularity and version
										if(currtop<cntver && cntver<lasttop)
										{
											topver = ver;
											topcnt = cnt;
											currtop = cntver;
										}
									}
									lasttop=currtop;
									currtop=0;

									if (topcnt)
									{
										//cli_lastCount[j]++;
										SubTotal += topcnt;
										cbuffer.Format(_T("%s: %i (%1.1f%%)"), GetClientVersionString((EnumClientTypes)j,topver), topcnt, static_cast<double>(topcnt)/clients*100.0);
										//eklmn: if we found something just replaced a text
										if (cli_versions[j][i] != NULL)
											stattree.SetItemText(cli_versions[j][i], cbuffer);
										else
											cli_versions[j][i] = stattree.InsertItem(cbuffer, clisoft[it]);
									}
									else
									{
										if (cli_versions[j][i] != NULL)
										{
											stattree.DeleteItem(cli_versions[j][i]);
											cli_versions[j][i] = NULL;
										}
									}
								}
								//eklmn: check a other clients
								if ((clients-SubTotal) != 0)
								{
									//cli_lastCount[j]++;
									cbuffer.Format("%s: %i (%1.1f%%)",GetResString(IDS_STATS_OTHERS),(clients-SubTotal),100.0*(clients-SubTotal)/clients);
									if (cli_versions_other[j])
										stattree.SetItemText(cli_versions_other[j], cbuffer);
									else
										cli_versions_other[j] = stattree.InsertItem(cbuffer, clisoft[it]);
								}

							}
						default: ;
					}
					it++;
				}
		} // - End Clients -> Client Software Section
		// General Client Statistics
		cbuffer.Format("%s: %u", GetResString(IDS_STATS_PROBLEMATIC), myStats[17]);stattree.SetItemText(cligen[3], cbuffer);
		cbuffer.Format("%s: %u", GetResString(IDS_BANNED), g_eMuleApp.m_pUploadQueue->GetBanCount()); stattree.SetItemText(cligen[4], cbuffer);

		//Filtered ... subtree
		cbuffer.Format("%s: %u", GetResString(IDS_STATS_FILTEREDCLIENTS),g_eMuleApp.m_lTotalFiltered); stattree.SetItemText(hFiltered, cbuffer);
		cbuffer.Format("%s: %u", GetResString(IDS_STATS_FILTEREDCLIENTS_IN),g_eMuleApp.m_lIncomingFiltered); stattree.SetItemText(hFilteredItems[0], cbuffer);
		cbuffer.Format("%s: %u", GetResString(IDS_STATS_FILTEREDCLIENTS_OUT),g_eMuleApp.m_lOutgoingFiltered); stattree.SetItemText(hFilteredItems[1], cbuffer);
		cbuffer.Format("%s: %u", GetResString(IDS_STATS_FILTEREDCLIENTS_SX),g_eMuleApp.m_lSXFiltered); stattree.SetItemText(hFilteredItems[2], cbuffer);

		cbuffer.Format("%s: %u", GetResString(IDS_STATS_UNFAIR_CLIENTS), g_eMuleApp.m_lTotalNumUnfairClients); stattree.SetItemText(cligen[5], cbuffer);

		// Unfair actions subtree
		cbuffer.Format("%s: %u", GetResString(IDS_STATS_UNFAIR_ACTIONS), g_eMuleApp.m_lTotalNumUnfairActions); stattree.SetItemText(hUnfairAction, cbuffer);
		cbuffer.Format("%s: %u", GetResString(IDS_STATS_UNFAIR_ACTION_MH),g_eMuleApp.m_lTotalNumUseMyHashActions); stattree.SetItemText(hUnfairActionItems[0], cbuffer);
		cbuffer.Format("%s: %u", GetResString(IDS_STATS_UNFAIR_ACTION_HC),g_eMuleApp.m_lTotalNumHashChangeActions); stattree.SetItemText(hUnfairActionItems[1], cbuffer);
		cbuffer.Format("%s: %u", GetResString(IDS_STATS_UNFAIR_ACTION_BN),g_eMuleApp.m_lTotalNumStolenNameActions); stattree.SetItemText(hUnfairActionItems[2], cbuffer);
		cbuffer.Format("%s: %u", GetResString(IDS_STATS_UNFAIR_ACTION_LT),g_eMuleApp.m_lTotalNumLeecherTypeActions); stattree.SetItemText(hUnfairActionItems[3], cbuffer);

		// Countries subtree
		if (forceUpdate || stattree.IsExpanded(h_clients))
		{
			stattree.DeleteChildItems(hCountries);
			if (g_eMuleApp.m_pIP2Country->IsIP2Country())
			{
				if (totalclient)
				{
					POSITION Country_pos;
					uint32 currtop = 0;
					uint32 lasttop = 0xFFFFFFFF;
					uint32 Country_count, Country_Total = 0;

					while (!clientCountries.IsEmpty())
					{
						POSITION pos = clientCountries.GetStartPosition();
						POSITION top_pos = 0;
						uint32 top_count = 0;
						while(pos)
						{
							clientCountries.GetNextAssoc(pos, Country_pos, Country_count);
							if(currtop<Country_count && Country_count<=lasttop)
							{
								top_pos = Country_pos;
								top_count = Country_count;
								currtop = Country_count;
							}
						}
						lasttop = currtop;
						currtop = 0;
						if (top_pos)
						{
							cbuffer.Format("%s: %u (%1.1f%%)", g_eMuleApp.m_pClientList->GetClientCountry(top_pos), top_count, static_cast<double>(100*top_count)/totalclient);
							stattree.InsertItem(cbuffer, hCountries);
							clientCountries.RemoveKey(top_pos);
							Country_Total++;
						}
					}
					cbuffer.Format("%s: %u", GetResString(IDS_COUNTRIES), Country_Total);
				}
				else
					cbuffer.Format("%s: <%s>", GetResString(IDS_COUNTRIES), GetResString(IDS_FSTAT_WAITING));
			}
			else
				cbuffer.Format("%s: <%s>", GetResString(IDS_COUNTRIES), GetResString(IDS_DISABLED));
			stattree.SetItemText(hCountries, cbuffer);
		} // - End Countries
	} // - END CLIENTS SECTION


	// UPDATE RECORDS FOR SERVERS AND SHARED FILES
	g_eMuleApp.m_pGlobPrefs->SetRecordStructMembers();

	// SERVERS SECTION
	if (forceUpdate || stattree.IsExpanded(h_servers))
	{
		// Get stat values
		uint32	servtotal, servfail, servuser, servfile, servtuser, servtfile;
		double	servocc;
		g_eMuleApp.m_pServerList->GetStatus (servtotal, servfail, servuser, servfile, servtuser, servtfile, servocc);
		// Set working servers value
		cbuffer.Format("%s: %i",GetResString(IDS_SF_WORKING),servtotal-servfail);stattree.SetItemText(srv[0], cbuffer);
		if (forceUpdate || stattree.IsExpanded(srv[0]))
		{
			// Set users on working servers value
			cbuffer.Format("%s: %s",GetResString(IDS_SF_WUSER),CastItoThousands(servuser));stattree.SetItemText(srv_w[0], cbuffer);
			// Set files on working servers value
			cbuffer.Format("%s: %s",GetResString(IDS_SF_WFILE),CastItoThousands(servfile));stattree.SetItemText(srv_w[1], cbuffer);
			// Set server occ value
			cbuffer.Format(GetResString(IDS_SF_SRVOCC),servocc);stattree.SetItemText(srv_w[2], cbuffer);
		}
		// Set failed servers value
		cbuffer.Format("%s: %i",GetResString(IDS_SF_FAIL),servfail);stattree.SetItemText(srv[1], cbuffer);
		// Set deleted servers value
		cbuffer.Format("%s: %i",GetResString(IDS_SF_DELCOUNT),g_eMuleApp.m_pServerList->GetDeletedServerCount());stattree.SetItemText(srv[2], cbuffer);
		// Set total servers value
		cbuffer.Format("%s: %i",GetResString(IDS_SF_TOTAL),servtotal);stattree.SetItemText(srv[3], cbuffer);
		// Set total users value
		cbuffer.Format("%s: %s",GetResString(IDS_SF_USER),CastItoThousands(servtuser));stattree.SetItemText(srv[4], cbuffer);
		// Set total files value
		cbuffer.Format("%s: %s",GetResString(IDS_SF_FILE),CastItoThousands(servtfile));stattree.SetItemText(srv[5], cbuffer);
		// UDP Search status
		if(g_eMuleApp.m_pDownloadQueue->GetUDPSearchStatus() == "")
		{
			cbuffer.Format(GetResString(IDS_STATS_UDPSEARCH), GetResString(IDS_FSTAT_WAITING));
			stattree.SetItemText(srv[6], cbuffer);
		}
		else
		{
			cbuffer.Format(GetResString(IDS_STATS_UDPSEARCH), g_eMuleApp.m_pDownloadQueue->GetUDPSearchStatus());
			stattree.SetItemText(srv[6], cbuffer);
		}
		// SERVERS -> RECORDS SECTION
		if (forceUpdate || stattree.IsExpanded(hsrv_records))
		{
			// Set most working servers
			cbuffer.Format("%s: %u", GetResString(IDS_STATS_SVRECWORKING), g_eMuleApp.m_pGlobPrefs->GetSrvrsMostWorkingServers() );
			stattree.SetItemText(srv_r[0], cbuffer);
			// Set most users online
			cbuffer.Format("%s: %s", GetResString(IDS_STATS_SVRECUSERS), CastItoThousands(g_eMuleApp.m_pGlobPrefs->GetSrvrsMostUsersOnline()) );
			stattree.SetItemText(srv_r[1], cbuffer);
			// Set most files avail
			cbuffer.Format("%s: %s", GetResString(IDS_STATS_SVRECFILES), CastItoThousands(g_eMuleApp.m_pGlobPrefs->GetSrvrsMostFilesAvail()) );
			stattree.SetItemText(srv_r[2], cbuffer);
		} // - End Servers -> Records Section
	} // - END SERVERS SECTION


	// SHARED FILES SECTION
	if (forceUpdate || stattree.IsExpanded(h_shared))
	{
		// Set Number of Shared Files
		cbuffer.Format(GetResString(IDS_SHAREDFILESCOUNT),g_eMuleApp.m_pSharedFilesList->GetCount());
		stattree.SetItemText(shar[0], cbuffer);
		// Set Average File Size
		uint64 bytesLargestFile = 0;
		uint64 allsize = g_eMuleApp.m_pSharedFilesList->GetDatasize(bytesLargestFile); // Func returns total share size and sets pointeredd uint64 to largest single filesize
		CString cbuffer2;
		if(g_eMuleApp.m_pSharedFilesList->GetCount() != 0)
			cbuffer2.Format( "%s", CastItoXBytes((uint64)allsize/g_eMuleApp.m_pSharedFilesList->GetCount()));
		else
		{
			cbuffer2.Format( "%s", CastItoXBytes(0) );
		}
		cbuffer.Format(GetResString(IDS_SF_AVERAGESIZE),cbuffer2);
		stattree.SetItemText(shar[1], cbuffer);
		// Set Largest File Size
		cbuffer.Format("%s: %s", GetResString(IDS_STATS_LARGESTFILE), CastItoXBytes(bytesLargestFile) );
		stattree.SetItemText(shar[2], cbuffer);
		// Set Total Share Size
		cbuffer.Format(GetResString(IDS_SF_SIZE),CastItoXBytes(allsize));
		stattree.SetItemText(shar[3], cbuffer);

		// SHARED FILES -> RECORDS SECTION
		if (forceUpdate || stattree.IsExpanded(hshar_records))
		{
			// Set Most Files Shared
			cbuffer.Format("%s: %u", GetResString(IDS_STATS_SHRECNUM), g_eMuleApp.m_pGlobPrefs->GetSharedMostFilesShared() );
			stattree.SetItemText(shar_r[0], cbuffer);
			// Set largest avg file size
			cbuffer.Format("%s: %s", GetResString(IDS_STATS_SHRECASIZE), CastItoXBytes(g_eMuleApp.m_pGlobPrefs->GetSharedLargestAvgFileSize()) );
			stattree.SetItemText(shar_r[1], cbuffer);
			// Set largest file size
			cbuffer.Format("%s: %s", GetResString(IDS_STATS_LARGESTFILE), CastItoXBytes(g_eMuleApp.m_pGlobPrefs->GetSharedLargestFileSize()) );
			stattree.SetItemText(shar_r[2], cbuffer);
			// Set largest share size
			cbuffer.Format("%s: %s", GetResString(IDS_STATS_SHRECSIZE), CastItoXBytes(g_eMuleApp.m_pGlobPrefs->GetSharedLargestShareSize()) );
			stattree.SetItemText(shar_r[3], cbuffer);
		} // - End Shared Files -> Records Section
	} // - END SHARED FILES SECTION

	// - End Set Tree Values

	stattree.SetRedraw(true);

} // ShowStatistics(bool forceRedraw = false){}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CStatisticsDlg::Localize()
{
	static const int s_aiResTbl[][2] =
	{
		{ IDC_STATIC_D3, IDS_ST_DOWNLOAD },
		{ IDC_STATIC_U, IDS_ST_UPLOAD },
		{ IDC_STATIC_A, IDS_SP_ACTCON },
		{ IDC_BNMENU, IDS_SF_STATISTICS }
	};
	static const int s_aiResTbl2[][2] =
	{
		{ IDC_STATIC_D, IDS_ST_CURRENT },
		{ IDC_STATIC_U2, IDS_ST_CURRENT },
		{ IDC_STATIC_D2, IDS_ST_SESSION },
		{ IDC_STATIC_U3, IDS_ST_SESSION },
		{ IDC_STATIC_S2, IDS_ST_ACTIVEDOWNLOAD },
		{ IDC_STATIC_S1, IDS_ST_ACTIVEUPLOAD }
	};
	// Used for formatting the Active Connections ratio and the time for average graphs
	CString	strBuffer;

	for (uint32 i = 0; i < ELEMENT_COUNT(s_aiResTbl); i++)
		SetDlgItemText(s_aiResTbl[i][0], GetResString(static_cast<UINT>(s_aiResTbl[i][1])));

	for (uint32 i = 0; i < ELEMENT_COUNT(s_aiResTbl2); i++)
		SetDlgItemText(s_aiResTbl2[i][0], GetResString(static_cast<UINT>(s_aiResTbl2[i][1])).MakeLower());

	if (g_eMuleApp.m_pGlobPrefs->GetGraphRatio() == 255) // 255 magic number for %
		strBuffer=_T(" (in %)");
	else if (g_eMuleApp.m_pGlobPrefs->GetGraphRatio() > 1)
			strBuffer.Format(_T(" (1:%u)"),g_eMuleApp.m_pGlobPrefs->GetGraphRatio());
	SetDlgItemText(IDC_STATIC_S0, GetResString(IDS_PW_GENERAL).MakeLower() + strBuffer);
	strBuffer.Format( _T("%s (%u %s)"), GetResString(IDS_AVG).MakeLower(),
		g_eMuleApp.m_pGlobPrefs->GetStatsAverageMinutes(), GetResString(IDS_MINS) );
	SetDlgItemText(IDC_TIMEAVG1, strBuffer);
	SetDlgItemText(IDC_TIMEAVG2, strBuffer);

	CreateStatsTree(); //Localization (should be tested)

	if (IsRightToLeftLanguage())
		GetDlgItem(IDC_STATTREE)->ModifyStyleEx(0, WS_EX_RTLREADING);
	else
		GetDlgItem(IDC_STATTREE)->ModifyStyleEx(WS_EX_RTLREADING, 0);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Menu Button: Displays the menu of stat tree commands.
void CStatisticsDlg::OnMenuButtonClicked()
{
	CRect rectBn;
	CPoint thePoint;
	CSize theSize;
	GetDlgItem(IDC_BNMENU)->GetWindowRect(&rectBn);
	thePoint = rectBn.TopLeft();
	theSize.SetSize(42,18);
	stattree.DoMenu(thePoint.operator+(theSize));
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CStatisticsDlg::CreateStatsTree()
{
	CString buffer;

	EMULE_TRY

	stattree.DeleteAllItems();

	// Setup Tree
	// transfer section
	h_transfer = stattree.InsertItem(GetResString(IDS_FSTAT_TRANSFER),1,1);				// Transfers Section
		buffer.Format("%s %s",GetResString(IDS_STATS_SRATIO),GetResString(IDS_FSTAT_WAITING));// Make It Pretty
		trans[0]= stattree.InsertItem(buffer, h_transfer);										// Session Ratio
		buffer.Format("%s %s",GetResString(IDS_STATS_CRATIO),GetResString(IDS_FSTAT_WAITING));// Make It Pretty
		trans[1]= stattree.InsertItem(buffer, h_transfer);										// Cumulative Ratio

	// upload section
	h_upload = stattree.InsertItem(GetResString(IDS_TW_UPLOADS), 6,6,h_transfer);		// Uploads Section
		// UL: session
		h_up_session= stattree.InsertItem(GetResString(IDS_STATS_SESSION), 8,8,h_upload);		// Session Section (Uploads)
		for(int i = 0; i<4; i++) up_S[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), h_up_session);
				hup_scb= stattree.InsertItem(GetResString(IDS_CLIENTS),up_S[0]);							// Clients Section
				for(int i = 0; i<(SO_LAST-1); i++) up_scb[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hup_scb);
				hup_spb= stattree.InsertItem(GetResString(IDS_PORT),up_S[0]);								// Ports Section
				for(int i = 0; i<2; i++) up_spb[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hup_spb);
				hup_ssb= stattree.InsertItem(GetResString(IDS_STATS_DATASOURCE),up_S[0]);				// Data Source Section
				for(int i = 0; i<2; i++) up_ssb[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hup_ssb);
				for(int i = 0; i<4; i++) up_ssessions[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), up_S[3]);
					// successful sessions
					for(int i = 0; i<2; i++) up_ssessions_s[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), up_ssessions[0]);
					for(int i = 0; i<ETS_TERMINATOR; i++) up_ssessions_spc[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), up_ssessions_s[1]);
					// failed sessions
					for(int i = 0; i<ETS_TERMINATOR; i++) up_ssessions_f[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), up_ssessions[1]);
				hup_soh= stattree.InsertItem(GetResString(IDS_STATS_OVRHD),h_up_session);					// Upline Overhead (Session)
				for(int i = 0; i<4; i++) up_soh[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hup_soh);
		// UL: cumulative
		h_up_total= stattree.InsertItem(GetResString(IDS_STATS_CUMULATIVE),9,9, h_upload);		// Cumulative Section (Uploads)
		up_T[0]= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_up_total);				// Uploaded Data (Total)
			hup_tcb= stattree.InsertItem(GetResString(IDS_CLIENTS),up_T[0]);							// Clients Section
			for(int i = 0; i<(SO_LAST-1); i++) up_tcb[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hup_tcb);
			hup_tpb= stattree.InsertItem(GetResString(IDS_PORT),up_T[0]);								// Ports Section
			for(int i = 0; i<2; i++) up_tpb[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hup_tpb);
			hup_tsb= stattree.InsertItem(GetResString(IDS_STATS_DATASOURCE),up_T[0]);					// Data Source Section
			for(int i = 0; i<2; i++) up_tsb[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hup_tsb);
			up_T[1]= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_up_total);				// Upload Sessions (Total)
			for(int i = 0; i<4; i++) up_tsessions[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), up_T[1]);
			hup_toh= stattree.InsertItem(GetResString(IDS_STATS_OVRHD),h_up_total);						// Upline Overhead (Total)
			for(int i = 0; i<4; i++) up_toh[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hup_toh);

	// download section
	h_download = stattree.InsertItem(GetResString(IDS_TW_DOWNLOADS), 7,7,h_transfer);	// Downloads Section
		//DL: session
		h_down_session= stattree.InsertItem(GetResString(IDS_STATS_SESSION),8,8, h_download);	// Session Section (Downloads)
		for(int i = 0; i<17; i++) down_S[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), h_down_session);
			hdown_scb= stattree.InsertItem(GetResString(IDS_CLIENTS),down_S[0]);			// Clients Section
			for(int i = 0; i<(SO_LAST-1); i++) down_scb[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hdown_scb);
			hdown_spb= stattree.InsertItem(GetResString(IDS_PORT),down_S[0]);							// Ports Section
			for(int i = 0; i<2; i++) down_spb[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hdown_spb);
			for(int i = 0; i<STATS_DL_SOURCES_TYPE-3; i++) down_sources[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), down_S[12]);
			for(int i = 0; i<4; i++) down_ssessions[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), down_S[13]);
			hdown_soh= stattree.InsertItem(GetResString(IDS_STATS_OVRHD),h_down_session);				// Downline Overhead (Session)
			for(int i = 0; i<4; i++) down_soh[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hdown_soh);

		//DL: cumulative
		h_down_total= stattree.InsertItem(GetResString(IDS_STATS_CUMULATIVE),9,9, h_download);	// Cumulative Section (Downloads)
		for(int i = 0; i<6; i++) down_T[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), h_down_total);
			hdown_tcb= stattree.InsertItem(GetResString(IDS_CLIENTS),down_T[0]);						// Clients Section
			for(int i = 0; i<(SO_LAST-1); i++) down_tcb[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hdown_tcb);
			hdown_tpb= stattree.InsertItem(GetResString(IDS_PORT),down_T[0]);							// Ports Section
			for(int i = 0; i<2; i++) down_tpb[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hdown_tpb);
			for(int i = 0; i<4; i++) down_tsessions[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), down_T[2]);
			hdown_toh= stattree.InsertItem(GetResString(IDS_STATS_OVRHD),h_down_total);					// Downline Overhead (Total)
			for(int i = 0; i<4; i++) down_toh[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hdown_toh);

	//connection section
	h_connection = stattree.InsertItem(GetResString(IDS_FSTAT_CONNECTION),2,2);				// Connection Section
		// connection: session
		h_conn_session= stattree.InsertItem(GetResString(IDS_STATS_SESSION),8,8,h_connection);	// Session Section (Connection)
			hconn_sg= stattree.InsertItem(GetResString(IDS_STATS_GENERAL),11,11,h_conn_session);	// General Section (Session)
			for(int i = 0; i<5; i++) conn_sg[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hconn_sg);
			hconn_su= stattree.InsertItem(GetResString(IDS_PW_CON_UPLBL),6,6,h_conn_session);		// Uploads Section (Session)
			for(int i = 0; i<4; i++) conn_su[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hconn_su);
			hconn_sd= stattree.InsertItem(GetResString(IDS_DOWNLOAD),7,7,h_conn_session);			// Downloads Section (Session)
			for(int i = 0; i<4; i++) conn_sd[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hconn_sd);
		// connection: cumulative
		h_conn_total= stattree.InsertItem(GetResString(IDS_STATS_CUMULATIVE),9,9,h_connection);	// Cumulative Section (Connection)
			hconn_tg= stattree.InsertItem(GetResString(IDS_STATS_GENERAL),11,11,h_conn_total);		// General (Total)
			for(int i = 0; i<4; i++) conn_tg[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hconn_tg);
			hconn_tu= stattree.InsertItem(GetResString(IDS_PW_CON_UPLBL),6,6,h_conn_total);			// Uploads (Total)
			for(int i = 0; i<3; i++) conn_tu[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hconn_tu);
			hconn_td= stattree.InsertItem(GetResString(IDS_DOWNLOAD),7,7,h_conn_total);				// Downloads (Total)
			for(int i = 0; i<3; i++) conn_td[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hconn_td);

	// time section
	h_time = stattree.InsertItem(GetResString(IDS_STATS_TIMESTATS),12,12);					// Time Statistics Section
	for(int i = 0; i<2; i++) tvitime[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), h_time);
		// time: session
		htime_s = stattree.InsertItem(GetResString(IDS_STATS_SESSION),8,8,h_time);				// Session Section (Time)
			for(int i = 0; i<4; i++) tvitime_s[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), htime_s);
			for(int i = 0; i<2; i++) tvitime_st[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), tvitime_s[1]);
		//time: cumulative
		htime_t = stattree.InsertItem(GetResString(IDS_STATS_CUMULATIVE),9,9,h_time);			// Cumulative Section (Time)
			for(int i = 0; i<3; i++) tvitime_t[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), htime_t);
			for(int i = 0; i<2; i++) tvitime_tt[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), tvitime_t[1]);

		htime_aap = stattree.InsertItem(GetResString(IDS_STATS_AVGANDPROJ),13,13,h_time);		// Projected Averages Section
			time_aaph[0] = stattree.InsertItem(GetResString(IDS_STATS_DAYLY),14,14,htime_aap);			// Daily Section
			time_aaph[1] = stattree.InsertItem(GetResString(IDS_STATS_MONTHLY),15,15,htime_aap);	// Monthly Section
			time_aaph[2] = stattree.InsertItem(GetResString(IDS_STATS_YEARLY),16,16,htime_aap);		// Yearly Section
			for(int x = 0; x<3; x++)
			{
				time_aap_hup[x] = stattree.InsertItem(GetResString(IDS_TW_UPLOADS),6,6,time_aaph[x]);	// Upload Section
				for(int i = 0; i<3; i++) time_aap_up[x][i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),time_aap_hup[x]);

				time_aap_up_hd[x][0] = stattree.InsertItem(GetResString(IDS_CLIENTS),time_aap_up[x][0]);							// Clients Section
				for(int i = 0; i<(SO_LAST-1); i++) time_aap_up_dc[x][i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), time_aap_up_hd[x][0]);
				time_aap_up_hd[x][1] = stattree.InsertItem(GetResString(IDS_PORT),time_aap_up[x][0]);								// Ports Section
				for(int i = 0; i<2; i++) time_aap_up_dp[x][i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), time_aap_up_hd[x][1]);
				time_aap_up_hd[x][2] = stattree.InsertItem(GetResString(IDS_STATS_DATASOURCE),time_aap_up[x][0]);					// Data Source Section
				for(int i = 0; i<2; i++) time_aap_up_ds[x][i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), time_aap_up_hd[x][2]);
				for(int i = 0; i<2; i++) time_aap_up_s[x][i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), time_aap_up[x][1]);
				for(int i = 0; i<4; i++) time_aap_up_oh[x][i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), time_aap_up[x][2]);

				time_aap_hdown[x] = stattree.InsertItem(GetResString(IDS_TW_DOWNLOADS),7,7,time_aaph[x]);// Download Section
				for(int i = 0; i<7; i++) time_aap_down[x][i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),time_aap_hdown[x]);
				time_aap_down_hd[x][0] = stattree.InsertItem(GetResString(IDS_CLIENTS),time_aap_down[x][0]);							// Clients Section
				for(int i = 0; i<(SO_LAST-1); i++) time_aap_down_dc[x][i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), time_aap_down_hd[x][0]);
				time_aap_down_hd[x][1] = stattree.InsertItem(GetResString(IDS_PORT),time_aap_down[x][0]);								// Ports Section
				for(int i = 0; i<2; i++) time_aap_down_dp[x][i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), time_aap_down_hd[x][1]);
				for(int i = 0; i<2; i++) time_aap_down_s[x][i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), time_aap_down[x][2]);
				for(int i = 0; i<4; i++) time_aap_down_oh[x][i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), time_aap_down[x][6]);
			}

	//client section
	h_clients = stattree.InsertItem(GetResString(IDS_CLIENTS),3,3);					// Clients Section
		hcliconnected = stattree.InsertItem(GetResString(IDS_STATS_ONLISTCLIENTS),h_clients);	// Connected Section
			clisoft[0] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hcliconnected /*hclisoft*/);
				hclisoftMODs = stattree.InsertItem(GetResString(IDS_STATS_CLIENT_MODS), clisoft[0] /*hclisoft*/);	// MODs Section
				for (int im = 0; im<8; im++)
				{
					clisoftMODs[im] = NULL; m_nMODs[im] = 0;
				}
			for (int i = 1; i<(SO_LAST-1); i++) clisoft[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hcliconnected /*hclisoft*/);
			for (int i = 0; i<(SO_LAST-1); i++)
			{
				cli_versions_other[i] = NULL; for (int j=0; j<4;j++) cli_versions[i][j] = NULL;
			}
			for(int i = 0; i<6; i++) cligen[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), h_clients);	// general clients stats
		hFiltered = stattree.InsertItem(GetResString(IDS_STATS_FILTEREDCLIENTS),h_clients);	// subsections: filtered
			for(int i = 0; i<3; i++) hFilteredItems[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hFiltered);
		hUnfairAction = stattree.InsertItem(GetResString(IDS_STATS_UNFAIR_ACTIONS),h_clients);	// subsections: Unfair action
			for(int i = 0; i<4; i++) hUnfairActionItems[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hUnfairAction);
		hCountries = stattree.InsertItem(GetResString(IDS_COUNTRIES),h_clients);	// Countries Section			

	//server section
	h_servers = stattree.InsertItem(GetResString(IDS_FSTAT_SERVERS),4,4);					// Servers section
		for(int i = 0; i<7; i++) srv[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), h_servers);		// Servers Items
		for(int i = 0; i<3; i++) srv_w[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), srv[0]);	// Working Servers Items
		hsrv_records = stattree.InsertItem(GetResString(IDS_STATS_RECORDS),10,10,h_servers);	// Servers Records Section
		for(int i = 0; i<3; i++) srv_r[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hsrv_records);	// Record Items

	// shared files
	h_shared = stattree.InsertItem( GetResString(IDS_SHAREDFILES),5,5 );					// Shared Files Section
		for(int i = 0; i<4; i++) shar[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), h_shared);
		hshar_records= stattree.InsertItem(GetResString(IDS_STATS_RECORDS),10,10,h_shared);		// Shared Records Section
		for(int i = 0; i<4; i++) shar_r[i] = stattree.InsertItem(GetResString(IDS_FSTAT_WAITING), hshar_records);

	// Make section headers bold in order to make the tree easier to view at a glance.
	stattree.SetItemState(h_transfer, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(h_connection, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(h_time, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(htime_s, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(htime_t, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(htime_aap, TVIS_BOLD, TVIS_BOLD);
	for(int i = 0; i<3; i++)
	{
		stattree.SetItemState(time_aaph[i], TVIS_BOLD, TVIS_BOLD);
		stattree.SetItemState(time_aap_hup[i], TVIS_BOLD, TVIS_BOLD);
		stattree.SetItemState(time_aap_hdown[i], TVIS_BOLD, TVIS_BOLD);
	}
	stattree.SetItemState(h_clients, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(h_servers, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(h_shared, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(h_upload, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(h_download, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(h_up_session, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(h_up_total, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(h_down_session, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(h_down_total, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(h_conn_session, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(h_conn_total, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(hsrv_records, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(hshar_records, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(hconn_sg, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(hconn_su, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(hconn_sd, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(hconn_tg, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(hconn_tu, TVIS_BOLD, TVIS_BOLD);
	stattree.SetItemState(hconn_td, TVIS_BOLD, TVIS_BOLD);

	// Expand our purdy new tree...
	CString sTreeMask;
	sTreeMask = g_eMuleApp.m_pGlobPrefs->GetExpandedTreeItems();
	if (sTreeMask.IsEmpty())
		sTreeMask = "111000000100000110000010000011110000010010";
	stattree.ApplyExpandedMask(sTreeMask);

	// Select the top item so that the tree is not scrolled to the bottom when first viewed.
	stattree.SelectItem(h_transfer);
	stattree.Init();

	// -khaos--+++>  Initialize our client version counts
	for (uint32 i = 0; i < 5; i++) cli_lastCount[i] = 0;

	// End Tree Setup
	EMULE_CATCH

	buffer.Empty();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CStatisticsDlg::UpdateActConScale()
{
	EMULE_TRY

	int iStatYGrids=int((g_eMuleApp.m_pGlobPrefs->GetStatsMax()/10.0)+0.1)-1;
	if (iStatYGrids>10)
		iStatYGrids=int((g_eMuleApp.m_pGlobPrefs->GetStatsMax()/50.0)+0.1)-1;
	m_Statistics.m_nYGrids=iStatYGrids;

	m_Statistics.SetRanges(0, g_eMuleApp.m_pGlobPrefs->GetStatsMax());

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CStatisticsDlg::ShowInterval()
{
	if (!g_eMuleApp.m_pdlgEmule->IsRunning()) return;

	EMULE_TRY

	EnableWindow(FALSE);

	if(!m_DownloadOMeter.GetSafeHwnd() || !m_UploadOMeter.GetSafeHwnd())
		return;

	CRect r;
	m_DownloadOMeter.GetPlotRect(r);
	int shownSecs = r.Width() * g_eMuleApp.m_pGlobPrefs->GetTrafficOMeterInterval();


	if(g_eMuleApp.m_pGlobPrefs->GetTrafficOMeterInterval()==0)
	{
		m_DownloadOMeter.SetXUnits(GetResString(IDS_STOPPED));
		m_UploadOMeter.SetXUnits(GetResString(IDS_STOPPED));
	}
	else
	{
		CString buffer = CastSecondsToHM(shownSecs);
		m_UploadOMeter.SetXUnits(buffer);
		m_DownloadOMeter.SetXUnits(buffer);
	}

	UpdateData(FALSE);
	EnableWindow(TRUE);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CStatisticsDlg::SetARange(bool SetDownload,int maxValue)
{
	EMULE_TRY

	if (SetDownload)
	{
		int iMaxDlGraph = maxValue;
		iMaxDlGraph = int((iMaxDlGraph/10.0)+0.99)*10;
		m_DownloadOMeter.m_nYGrids=int(iMaxDlGraph/10)-1;
		m_DownloadOMeter.SetRange(0, iMaxDlGraph, 0);
		m_DownloadOMeter.SetRange(0, iMaxDlGraph, 1);
		m_DownloadOMeter.SetRange(0, iMaxDlGraph, 2);
	}
	else
	{
		int iMaxUlGraph = maxValue;
		iMaxUlGraph = int((iMaxUlGraph/4.0)+0.99)*4;
		m_UploadOMeter.m_nYGrids=int(iMaxUlGraph/2)-1;
		m_UploadOMeter.SetRange(0, iMaxUlGraph, 0);
		m_UploadOMeter.SetRange(0, iMaxUlGraph, 1);
		m_UploadOMeter.SetRange(0, iMaxUlGraph, 2);
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CStatisticsDlg::OnSize(UINT nType, int cx, int cy)
{
	CResizableDialog::OnSize(nType, cx, cy);
	if ( (cx>0 && cy>0) && (cx!=m_oldcx && cy!=m_oldcy) )
	{
		m_oldcx=cx;
		m_oldcy=cy;
		ShowInterval();
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CStatisticsDlg::OnShowWindow(BOOL bShow,UINT nStatus)
{
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
double CStatisticsDlg::GetAvgDownloadRate(int averageType)
{
	EMULE_TRY

	//check initial state
	if (g_eMuleApp.stat_transferStarttime==0)
		return 0.0f;

	if (averageType==AVG_SESSION)
	{
		DWORD dwRunTime_MS = ::GetTickCount() - g_eMuleApp.stat_transferStarttime;

		//Cax2 - stops the sudden session upload average 'jump' at the beginning.
		if (dwRunTime_MS < 5000)
			return 0;
		//eklmn: calculation of mean value only with one division allows us to get better result
		return ((double)g_eMuleApp.stat_sessionReceivedBytes)/((double) dwRunTime_MS * 1.024);
	}
	else
	{
		if (downrateHistory.empty())
			return 0;
		//Cax2 - we could use that formula... but it's faster if we compute that ratio beforehand,
		//Cax2 - & more accurate if we use the actual data we have now instead of the front of the list.
		return ((double)(g_eMuleApp.stat_sessionReceivedBytes - downrateHistory.back()))/((double)(::GetTickCount() - timeHistory.back())*1.024);
	}

	EMULE_CATCH

	return 0.0f;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
double CStatisticsDlg::GetAvgUploadRate(int averageType)
{
	EMULE_TRY

	//check initial state
	if (g_eMuleApp.stat_transferStarttime==0)
		return 0.0f;

	if (averageType == AVG_SESSION)
	{
		DWORD dwRunTime_MS = ::GetTickCount() - g_eMuleApp.stat_transferStarttime;

		//Cax2 - stops the sudden session upload average 'jump' at the beginning.
		if (dwRunTime_MS < 5000)
			return 0;
		//eklmn: calculation of mean value only with one division allows us to get better result
		return ((double)g_eMuleApp.stat_sessionSentBytes)/((double) dwRunTime_MS * 1.024);
	}
	else
	{
		if (uprateHistory.empty())
			return 0.0f;
		//Cax2 - precomputed ratio. see above
		return ((double)(g_eMuleApp.stat_sessionSentBytes - uprateHistory.back()))/((double)(::GetTickCount() - timeHistory.back())*1.024);
	}

	EMULE_CATCH

	return 0.0f;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CStatisticsDlg::RecordRate()
{
	EMULE_TRY

	if (g_eMuleApp.stat_transferStarttime==0)
		return;

	DWORD tickNow = ::GetTickCount();

	// Cax 2: save every 10th of the statsaverageminutes (no need to be more accurate...)
	// check time has passed since we updated the list last
	DWORD nUpdateTime = g_eMuleApp.m_pGlobPrefs->GetStatsAverageMinutes()*60*100;		//A 10th of the average interval
	if (tickNow - timeHistory.front() < nUpdateTime)
		return;

	downrateHistory.push_front(g_eMuleApp.stat_sessionReceivedBytes);
	uprateHistory.push_front(g_eMuleApp.stat_sessionSentBytes);
	timeHistory.push_front(tickNow);

	// limit to maxmins
	nUpdateTime *= 10; //Now we finally get the average interval expressed in ticks!
	while (tickNow-timeHistory.back()>nUpdateTime)		//Cax2 - keep them in sync
	{
		downrateHistory.pop_back();
		uprateHistory.pop_back();
		timeHistory.pop_back();
	}
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CStatisticsDlg::UpdateConnectionsStatus()
{
	EMULE_TRY

	// Can't do anything before OnInitDialog
	if(!m_hWnd)
		return;

#ifdef OLD_SOCKETS_ENABLED
	activeconnections = g_eMuleApp.m_pListenSocket->GetNumOpenSockets(); // netwolf 07.05.03 (moved here from CStatisticsDlg::SetCurrentRate())
	if ( peakconnections < activeconnections )
		peakconnections = activeconnections;
	// -khaos--+++>
	if (peakconnections > g_eMuleApp.m_pGlobPrefs->GetConnPeakConnections())
		g_eMuleApp.m_pGlobPrefs->Add2ConnPeakConnections(peakconnections);
	// <-----khaos-
	if( g_eMuleApp.m_pServerConnect->IsConnected())
	{
		totalconnectionchecks++;
		double percent;
		percent = (static_cast<double>(totalconnectionchecks-1.0)/static_cast<double>(totalconnectionchecks));
		if( percent > 0.99 )
			percent = 0.99;
		averageconnections = (averageconnections*percent) + static_cast<double>(static_cast<double>(activeconnections)*static_cast<double>(1.0-percent));
	}
#endif //OLD_SOCKETS_ENABLED

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
double CStatisticsDlg::GetMaxConPerFiveModifier()
{
//	This is a alpha test.. Will clean up for b version.
	double		dblSpikeSize = 0;

#ifdef OLD_SOCKETS_ENABLED
	dblSpikeSize = g_eMuleApp.m_pListenSocket->GetNumOpenSockets() - averageconnections;
#endif //OLD_SOCKETS_ENABLED
	if (dblSpikeSize < 1.0)
		return 1;

//	MOREVIT - Ok, why not 2.5 * maxPer5 instead of this?
	double		dblSpikeTolerance = 25.0*static_cast<double>(g_eMuleApp.m_pGlobPrefs->GetMaxConPerFive())/10.0;

	if (dblSpikeSize > dblSpikeTolerance)
		return 0;

	double		dblModifier = (1-(dblSpikeSize/dblSpikeTolerance));

	return dblModifier;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CStatisticsDlg::SetCurrentRate(double uploadrate, double downloadrate)
{
	EMULE_TRY

	if (!g_eMuleApp.m_pdlgEmule->IsRunning())
		return;

	// Can't do anything before OnInitDialog
	if(!m_hWnd)
		return;

	double m_dPlotDataUp[ 3 ];
	double m_dPlotDataDown[ 3 ], adPlotDataMore[3];
	uint64	myBigStats[STATS_DL_DATA_INFO];
	uint16	myRateStats[STATS_DL_SOURCES_TYPE];

	// current rate
	m_dPlotDataDown[2]=downloadrate;
	m_dPlotDataUp[2]=uploadrate;

	if (maxDown<downloadrate)
		maxDown=downloadrate;

	// averages
	m_dPlotDataDown[0]=	GetAvgDownloadRate(AVG_SESSION);
	m_dPlotDataUp[0]=	GetAvgUploadRate(AVG_SESSION);

	m_dPlotDataDown[1]=	GetAvgDownloadRate(AVG_TIME);
	m_dPlotDataUp[1]=	GetAvgUploadRate(AVG_TIME);

	// show
	m_DownloadOMeter.AppendPoints(m_dPlotDataDown);
	m_UploadOMeter.AppendPoints(m_dPlotDataUp);

	// get Partialfiles summary

	g_eMuleApp.m_pDownloadQueue->GetDownloadStats(myRateStats, myBigStats);
	if(g_eMuleApp.m_pGlobPrefs->GetGraphRatio() == 255) // 255 magic number for %
		adPlotDataMore[0] = (100*activeconnections/g_eMuleApp.m_pGlobPrefs->GetMaxConnections());
	else
		adPlotDataMore[0] = (activeconnections/g_eMuleApp.m_pGlobPrefs->GetGraphRatio());
	adPlotDataMore[1] = g_eMuleApp.m_pUploadQueue->GetUploadQueueLength();
	adPlotDataMore[2] = myRateStats[1];

	m_Statistics.AppendPoints(adPlotDataMore);

	// m_pWebServer
	UpDown updown;
	updown.upload = uploadrate;
	updown.download = downloadrate;
	updown.connections = activeconnections;	//SyruS / g_eMuleApp.m_pGlobPrefs->GetGraphRatio();
	g_eMuleApp.m_pWebServer->AddStatsLine(updown);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CStatisticsDlg::RepaintMeters()
{
	EMULE_TRY

	EnableWindow(FALSE);

	m_DownloadOMeter.SetBackgroundColor(g_eMuleApp.m_pGlobPrefs->GetStatsColor(0));
	m_DownloadOMeter.SetGridColor(g_eMuleApp.m_pGlobPrefs->GetStatsColor(1));
	m_DownloadOMeter.SetPlotColor( g_eMuleApp.m_pGlobPrefs->GetStatsColor(4) ,0);
	m_DownloadOMeter.SetPlotColor( g_eMuleApp.m_pGlobPrefs->GetStatsColor(3) ,1);
	m_DownloadOMeter.SetPlotColor( g_eMuleApp.m_pGlobPrefs->GetStatsColor(2) ,2);
	m_UploadOMeter.SetBackgroundColor(g_eMuleApp.m_pGlobPrefs->GetStatsColor(0));
	m_UploadOMeter.SetGridColor(g_eMuleApp.m_pGlobPrefs->GetStatsColor(1));
	m_UploadOMeter.SetPlotColor( g_eMuleApp.m_pGlobPrefs->GetStatsColor(7) ,0);
	m_UploadOMeter.SetPlotColor( g_eMuleApp.m_pGlobPrefs->GetStatsColor(6) ,1);
	m_UploadOMeter.SetPlotColor( g_eMuleApp.m_pGlobPrefs->GetStatsColor(5) ,2);
	m_Statistics.SetBackgroundColor(g_eMuleApp.m_pGlobPrefs->GetStatsColor(0));
	m_Statistics.SetGridColor(g_eMuleApp.m_pGlobPrefs->GetStatsColor(1));
	m_Statistics.SetPlotColor( g_eMuleApp.m_pGlobPrefs->GetStatsColor(8),0);
	m_Statistics.SetPlotColor( g_eMuleApp.m_pGlobPrefs->GetStatsColor(9),1);
	m_Statistics.SetPlotColor( g_eMuleApp.m_pGlobPrefs->GetStatsColor(10),2);

	if (oldRatio!= g_eMuleApp.m_pGlobPrefs->GetGraphRatio())	//Cax2 - Resize the general connections...
	{
		// xrmb: if either old or new is % we need to invalidate 
		// (maybe not true, but don't have the time to think about this)
		// btw. 255 is still the magic number for %
		if(oldRatio == 255 || g_eMuleApp.m_pGlobPrefs->GetGraphRatio() == 255)
			m_Statistics.Invalidate();
		else
			m_Statistics.ReSizePlot(0,(double)oldRatio/g_eMuleApp.m_pGlobPrefs->GetGraphRatio());
		oldRatio=g_eMuleApp.m_pGlobPrefs->GetGraphRatio();
	}
	//m_Statistics.Invalidate();	// eklmn: why we have to invalidate a stats?!

	SetupLegend( IDC_C0_2, 0 ,1);
	SetupLegend( IDC_C0_3, 1 ,1);
	SetupLegend( IDC_C0,   2 ,1);

	SetupLegend( IDC_C1_2, 0 ,2);
	SetupLegend( IDC_C1_3, 1 ,2);
	SetupLegend( IDC_C1,   2 ,2);

	SetupLegend( IDC_S0,   0 ,3);
	SetupLegend( IDC_S1,   1 ,3);
	SetupLegend( IDC_S3,   2 ,3);

	EnableWindow(TRUE);		//Cax2 show the updated graphs immediately!

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CStatisticsDlg::OnDestroy()
{
	CResizableDialog::OnDestroy();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CStatisticsDlg::SetupLegend( int ResIdx, int ElmtIdx, int legendNr)
{
	EMULE_TRY

	CRect Rect;

	GetDlgItem( ResIdx )->GetWindowRect( Rect );
	ScreenToClient( Rect );

	if (legendNr==1)
	{
		if (!m_Led1[ElmtIdx])
			m_Led1[ElmtIdx].Create(WS_VISIBLE | WS_CHILD, Rect, this);
		m_Led1[ElmtIdx].SetBackgroundColor(m_DownloadOMeter.GetPlotColor(ElmtIdx));
		m_Led1[ElmtIdx].SetFrameColor(RGB(0x00, 0x00, 0x00));
	}
	else if (legendNr==2)
	{
		if (!m_Led2[ElmtIdx])
			m_Led2[ElmtIdx].Create( WS_VISIBLE | WS_CHILD, Rect, this);
		m_Led2[ElmtIdx].SetBackgroundColor(m_UploadOMeter.GetPlotColor(ElmtIdx));
		m_Led2[ElmtIdx].SetFrameColor(RGB(0x00, 0x00, 0x00));
	}
	else if (legendNr==3)
	{
		if (!m_Led3[ElmtIdx])
			m_Led3[ElmtIdx].Create(WS_VISIBLE | WS_CHILD, Rect, this);
		m_Led3[ElmtIdx].SetBackgroundColor(m_Statistics.GetPlotColor(ElmtIdx));
		m_Led3[ElmtIdx].SetFrameColor(RGB(0x00, 0x00, 0x00));
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CString CStatisticsDlg::GetMODType (uint16 index)
{
	EMULE_TRY

	CString sMODName;

	switch (index)
	{
		case 0:
			sMODName = "Plus";
			break;
		case 1:
			sMODName = "sivka";
			break;
		case 2:
			sMODName = "LSD";
			break;
		case 3:
			sMODName = "The Black Hand";
			break;
		case 4:
			sMODName = "Morph";
			break;
		case 5:
			sMODName = "Pawcio";
			break;
		case 6:
			sMODName = "LH";
			break;
		case 7:
			sMODName = GetResString(IDS_STATS_OTHERS);
			break;
		default:
			sMODName = "";
	};
	return sMODName;

	EMULE_CATCH
	return "";
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CString CStatisticsDlg::GetUpEndReason(EnumEndTransferSession index)
{
	switch (index)
	{
		case ETS_TIMEOUT:
			return GetResString(IDS_STATS_UL_SESSION_T);
		case ETS_DISCONNECT:
			return GetResString(IDS_STATS_UL_SESSION_D);
		case ETS_BAN:
			return GetResString(IDS_STATS_UL_SESSION_B);
		case ETS_CANCELED:
			return GetResString(IDS_STATS_UL_SESSION_C);
		case ETS_END_OF_DOWNLOAD:
			return GetResString(IDS_STATS_UL_SESSION_ED);
		case ETS_FILE_ERROR:
			return GetResString(IDS_STATS_UL_SESSION_FE);
		case ETS_BLOCKED_CHUNK:
			return GetResString(IDS_STATS_UL_SESSION_BC);
		default:
			return "";
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

